## Collection of recent research papers on Deep Learning, Machine Learning application


Research Papers related with Pytorch, Tensorflow implementations.


### Vision


1. Towards Stabilizing Batch Statistics in Backward Propagation of Batch Normalization 
Junjie Yan, Ruosi Wan, Xiangyu Zhang, Wei Zhang, Yichen Wei, Jian Sun
[Paper](https://openreview.net/pdf?id=SkgGjRVKDS)  [code](https://github.com/megvii-model/MABN)

2. Fast Neural Network Adaptation via Parameter Remapping and Architecture Search 
Jiemin Fang*, Yuzhu Sun*, Kangjian Peng*, Qian Zhang, Yuan Li, Wenyu Liu, Xinggang Wang
[papepr](https://openreview.net/pdf?id=rklTmyBKPH)  [code](https://github.com/JaminFong/FNA)

3. Certified Defenses for Adversarial Patches 
Ping-yeh Chiang*, Renkun Ni*, Ahmed Abdelkader, Chen Zhu, Christoph Studor, Tom Goldstein [paper](https://openreview.net/pdf?id=HyeaSkrYPH) [code](https://github.com/Ping-C/certifiedpatchdefense)

4. Adaptively Connected Neural Networks. 
Guangrun Wang, Keze Wang, Liang Lin [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Wang_Adaptively_Connected_Neural_Networks_CVPR_2019_paper.pdf) [code](https://github.com/wanggrun/Adaptively-Connected-Neural-Networks)

5. Tracking by Animation: Unsupervised Learning of Multi-Object Attentive Trackers. 
Zhen He, Jian Li, Daxue Liu, Hangen He, David Barber [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/He_Tracking_by_Animation_Unsupervised_Learning_of_Multi-Object_Attentive_Trackers_CVPR_2019_paper.pdf) [code](https://github.com/zhen-he/tracking-by-animation)

6. EDVR: Video Restoration With Enhanced Deformable Convolutional Networks. 
Xintao Wang, Kelvin C. K. Chan, Ke Yu, Chao Dong, Chen Change Loy
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPRW_2019/papers/NTIRE/Wang_EDVR_Video_Restoration_With_Enhanced_Deformable_Convolutional_Networks_CVPRW_2019_paper.pdf) [code](https://github.com/xinntao/EDVR)

7. LiveBot: Generating Live Video Comments Based on Visual and Textual Contexts. 
Shuming Ma, Lei Cui, Damai Dai, Furu Wei, Xu Sun
2019 (modified: 03 Mar 2020) [paper](https://aaai.org/ojs/index.php/AAAI/article/view/4656/4534) [code](https://github.com/lancopku/livebot)

8. A Hybrid Method for Tracking of Objects by UAVs. 
Hasan Saribas, Bedirhan Uzun, Burak Benligiray, Onur Eker, Hakan Cevikalp
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPRW_2019/papers/UAVision/Saribas_A_Hybrid_Method_for_Tracking_of_Objects_by_UAVs_CVPRW_2019_paper.pdf) [code](https://github.com/bdrhn9/hybrid-tracker)

9. DeepCO3: Deep Instance Co-Segmentation by Co-Peak Search and Co-Saliency Detection. 
Kuang-Jui Hsu, Yen-Yu Lin, Yung-Yu Chuang
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Hsu_DeepCO3_Deep_Instance_Co-Segmentation_by_Co-Peak_Search_and_Co-Saliency_Detection_CVPR_2019_paper.pdf) [code](https://github.com/KuangJuiHsu/DeepCO3/)

10. Art2Real: Unfolding the Reality of Artworks via Semantically-Aware Image-To-Image Translation. 
Matteo Tomei, Marcella Cornia, Lorenzo Baraldi, Rita Cucchiara
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Tomei_Art2Real_Unfolding_the_Reality_of_Artworks_via_Semantically-Aware_Image-To-Image_Translation_CVPR_2019_paper.pdf) [code](https://github.com/aimagelab/art2real)

11. ELASTIC: Improving CNNs With Dynamic Scaling Policies. 
Huiyu Wang, Aniruddha Kembhavi, Ali Farhadi, Alan L. Yuille, Mohammad Rastegari
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Wang_ELASTIC_Improving_CNNs_With_Dynamic_Scaling_Policies_CVPR_2019_paper.pdf) [code](https://github.com/allenai/elastic)

12. Hybrid Attention-Based Prototypical Networks for Noisy Few-Shot Relation Classification. 
Tianyu Gao, Xu Han, Zhiyuan Liu, Maosong Sun
2019 (modified: 03 Mar 2020) [paper](https://www.aaai.org/ojs/index.php/AAAI/article/view/4604/4482) [code](https://github.com/thunlp/)

13. Recursive Visual Attention in Visual Dialog. 
Yulei Niu, Hanwang Zhang, Manli Zhang, Jianhong Zhang, Zhiwu Lu, Ji-Rong Wen
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Niu_Recursive_Visual_Attention_in_Visual_Dialog_CVPR_2019_paper.pdf) [code](https://github.com/yuleiniu/rva)

14. Synthesis of High-Quality Visible Faces from Polarimetric Thermal Faces using Generative Adversarial Networks. 
He Zhang, Benjamin S. Riggan, Shuowen Hu, Nathaniel J. Short, Vishal M. Patel
2019 (modified: 03 Mar 2020) [paper](https://link.springer.com/content/pdf/10.1007/s11263-019-01175-3.pdf)
[code](https://github.com/hezhangsprinter)

15. MnasNet: Platform-Aware Neural Architecture Search for Mobile. 
Mingxing Tan, Bo Chen, Ruoming Pang, Vijay Vasudevan, Mark Sandler, Andrew Howard, Quoc V. Le
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Tan_MnasNet_Platform-Aware_Neural_Architecture_Search_for_Mobile_CVPR_2019_paper.pdf) [code](https://github.com/tensorflow/tpu/tree/master/models/official/mnasnet)

16. Auto-Encoding Scene Graphs for Image Captioning. 
Xu Yang, Kaihua Tang, Hanwang Zhang, Jianfei Cai
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Yang_Auto-Encoding_Scene_Graphs_for_Image_Captioning_CVPR_2019_paper.pdf) [code](https://github.com/yangxuntu/SGAE)

17. Visualizing the Decision-making Process in Deep Neural Decision Forest. 
Shichao Li, Kwang-Ting Cheng
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPRW_2019/papers/Explainable%20AI/Li_Visualizing_the_Decision-making_Process_in_Deep_Neural_Decision_Forest_CVPRW_2019_paper.pdf) [sode](https://github.com/Nicholasli1995/)

18. Holistic CNN Compression via Low-Rank Decomposition with Knowledge Transfer. 
Shaohui Lin, Rongrong Ji, Chao Chen, Dacheng Tao, Jiebo Luo
2019 (modified: 03 Mar 2020) [paper](https://ieeexplore.ieee.org/document/8478366) [code](https://github.com/ShaohuiLin/LRDKT)

19. PointNetLK: Robust & Efficient Point Cloud Registration Using PointNet. 
Yasuhiro Aoki, Hunter Goforth, Rangaprasad Arun Srivatsan, Simon Lucey
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Aoki_PointNetLK_Robust__Efficient_Point_Cloud_Registration_Using_PointNet_CVPR_2019_paper.pdf) [code](https://github.com/hmgoforth/PointNetLK)

20. Learning to Parse Wireframes in Images of Man-Made Environments 
Kun Huang, Yifan Wang, Zihan Zhou, Tianjiao Ding, Shenghua Gao, Yi Ma
2018 (modified: 25 Feb 2020) [paper](http://openaccess.thecvf.com/content_cvpr_2018/papers/Huang_Learning_to_Parse_CVPR_2018_paper.pdf) [code](https://github.com/huangkuns/wireframe)

21. Deep Model Transferability from Attribution Maps 
Jie Song, Yixin Chen, Xinchao Wang, Chengchao Shen, Mingli Song
25 Feb 2020 [paper](http://papers.nips.cc/paper/8849-deep-model-transferability-from-attribution-maps.pdf) [code](https://github.com/zju-vipa/)

22. [RE] Gate Decorator: Global Filter Pruning Method for Accelerating Deep Convolutional Neural Networks 
Xueqing Zhao, Jinsong Zhang, Hao Sun
29 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=hR_leftqaM)
[code](https://github.com/youzhonghui/gate-decorator-pruning/blob/b95f86a7d921432e2a149151137addd005e8e836/run/vgg16/prune.json#L26))

23. Direction Concentration Learning: Enhancing Congruency in Machine Learning  
Yan Luo, Yongkang Wong, Mohan Kankanhalli, Qi Zhao
12 Feb 2020[paper](https://openreview.net/pdf?id=Bp2Q4BpwdN) [code](https://github.com/luoyan407/congruency)

24. Deformable Convolutional Networks 
Jifeng Dai, Haozhi Qi, Yuwen Xiong, Yi Li, Guodong Zhang, Han Hu, Yichen Wei
2017 (modified: 12 Feb 2020) [paper](https://ieeexplore.ieee.org/document/8237351) [code](https://github.com/msracver/Deformable-ConvNets)

25. Improving Visual Relation Detection using Depth Maps 
Sahand Sharifzadeh, Sina Moayed Baharlou, Max Berrendorf, Rajat Koner, Volker Tresp
26 Sep 2019 (modified: 24 Dec 2019)  [paper](https://openreview.net/pdf?id=HkxcUxrFPS) [code](https://github.com/Sina-Baharlou/Depth-VRD)

### Reinforcement learning
1. Deep Reinforcement Learning for Organ Localization in CT 
Anonymous 25 Jan 2020 (modified: 11 Feb 2020) [paper](https://openreview.net/pdf?id=0vDeD2UD0S) [code](https://github.com/superxuang/caffe_3d_faster_rcnn/issues)

2. Playing Text-Adventure Games with Graph-Based Deep Reinforcement Learning 
Prithviraj Ammanabrolu, Mark Riedl
2019 (modified: 03 Mar 2020)  [paper](https://www.aclweb.org/anthology/N19-1358.pdf) [code](https://github.com/rajammanabrolu/KG-DQN)

3. EMI: Exploration with Mutual Information 
Hyoungseok Kim, Jaekyeom Kim, Yeonwoo Jeong, Sergey Levine, Hyun Oh Song
2019 (modified: 03 Mar 2020) [paper](http://proceedings.mlr.press/v97/kim19a/kim19a.pdf) [supporting-document](http://proceedings.mlr.press/v97/kim19a/kim19a-supp.pdf) [code](https://github.com/snu-mllab/EMI)

4. Fast Neural Architecture Search of Compact Semantic Segmentation Models via Auxiliary Cells. 
Vladimir Nekrasov, Hao Chen, Chunhua Shen, Ian D. Reid
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Nekrasov_Fast_Neural_Architecture_Search_of_Compact_Semantic_Segmentation_Models_via_CVPR_2019_paper.pdf) [code](https://github.com/drsleep/nas-segm-pytorch)

5. DAC Replication Report 
Yan Huang, Cancan Huang, Zhe Hu, Zezhi Wang, Ziyao Huang, Yichen Chai
02 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=rkgLDa5zpr) [code](https://github.com/DAC-Prime/supreme-waffle/blob/master/dac/ppoc.py)

6. Reproducing “Towards Interpretable ReinforcementLearning Using Attention Augmented Agents” 
Charles Lovering, Sam Lobel, Denizalp Goktas, Kweku Kwegyir-Aggrey, Albert Webson
02 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=BJgtDa9GaH) [code](https://github.com/cjlovering/interpretable-reinforcement-learning-using-attention)

7. DPO Reproducibility Challenge Report 
Jiuyang Bai, Gregory Cho, Linlin Liu, Xingchi (Miles) Yan, Liu Yang
02 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=rkgbDp5z6H) [code](https://github.com/gwbcho/dpo-replication)

8. [Re] A Family of Robust Stochastic Operators for Reinforcement Learning 
Haoze Zhang, Lu Shao, Joseph Kijewski, Ishaan Shah, Nishant Kumar, Daniel Glickman
02 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=Bkee_pcM6H) [code](https://github.com/vmayoral/basic_reinforcement_learning)

9. [Replication] A Meta-MDP Approach to Exploration for LifelongReinforcement Learning 
David Cabatingan, Kendrick Cole, Petar Peshev, Natalie Delworth
02 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=rkedITqfpB) [code](https://github.com/dcabatin/Meta-MDP-Reproduction)

10. DPO Reproducibility Challenge Report 
Jiuyang Bai, Gregory Cho, Linlin Liu, Xingchi (Miles) Yan, Liu Yang
02 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=rkgbDp5z6H) [code](https://github.com/gwbcho/dpo-replication)

11. Reproducibility Challenge: Meta-LearningRepresentations for Continual Learning 
Mihaela Georgieva Stoycheva, Sergio Liberman Bronfman, Konstantinos Saitas Zarkias
02 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=H1giraczTS) [code](https://github.com/sergiolib/reproduce_oml)

12. Learning to Discretize: Solving 1D Scalar Conservation Laws via Deep Reinforcement Learning 
Yufei Wang*, Ziju Shen*, Zichao Long, Bin Dong
26 Sep 2019 (modified: 24 Dec 2019) [paper](https://openreview.net/pdf?id=rygBVTVFPB) [code](https://github.com/qwerlanksdf/L2D)



### Tabular

1. Neural Tangents: Fast and Easy Infinite Neural Networks in Python 
Roman Novak, Lechao Xiao, Jiri Hron, Jaehoon Lee, Alexander A. Alemi, Jascha Sohl-Dickstein, Samuel S. Schoenholz
26 Sep 2019 (modified: 11 Mar 2020) [paper](https://openreview.net/pdf?id=SklD9yrFPS) [code](https://github.com/google/neural-tangents)

2. Optimistic Exploration even with a Pessimistic Initialisation 
Tabish Rashid, Bei Peng, Wendelin Boehmer, Shimon Whiteson
26 Sep 2019 (modified: 11 Mar 2020) [paper](https://openreview.net/pdf?id=r1xGP6VYwH) [code](https://github.com/deepmind/bsuite)

3. Exploration in Reinforcement Learning with Deep Covering Options 
Yuu Jinnai, Jee Won Park, Marlos C. Machado, George Konidaris
26 Sep 2019 (modified: 11 Mar 2020) [paper](https://openreview.net/pdf?id=SkeIyaVtwB) [code](https://github.com/haarnoja/sac/blob/master/sac/algos/diayn.py)

4. Optimistic Exploration even with a Pessimistic Initialisation 
Tabish Rashid, Bei Peng, Wendelin Boehmer, Shimon Whiteson
26 Sep 2019 (modified: 11 Mar 2020) [paper](https://openreview.net/pdf?id=r1xGP6VYwH) [code](https://github.com/deepmind/bsuite)

5. Efficient Inference and Exploration for Reinforcement Learning 
Yi Zhu, Jing Dong, Henry Lam
26 Sep 2019 (modified: 24 Dec 2019) [paper](https://openreview.net/pdf?id=rygw7aNYDS) [code](https://github.com/deepmind/bsuite)

6. TabNet: Attentive Interpretable Tabular Learning 
Sercan O. Arik, Tomas Pfister
26 Sep 2019 (modified: 24 Dec 2019) [paper](https://openreview.net/pdf?id=BylRkAEKDH) [code](https://github.com/catboost/benchmarks/tree/master/quality_benchmarks)

7. Regularization Learning Networks: Deep Learning for Tabular Datasets 
Ira Shavitt, Eran Segal
2018 (modified: 17 Jul 2019) [code](http://papers.nips.cc/paper/7412-regularization-learning-networks-deep-learning-for-tabular-datasets.pdf) [code](https://github.com/irashavitt/regularization_learning_networks)

8. TabNN: A Universal Neural Network Solution for Tabular Data 
Guolin Ke, Jia Zhang, Zhenhui Xu, Jiang Bian, Tie-Yan Liu
28 Sep 2018 (modified: 21 Dec 2018) [paper](https://openreview.net/pdf?id=r1eJssCqY7) [code](https://github.com/Microsoft/LightGBM/tree/master/examples)

9. DORA The Explorer: Directed Outreaching Reinforcement Action-Selection 
Lior Fox, Leshem Choshen, Yonatan Loewenstein
16 Feb 2018 (modified: 22 Feb 2018) [paper](https://openreview.net/pdf?id=ry1arUgCW) [code](https://github.com/nathanwang000/deep_exploration_with_E_network )

10. Mask Scoring R-CNN. 
Zhaojin Huang, Lichao Huang, Yongchao Gong, Chang Huang, Xinggang Wang
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Huang_Mask_Scoring_R-CNN_CVPR_2019_paper.pdf) [code](https://github.com/zjhuang22/maskscoring_rcnn)

11. Temporal Anomaly Detection: Calibrating the Surprise. 
Eyal Gutflaish, Aryeh Kontorovich, Sivan Sabato, Ofer Biller, Oded Sofer
2019 (modified: 03 Mar 2020) [paper](https://www.aaai.org/ojs/index.php/AAAI/article/view/4261/4139) [code](https://github.com/eyalgut/TLR)

12. Automatic Fusion of Segmentation and Tracking Labels 
Cem Emre Akbas, Vladimír Ulman, Martin Maska, Florian Jug, Michal Kozubek
2018 (modified: 03 Mar 2020) [paper](https://link.springer.com/chapter/10.1007%2F978-3-030-11024-6_34) [code](https://github.com/xulman/CTC-FijiPlugins)

13. Viewport Proposal CNN for 360deg Video Quality Assessment. 
Chen Li, Mai Xu, Lai Jiang, Shanyi Zhang, Xiaoming Tao
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Li_Viewport_Proposal_CNN_for_360deg_Video_Quality_Assessment_CVPR_2019_paper.pdf) [code](https://github.com/Archer-Tatsu/V-CNN)

### NLU 

1. Incorporating BERT into Neural Machine Translation 
Jinhua Zhu, Yingce Xia, Lijun Wu, Di He, Tao Qin, Wengang Zhou, Houqiang Li, Tieyan Liu
26 Sep 2019 (modified: 11 Mar 2020) [paper](https://openreview.net/pdf?id=Hyl7ygStwB) [code](https://github.com/bert-nmt/bert-nmt)

2. TabFact: A Large-scale Dataset for Table-based Fact Verification 
Wenhu Chen, Hongmin Wang, Jianshu Chen, Yunkai Zhang, Hong Wang, Shiyang Li, Xiyou Zhou, William Yang Wang
26 Sep 2019 (modified: 11 Mar 2020)[paper](https://openreview.net/pdf?id=rkeJRhNYDH) [code](https://github.com/ppasupat/WikiTableQuestions/releases)

3. Probing Emergent Semantics in Predictive Agents via Question Answering 
Abhishek Das, Federico Carnevale, Hamza Merzic, Laura Rimell, Rosalia Schneider, Alden Hung, Josh Abramson, Arun Ahuja, Stephen Clark, Greg Wayne, Felix Hill
26 Sep 2019 (modified: 24 Dec 2019) [paper](https://openreview.net/pdf?id=Bylh2krYPr) [code](https://github.com/deepmind/lab)

4. Reproduction of Baselines on Label-Distribution-Aware Margin Loss and Deferred Reweighting Schedule 
Xinyu He, Hehuimin Cheng, Vitaly Kondulukov
29 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=j5ScDyYXrN) [code](https://github.com/kaidic/LDAM-DRW)

5. [RE] Gate Decorator: Global Filter Pruning Method for Accelerating Deep Convolutional Neural Networks 
Xueqing Zhao, Jinsong Zhang, Hao Sun
29 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=hR_leftqaM) [code](https://github.com/youzhonghui/gate-decorator-pruning/blob/b95f86a7d921432e2a149151137addd005e8e836/run/vgg16/prune.json#L26).

6. Reproducibility of "Augmented Neural ODEs" 
Henry Ho, Luca Zarow, Eric Zimmermann
29 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=O1IJIoWN6p) [code](https://reproducibility-challenge.github.io/neurips2019/task)

7. Sample-Efficient Deep Reinforcement Learning via Episodic Backward Update 
Anonymous
02 Dec 2019 (modified: 08 Jan 2020) [paper](https://openreview.net/pdf?id=Byg5D65GTS) [code](https://github.com/vedasunkara/EBUReproducibilityChallenge/tree/master/graph4+5)

8. [Re] Better transfer learning with inferred successor maps 
Matthew Slivinski, Alana Jaskir, Aaron Traylor
02 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=B1lQvpqzpr) [code](https://github.com/attraylor/reproducing_bsr)

9. Reproducibility Challenge – Generative Modeling by Estimating Gradients of the Data Distribution 
Antonio Matosevic, Eliisabet Hein, Francesco Nuzzo
02 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=SkxCSTqG6H) [data](https://github.com/ermongroup/ncsn)

10. [Re] Exact Combinatorial Optimization with Graph Convolutional Neural Networks 
Audrey-Anne Guindon, Lourdes Crivelli
02 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=r1x-_acfaH) [data](https://github.com/audreyanneguindon/NeurIPS_2019)

11. Reproducing “Towards Interpretable ReinforcementLearning Using Attention Augmented Agents” 
Charles Lovering, Sam Lobel, Denizalp Goktas, Kweku Kwegyir-Aggrey, Albert Webson
02 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=BJgtDa9GaH) [data](https://github.com/cjlovering/interpretable-reinforcement-learning-using-attention)

12. Lookahead Optimizer: k steps forward, 1 step back 
Rithwik Kukunuri, Shivji Bhagat
02 Dec 2019 (modified: 29 Dec 2019) [paper](https://openreview.net/pdf?id=H1lPS65z6B) [code](https://github.com/shv07/lookahead-optimizer)

### NLI 

1. Learning Credal Sum Product Networks 
Anonymous
15 Feb 2020 (modified: 15 Feb 2020) [paper](https://openreview.net/pdf?id=3-Tc21z1Ub) [code](https://github.com/arranger1044/awesome-spn)

2.  Utilizing BERT for Aspect-Based Sentiment Analysis via Constructing Auxiliary Sentence 
Chi Sun, Luyao Huang, Xipeng Qiu
2019 (modified: 03 Mar 2020) [paper](https://www.aclweb.org/anthology/N19-1035.pdf) [code](https://github.com/HSLCY/ABSA-BERT-pair)

3. Auto-Encoding Scene Graphs for Image Captioning. 
Xu Yang, Kaihua Tang, Hanwang Zhang, Jianfei Cai
2019 (modified: 03 Mar 2020) [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Yang_Auto-Encoding_Scene_Graphs_for_Image_Captioning_CVPR_2019_paper.pdf) [code](https://github.com/yangxuntu/SGAE)

4. CGMH: Constrained Sentence Generation by Metropolis-Hastings Sampling. 
Ning Miao, Hao Zhou, Lili Mou, Rui Yan, Lei Li
2019 (modified: 03 Mar 2020) [paper](https://aiide.org/ojs/index.php/AAAI/article/view/4659/4537) [code](https://github.com/NingMiao/CGMH)

5. Massively Multilingual Sentence Embeddings for Zero-Shot Cross-Lingual Transfer and Beyond 
Mikel Artetxe
25 Sep 2019  [paper](https://openreview.net/pdf?id=SJlvUzJtDS) [code](https://github.com/facebookresearch/LASER)

6. Natural Language Inference with External Knowledge 
Qian Chen, Xiaodan Zhu, Zhen-Hua Ling, Diana Inkpen
16 Feb 2018 (modified: 16 Feb 2018)[paper](https://openreview.net/pdf?id=Sy3XxCx0Z) [code](https://github.com/lukecq1231/nli)

7. Goten: GPU-Outsourcing Trusted Execution of Neural Network Training and Prediction 
Lucien K.L. Ng, Sherman S.M. Chow, Anna P.Y. Woo, Donald P. H. Wong, Yongjun Zhao
26 Sep 2019 (modified: 24 Dec 2019) [paper](https://openreview.net/pdf?id=S1xRnxSYwS) [code](https://github.com/goten-team/Goten)

8. PopSGD: Decentralized Stochastic Gradient Descent in the Population Model 
Giorgi Nadiradze, Amirmojtaba Sabour, Aditya Sharma, Ilia Markov, Vitaly Aksenov, Dan Alistarh.
26 Sep 2019 (modified: 24 Dec 2019) [paper](https://openreview.net/pdf?id=BkgqExrYvS) [code](https://github.com/ICLR-PopSGD/PopSGD)

9. ADAPTING PRETRAINED LANGUAGE MODELS FOR LONG DOCUMENT CLASSIFICATION 
Matthew Lyle Olson, Lisa Zhang, Chun-Nam Yu
26 Sep 2019 (modified: 24 Dec 2019) [paper](https://openreview.net/pdf?id=ryxW804FPH) [code](https://github.com/cf-anonymous/long_doc)

10. GResNet: Graph Residual Network for Reviving Deep GNNs from Suspended Animation 
Jiawei Zhang, Lin Meng
26 Sep 2019 (modified: 24 Dec 2019) [paper](https://openreview.net/pdf?id=rygHq6EFwr) [code](https://github.com/anonymous-sourcecode/GResNet)

11. Improving Confident-Classifiers For Out-of-distribution Detection 
Sachin Vernekar, Ashish Gaurav, Vahdat Abdelzad, Taylor Denouden, Rick Salay, Krzysztof Czarnecki
26 Sep 2019 (modified: 24 Dec 2019) [paper](https://openreview.net/pdf?id=rJeIGkBKPS) [code](https://github.com/iclr2020-ai/ICLR2020)

12. Self-Supervised State-Control through Intrinsic Mutual Information Rewards 
Rui Zhao, Volker Tresp, Wei Xu
26 Sep 2019 (modified: 24 Dec 2019) [paper](https://openreview.net/pdf?id=HygSq3VFvH) [code](https://github.com/misc-project/misc)

13. On Iterative Neural Network Pruning, Reinitialization, and the Similarity of Masks 
Michela Paganini, Jessica Forde
26 Sep 2019 (modified: 24 Dec 2019) [paper](https://openreview.net/pdf?id=B1xgQkrYwS) [code](https://github.com/iclr-8dafb2ab/iterative-pruning-reinit)

14. Encoder-Agnostic Adaptation for Conditional Language Generation 
Zachary M. Ziegler, Luke Melas-Kyriazi, Sebastian Gehrmann, Alexander M. Rush
26 Sep 2019 (modified: 24 Dec 2019)[paper](https://openreview.net/pdf?id=B1xq264YvH) [code](https://github.com/anon37234/encoder-agnostic-adaptation)

15. Zero-Shot Out-of-Distribution Detection with Feature Correlations 
Chandramouli S Sastry, Sageev Oore
26 Sep 2019 (modified: 24 Dec 2019) [paper](https://openreview.net/pdf?id=r1g6MCEtwr) [code](https://github.com/zeroshot-ood/ood-detection)

16. Learning Credal Sum Product Networks 
15 Feb 2020 (modified: 15 Feb 2020)[paper](https://openreview.net/pdf?id=3-Tc21z1Ub) [code](https://github.com/arranger1044/awesome-spn)

### Time Series:
#### 2018 
1. PocketFlow: An Automated Framework for Compressing and Accelerating Deep Neural Networks .  Jiaxiang Wu, Yao Zhang, Haoli Bai, Huasong Zhong, Jinlong Hou, Wei Liu, Wenbing Huang, Junzhou Huang [paper](https://openreview.net/pdf?id=H1fWoYhdim ) [code](https://github.com/Tencent/PocketFlow )

2. Deep Recurrent Gaussian Process with Variational Sparse Spectrum Approximation. Roman Föll, Bernard Haasdonk, Markus Hanselmann, Holger Ulmer [paper](https://openreview.net/pdf?id=BkgosiRcKm) [code](https://github.com/RomanFoell/DRGP-VSS ) 

3. Reconstructing evolutionary trajectories of mutations in cancer.  Yulia Rubanova, Ruian Shi, Roujia Li, Jeff Wintersinger, Amit Deshwar, Nil Sahin, Quaid Morris [paper](https://openreview.net/pdf?id=Hkjg7N1Pz ) [code](https://github.com/YuliaRubanova/TrackSig )

4. Combination of Supervised and Reinforcement Learning For Vision-Based Autonomous Control. Dmitry Kangin, Nicolas Pugeault [paper](https://openreview.net/pdf?id=BkeC_J-R-)  [code](https://github.com/openai/baselines )

#### 2019 
1. Reproducibility Challenge: Meta-LearningRepresentations for Continual Learning. Mihaela Georgieva Stoycheva, Sergio Liberman Bronfman, Konstantinos Saitas Zarkias [paper](https://openreview.net/pdf?id=H1giraczTS ) [code](https://github.com/sergiolib/reproduce_oml ) 

2. Reproducibility of "Augmented Neural ODEs". Henry Ho, Luca Zarow, Eric Zimmermann [paper](https://openreview.net/pdf?id=O1IJIoWN6p ) [code](https://github.com/EmilienDupont/augmented-neural-odes/blob/5d3fdefc5eebdb4b6bdfaf74640a5cd50d5484c1/augmented-neural-ode-example.ipynb) 

3. Unsupervised Scalable Representation Learning for Multivariate Time Series. Felix Liljefors, Mohammad Moein Sorkhei, Sofia Broomé [paper](https://openreview.net/pdf?id=HyxQr65z6S ) [code](https://github.com/hfawaz/dl-4-tsc )

4. Neural Tangents: Fast and Easy Infinite Neural Networks in Python.  Roman Novak, Lechao Xiao, Jiri Hron, Jaehoon Lee, Alexander A. Alemi, Jascha Sohl-Dickstein, Samuel S. Schoenholz [paper](https://openreview.net/pdf?id=SklD9yrFPS ) [code](https://github.com/google/neural-tangents )

#### 2020 

1. Optimistic Exploration even with a Pessimistic Initialisation.  Tabish Rashid, Bei Peng, Wendelin Boehmer, Shimon Whiteson [paper](https://openreview.net/pdf?id=r1xGP6VYwH ) [code](https://github.com/deepmind/bsuite )

2. Kotlin∇: A shape-safe DSL for differentiable programming.   Breandan Considine, Michalis Famelis, Liam Paull [paper](https://openreview.net/pdf?id=SkluMSZ08H  ) [code](https://github.com/breandan/kotlingrad)

3. A Wild Bootstrap for Degenerate Kernel Tests .  Kacper Chwialkowski, Dino Sejdinovic, Arthur Gretton [paper](http://papers.nips.cc/paper/5452-a-wild-bootstrap-for-degenerate-kernel-tests.pdf ) [code](https://github.com/kacperChwialkowski/wildBootstrap) 

4. Physiological Signal Embeddings (PHASE) via Interpretable Stacked Models. Hugh Chen, Scott Lundberg, Gabe Erion, Su-In Lee [paper](https://openreview.net/pdf?id=SygInj05Fm ) [code](https://github.com/slundberg/shap )

5. ProbGAN: Towards Probabilistic GAN with Theoretical Guarantees. Hao He, Hao Wang, Guang-He Lee, Yonglong Tian [paper](https://openreview.net/pdf?id=H1l7bnR5Ym  ) [code](https://github.com/mseitzer/pytorch-fid )

6. Interpolation-Prediction Networks for Irregularly Sampled Time Series.  Satya Narayan Shukla, Benjamin Marlin [paper](https://openreview.net/pdf?id=r1efr3C9Ym ) [code](https://github.com/jfutoma/MGP-RNN )

7. Practical lossless compression with latent variables using bits back coding.  James Townsend, Thomas Bird, David Barber [paper](https://openreview.net/pdf?id=ryE98iR5tm  ) [code](https://github.com/bits-back/bits-back  )

8. mFLICA: An R package for Inferring Leadership of Coordination From Time Series. Chainarong Amornbunchornvej. [paper](https://arxiv.org/pdf/2004.06092.pdf )  

9. Extracting correlations in earthquake time series using complex network analysis. Sumanta Kundu, Anca Opris, Yohei Yukutake, and Takahiro Hatano [paper](https://arxiv.org/pdf/2004.05415.pdf  )  

10. Pivotal tests for relevant differences in the second order dynamics of functional time series.  Anne van Delft and Holger Dette [paper](https://arxiv.org/pdf/2004.04724.pdf)    

11. Extreme expectile estimation for heavy-tailed time series.  Simone A. Padoan and Gilles Stupfler [paper](https://arxiv.org/pdf/2004.04078.pdf)    
Bootstrap Prediction Bands for Functional Time Series.  Efstathios Paparoditis, Han Lin Shang [paper](https://arxiv.org/pdf/2004.03971.pdf)  

12. Forecasting count data using time series model with exponentially decaying covariance structure.  Soudeep Deb [paper](https://arxiv.org/pdf/2004.03130.pdf  )

13. TSInsight: A local-global attribution framework for interpretability in time-series data. Shoaib Ahmed Siddiqui, Dominique Mercier, Andreas Dengel, and Sheraz Ahmed [paper](https://arxiv.org/pdf/2004.02958.pdf) 

14. The fractal dimension of music: Melodic contours and time series of pitch.  Maria H. Niklasson1, and Gunnar A. Niklasson [paper](https://arxiv.org/ftp/arxiv/papers/2004/2004.02612.pdf)   

15. ReRe: A Lightweight Real-time Ready-to-Go Anomaly Detection Approach for Time Series. Ming-Chang Lee, Jia-Chun Lin, and Ernst Gunnar Gran [paper](https://arxiv.org/ftp/arxiv/papers/2004/2004.02319.pdf)

16. Modeling Rare Interactions in Time Series Data Through Qualitative Change: Application to Outcome Prediction in Intensive Care Units. Zina Ibrahim, and Honghan Wu, and Richard Dobson  [paper](https://arxiv.org/pdf/2004.01431.pdf )

17. From Fourier to Koopman: Spectral Methods for Long-term Time Series Prediction. Henning Lange, Steven L. Brunton, J. Nathan Kutz [paper](https://arxiv.org/pdf/2004.00574.pdf) 

18. A polynomial time algorithm to compute the connected tree-width of a series-parallel graph∗.  Christophe Paul, Guillaume Mescoff, Dimitrios M. Thilikos [paper](https://arxiv.org/pdf/2004.00547.pdf  )

19. ANOMALY DETECTION IN UNIVARIATE TIME-SERIES: A SURVEY ON THE STATE-OF-THE-ART.  Mohammad Braei, Dr.-Ing. Sebastian Wagner [paper](https://arxiv.org/pdf/2004.00433.pdf )   

20. Discrete orthogonal polynomials as a tool for detection of small anomalies of time series:a case study of GPS final orbits. S. P. Tsarev and A. A. Kytmanov  [paper](https://arxiv.org/pdf/2004.00414.pdf  )  

21. Adversarial Attacks on Multivariate Time Series.  Samuel Harford, Fazle Karim, and Houshang Darabi [paper](https://arxiv.org/pdf/2004.00410.pdf )   

22. Difference Attention Based Error Correction LSTM Model for Time Series Prediction.  Yuxuan Liu, Jiangyong Duan and Juan Meng  [paper](https://arxiv.org/ftp/arxiv/papers/2003/2003.13616.pdf  )

23. A correspondence between temporal correlations in time series, inverse problems, and the Spherical Model. Riccardo Marcaccioli and Giacomo Livan [paper](https://arxiv.org/pdf/2003.12818.pdf  ) 

24. Correlated daily time series and forecasting in the M4 competition. Anti Ingela, Novin Shahroudia, Markus K¨angseppa, Andre T¨attara, Viacheslav Komisarenkoa, Meelis Kulla [paper](https://arxiv.org/pdf/2003.12796.pdf )

25. How the world’s collective attention is being paid to a pandemic:COVID-19 related 1-gram time series for 24 languages on Twitter. Thayer Alshaabi, Michael V. Arnold, Joshua R. Minot, Jane Lydia Adams, David Rushing Dewhurst,  Andrew J. Reagan, Roby Muhamad, Christopher M. Danforth, and Peter Sheridan Dodds [paper](https://arxiv.org/pdf/2003.12614.pdf  )

26. ABBA: Adaptive Brownian bridge-based symbolic aggregation of time series. Steven Elsworth · Stefan Guttel [paper](https://arxiv.org/pdf/2003.12469.pdf ) 

27. Time Series Data Cleaning: From Anomaly Detection to Anomaly Repairing (Technical Report).  Aoqian Zhang, Shaoxu Song, Jianmin Wang, Philip S. Yu [paper](https://arxiv.org/pdf/2003.12396.pdf )

28. WHEN RAMANUJAN MEETS TIME-FREQUENCY ANALYSIS IN COMPLICATED TIME SERIES ANALYSIS. ZIYU CHEN AND HAU-TIENG WU [papepr](https://arxiv.org/pdf/2004.00076.pdf  )

29. Stationarity of Time-Series on Graph: A Generalized Approach via Transition Invariance. Amin Jalili [paper](https://arxiv.org/pdf/2004.00298.pdf )   

30. Financial Time Series Representation Learning.  Philippe Chatigny, Jean-Marc Patenaude, Shengrui Wang [paper](https://arxiv.org/pdf/2003.12194.pdf )   

31. Zero-shot and few-shot time series forecasting with ordinal regression recurrent neural networks. Bernardo Perez Orozco,and Stephen J. Roberts  [paper](https://arxiv.org/pdf/2003.12162.pdf  ) 

32. Scalable Deployment of AI Time-series Models for IoT. Bradley Eck , Francesco Fusco , Robert Gormally , Mark Purcell , Seshu Tirupathi [paper](https://arxiv.org/pdf/2003.12141.pdf )

33. Time series and machine learning to forecast the water quality from satellite data .  Maryam R. Al Shehhi and Abdullah Kaya [paper](https://arxiv.org/ftp/arxiv/papers/2003/2003.11923.pdf  )

34. On Consistency and Sparsity for High-Dimensional Functional Time Series with Application to Autoregressions.  Shaojun Guo and Xinghao Qiao  [paper](https://arxiv.org/pdf/2003.11462.pdf  )

35. Integrating Physiological Time Series and Clinical Notes with Deep Learning for Improved ICU Mortality Prediction.  Satya Narayan Shukla, Benjamin M. Marlin [paper](https://arxiv.org/pdf/2003.11059.pdf ) 

36. A time series method to analyze incidence pattern and estimate reproduction number of COVID-19. Soudeep Deb, Manidipa Majumdar [paper](https://arxiv.org/pdf/2003.10655.pdf  )

37. A Multi-Quantile Regression Time Series Model with Interquantile Lipschitz Regularization for Wind Power Probabilistic Forecasting. Marcelo Ruas, Alexandre Street, Cristiano Fernandes [paper](https://arxiv.org/pdf/2003.09983.pdf )   

38. Drift-Adjusted And Arbitrated Ensemble Framework For Time Series Forecasting. Anirban Chatterjee, Subhadip Paul, Uddipto Dutta, Smaranya Dey  [paper](https://arxiv.org/ftp/arxiv/papers/2003/2003.09311.pdf)    

39. IMPROVING IRREGULARLY SAMPLED TIME SERIES LEARNING WITH DENSE DESCRIPTORS OF TIME.  Rafael T. Sousa, Lucas A. Pereira, Anderson S. Soares [paper](https://arxiv.org/pdf/2003.09291.pdf )   

40. A comparison of Hurst exponent estimators in long-range dependent curve time series.  Han Lin Shang [paper](https://arxiv.org/pdf/2003.08787.pdf )   

41. On neural architectures for astronomical time-series classification.  Sara Jamal and Joshua S. Bloom [paper](https://arxiv.org/pdf/2003.08618.pdf)    

42. Modeling of Multisite Precipitation Occurrences Using Latent Gaussian-based Multivariate Binary Response Time Series. Hsien-Wei Chen [paper](https://arxiv.org/ftp/arxiv/papers/2003/2003.07998.pdf  )

43. Construe: a software solution for the explanation-based interpretation of time series.  T. Teijeiroa, P. F´elixb [paper](https://arxiv.org/pdf/2003.07596.pdf )   

44. Model Monitoring and Dynamic Model Selection in Travel Time-series Forecasting. Rosa Candela, Pietro Michiardi, Maurizio Filippone, and Maria A. Zuluaga [paper](https://arxiv.org/pdf/2003.07268.pdf )  

45. A Persistent Homology Approach to Time Series Classification. Yu-Min Chung, William Cruse, and Austin Lawson [paper](https://arxiv.org/pdf/2003.06462.pdf  )

46. Statistical Inference for High Dimensional Panel Functional Time Series.  Zhou Zhou and Holger Dette [paper](https://arxiv.org/pdf/2003.05968.pdf )   

47. Time Series Forecasting Using LSTM Networks:A Symbolic Approach.  Steven Elsworth and Stefan Guttel [paper](https://arxiv.org/pdf/2003.05672.pdf )   

48. Simulation of long-term time series of solar photovoltaic power: is the ERA5-land reanalysis the next big step?   Luis Ramirez Camargo, Johannes Schmidt [paper](https://arxiv.org/ftp/arxiv/papers/2003/2003.04131.pdf )   

49. A Time Series Approach To Player Churn and Conversion in Videogames.  Ana Fernández del Río, Anna Guitart and África Periánez [paper](https://arxiv.org/pdf/2003.10287.pdf )   

50. FORECASTING IN MULTIVARIATE IRREGULARLY SAMPLED TIME SERIES WITH MISSING VALUES.  Shivam Srivastava, Prithviraj Sen, Berthold Reinwald [paper](https://arxiv.org/pdf/2004.03398.pdf )   


### Self supervised learning
#### 2019
1. UNSUPERVISED FEW-SHOT LEARNING VIA SELFSUPERVISED TRAINING. Zilong Ji, Xiaolong Zou, Tiejun Huang, Si Wu [paper](https://arxiv.org/pdf/1912.12178.pdf  )

2. Multiple Pretext-Task for Self-Supervised Learning via Mixing Multiple Image Transformations. Shin’ya Yamaguchi, Sekitoshi Kanai, Tetsuya Shioda, Shoichiro Takeda [paper](https://arxiv.org/pdf/1912.11603.pdf)    

3. NEURAL OUTLIER REJECTION FOR SELF-SUPERVISED KEYPOINT LEARNING. Jiexiong Tang, Hanme Kim, Vitor Guizilini, Sudeep Pillai, Rares Ambrus [paper](https://arxiv.org/pdf/1912.10615.pdf )   

4. Multimodal Self-Supervised Learning for Medical Image Analysis. Aiham Taleb, Christoph Lippert, Tassilo Klein, and Moin Nabi [papaer](https://arxiv.org/pdf/1912.05396.pdf  )

5. Self-Supervised 3D Keypoint Learning for Ego-motion Estimation. Jiexiong Tang, Rares, Ambrus, Vitor Guizilini, Sudeep Pillai, Hanme Kim, Adrien Gaidon [paper](https://arxiv.org/pdf/1912.03426.pdf )

6. Self-Supervised Visual Terrain Classification from Unsupervised Acoustic Feature Learning.  Jannik Zurn, Wolfram Burgard, and Abhinav Valada  [paper](https://arxiv.org/pdf/1912.03227.pdf )   

7. Self-Supervised Learning of Video-Induced Visual Invariances. Michael Tschannen, Josip Djolonga, Marvin Ritter, Aravindh Mahendran, Xiaohua Zhai, Neil Houlsby, Sylvain Gelly, Mario Lucic [paper](https://arxiv.org/pdf/1912.02783.pdf )   

8. Self-Supervised Learning of Pretext-Invariant Representations.  Ishan Misra, Laurens van der Maaten [paper](https://arxiv.org/pdf/1912.01991.pdf )  

9. Self-Supervised Learning by Cross-Modal Audio-Video Clustering. Humam Alwassel1, Dhruv Mahajan, Lorenzo Torresani, Bernard Ghanem, Du Tran  [paper](https://arxiv.org/pdf/1911.12667.pdf ) 

10. Revisiting Image Aesthetic Assessment via Self-Supervised Feature Learning. Kekai Sheng, Weiming Dong, Menglei Chai, Guohui Wang, Peng Zhou, Feiyue Huang, Bao-Gang Hu, Rongrong Ji, Chongyang Ma [paper](https://arxiv.org/pdf/1911.11419.pdf )   

11. EnAET: Self-Trained Ensemble AutoEncoding Transformations for Semi-Supervised Learning. Xiao Wang, Daisuke Kihara, Jiebo Luo, and Guo-Jun Qi  [paper](https://arxiv.org/pdf/1911.09265.pdf )  

12. AETv2: AutoEncoding Transformations for Self-Supervised Representation Learning by Minimizing Geodesic Distances in Lie Groups. Feng Lin, Haohang Xu, Houqiang Li, Hongkai Xiong, Guo-Jun Qi [paper](https://arxiv.org/pdf/1911.07004.pdf )   

#### 2020

13. Self-supervised Feature Learning by Cross-modality and Cross-view Correspondences.  Longlong Jing, Yucheng Chen, Ling Zhang, Mingyi He, and Yingli Tian [paper](https://arxiv.org/pdf/2004.05749.pdf  )  

14. Temporally Coherent Embeddings for Self-Supervised Video Representation Learning. Joshua Knights, Anthony Vanderkop, Daniel Ward, Olivia, Mackenzie-Ross, and Peyman Moghadam [paper](https://arxiv.org/pdf/2004.02753.pdf )   

15. SelfORE: Self-supervised Relational Feature Learning for Open Relation Extraction.  Xuming Hu, Lijie Wen, Yusong Xu, Chenwei Zhang, Philip S. Yu [paper](https://arxiv.org/pdf/2004.02438.pdf )   

16. Steering Self-Supervised Feature Learning Beyond Local Pixel Statistics.  Simon Jenni, Hailin Jin, Paolo Favaro, University of Bern, Adobe Research [paper](https://arxiv.org/pdf/2004.02331.pdf )   

17. Flow2Stereo: Effective Self-Supervised Learning of Optical Flow and Stereo Matching.  Pengpeng Liu, Irwin King, Michael Lyu, Jia Xu [paper](https://arxiv.org/pdf/2004.02138.pdf)    

18. Exploit Clues from Views: Self-Supervised and Regularized Learning for Multiview Object Recognition.  Chih-Hui Ho, Bo Liu, Tz-Ying Wu, Nuno Vasconcelos [paper](https://arxiv.org/pdf/2003.12735.pdf ) 

19. Self-Supervised Learning for Domain Adaptation on Point-Clouds. Idan Achituve, Haggai Maron, and Gal Chechik [paper](https://arxiv.org/pdf/2003.12641.pdf )   

20. ATTENTION-BASED SELF-SUPERVISED FEATURE LEARNING FOR SECURITY DATA. I-Ta Lee, Manish Marwah, Martin Arlitt [paper](https://arxiv.org/pdf/2003.10639.pdf )   

21. Fast(er) Reconstruction of Shredded Text Documents via Self-Supervised Deep Asymmetric Metric Learning. Thiago M. Paixao, Rodrigo F. Berriel, Maria C. S. Boeres, Alessando L. Koerich, Claudine Badue, Alberto F. De Souza, and Thiago Oliveira-Santos [paper](https://arxiv.org/pdf/2003.10063.pdf )   

22. Cross-domain Self-supervised Learning for Domain Adaptation with Few Source Labels. Donghyun Kim, Kuniaki Saito, Tae-Hyun Oh, Bryan A. Plummer, Stan Sclaroff, and Kate Saenko [paper](https://arxiv.org/pdf/2003.08264.pdf)  

23. Self-Supervised Discovering of Causal Features: Towards Interpretable Reinforcement Learning. Wenjie Shi, Shiji Song, Zhuoyuan Wang, Gao Huang [paper](https://arxiv.org/pdf/2003.07069.pdf  )  

24. Online Self-Supervised Learning for Object Picking: Detecting Optimum Grasping Position using a Metric Learning Approach. Kanata Suzuki, Yasuto Yokota, Yuzi Kanazawa and Tomoyoshi Takebayashi [paper](https://arxiv.org/pdf/2003.03717.pdf ) 

25. Noise Estimation Using Density Estimation for Self-Supervised Multimodal Learning.  Elad Amrani, Rami Ben-Ari, Daniel Rotman, and Alex Bronstein [paper](https://arxiv.org/pdf/2003.03186.pdf )   

26. Self-Supervised Spatio-Temporal Representation Learning Using Variable Playback Speed Prediction. Hyeon Cho, Taehoon Kim, Hyung Jin Chang, and Wonjun Hwang [paper](https://arxiv.org/pdf/2003.02692.pdf  ) 

27. Self-Supervised Graph Representation Learning via Global Context Prediction.  Zhen Peng, Yixiang Dong, Minnan Luo, Xiao-Ming Wu, Qinghua Zheng [paper](https://arxiv.org/pdf/2003.01604.pdf )   

28. Self-Supervised Object-Level Deep Reinforcement Learning. William Agnew, Pedro Domingos [paper](https://arxiv.org/pdf/2003.01384.pdf )

29. A Self-Supervised Learning Approach to Rapid Path Planning for Car-Like Vehicles Maneuvering in Urban Environment.  Piotr Kicki, Tomasz Gawron, and Piotr Skrzypczyski [paper](https://arxiv.org/pdf/2003.00946.pdf  )  

30. A Multi-view Perspective of Self-supervised Learning. Chuanxing Geng, Zhenghao Tan, Songcan Chen [paper](https://arxiv.org/pdf/2003.00877.pdf )   

31. MVP: Unified Motion and Visual Self-Supervised Learning for Large-Scale Robotic Navigation. Marvin Chancan´and Michael Milford [paper](https://arxiv.org/pdf/2003.00667.pdf )   

32. Self-Supervised Viewpoint Learning From Image Collections.  Siva Karthik Mustikovela, Varun Jampani, Shalini De Mello, Sifei Liu, Umar Iqbal, Carsten Rother, Jan Kautz [paper](https://arxiv.org/pdf/2004.01793.pdf)    

33. Deep Active Learning for Biased Datasets via Fisher Kernel Self-Supervision.  Denis Gudovskiy, Alec Hodgkinson, Takuya Yamaguchi, Sotaro Tsukizawa [paper](https://arxiv.org/pdf/2003.00393.pdf ) 

34. SELF-SUPERVISED REPRESENTATION LEARNING FOR ULTRASOUND VIDEO. Jianbo Jiao, Richard Droste, Lior Drukker, Aris T. Papageorghiou, J. Alison Noble [paper](https://arxiv.org/pdf/2003.00105.pdf )   

35. SEMANTICALLY-GUIDED REPRESENTATION LEARNING FOR SELF-SUPERVISED MONOCULAR DEPTH.  Vitor Guizilini, Rui Hou, Jie Li, Rares Ambrus, Adrien Gaidon [paper](https://arxiv.org/pdf/2002.12319.pdf)   

36. Learning a Directional Soft Lane Affordance Model for Road Scenes.  Using Self-Supervision, Robin Karlsson and Erik Sjoberg [paper](https://arxiv.org/pdf/2002.11477.pdf )   

37. Automatic Shortcut Removal for Self-Supervised Representation Learning. Matthias Minderer, Olivier Bachem, Neil Houlsby, Michael Tschannen [paper](https://arxiv.org/pdf/2002.08822.pdf )  

38. BADGR: An Autonomous Self-Supervised Learning-Based Navigation System.  Gregory Kahn, Pieter Abbeel, Sergey Levine [papepr](https://arxiv.org/pdf/2002.05700.pdf )   

39. SELF-SUPERVISED LEARNING FOR AUDIO-VISUAL SPEAKER DIARIZATION.  Yifan Ding, Yong Xu, Shi-Xiong Zhang, Yahuan Cong and Liqiang Wang [paper](https://arxiv.org/pdf/2002.05314.pdf )   

40. SELF-SUPERVISED ECG REPRESENTATION LEARNING FOR EMOTION RECOGNITION.  Pritam Sarkar, Ali Etemad [papepr](https://arxiv.org/pdf/2002.03898.pdf)     
41. Deep Self-Supervised Representation Learning for Free-Hand Sketch.  Peng Xu, Zeyu Song, Qiyue Yin, Yi-Zhe Song [paper](https://arxiv.org/pdf/2002.00867.pdf)    

42. MULTI-TASK SELF-SUPERVISED LEARNING FOR ROBUST SPEECH RECOGNITION.  Mirco Ravanelli, Jianyuan Zhong, Santiago Pascual, Pawel Swietojanski, Joao Monteiro, Jan Trmal, Yoshua Bengio [paper](https://arxiv.org/pdf/2001.09239.pdf)   

43. Curriculum Labeling: Self-paced Pseudo-Labeling for Semi-Supervised Learning. Paola Cascante-Bonilla, Fuwen Tan, Yanjun Qi, Vicente Ordonez [paper](https://arxiv.org/pdf/2001.06001.pdf)    

44. Self-supervised visual feature learning with curriculum.  Vishal Keshav, Fabien Delattre [paper](https://arxiv.org/pdf/2001.05634.pdf )  

45. VISUALLY GUIDED SELF SUPERVISED LEARNING OF SPEECH REPRESENTATIONS. Abhinav Shukla, Konstantinos Vougioukas, Pingchuan Ma, Stavros Petridis, Maja Pantic [paper](https://arxiv.org/pdf/2001.04316.pdf )   

46. Self-Supervised Fast Adaptation for Denoising via Meta-Learning.  Seunghwan Lee, Donghyeon Cho, Jiwon Kim, and Tae Hyun Kim [paper](https://arxiv.org/pdf/2001.02899.pdf )   

47. Few-shot Learning with Multi-scale Self-supervision.  Hongguang Zhang, Philip H. S. Torr, Piotr Koniusz [paper](https://arxiv.org/pdf/2001.01600.pdf )    

48. Robust Self-Supervised Learning of Deterministic Errors in Single-Plane (Monoplanar) and Dual-Plane (Biplanar) X-ray Fluoroscopy. Jacky C.K. Chow, Steven K. Boyd, Derek D. Lichti, Janet L. Ronsky [paper](https://arxiv.org/ftp/arxiv/papers/2001/2001.00686.pdf  ) 

49. Self-Supervised Learning of Generative Spin-Glasses with Normalizing Flows. Gavin S. Hartnett, Masoud Mohseni [paper](https://arxiv.org/pdf/2001.00585.pdf )   

50. Video Cloze Procedure for Self-Supervised Spatio-Temporal Learning. Dezhao Luo, Chang Liu, Yu Zhou, Dongbao Yang, Can Ma, Qixiang Ye, Weiping Wang  [paper](https://arxiv.org/pdf/2001.00294.pdf )   

###  NLP 
#### 2018
1. Baseline: Strong, Extensible, Reproducible, Deep Learning Baselines for NLP.  Daniel Pressel, Brian Lester, Sagnik Ray Choudhury, Matt Barta, Yanjie Zhao, Amy Hemmeter [paper](https://openreview.net/pdf?id=r1xEb7J15Q  ) [code](https://github.com/dpressel/baseline)  

#### 2019

1. Spherical Text Embedding. Yu Meng, Jiaxin Huang, Guangyuan Wang, Chao Zhang, Honglei Zhuang, Lance Kaplan, Jiawei Han [papepr](https://openreview.net/pdf?id=HylBTNBlLB ) [code](https://github.com/yumeng5/Spherical-Text-Embedding )

2. Spherical Text Embedding. Yu Meng, Jiaxin Huang, Guangyuan Wang, Chao Zhang, Honglei Zhuang, Lance Kaplan, Jiawei Han [paper](https://openreview.net/pdf?id=HylBTNBlLB ) [code]https://github.com/yumeng5/Spherical-Text-Embedding)

3. Sampling Bias in Deep Active Classification: An Empirical Study.  Ameya Prabhu, Charles Dognin, Maneesh Singh [paper](https://arxiv.org/pdf/1909.09389.pdf  ) [code](https://github.com/drimpossible/Sampling-Bias-Active-Learning )

4. Named Entity Recognition in Tweets: An Experimental Study.  Alan Ritter, Sam Clark, Mausam, Oren Etzioni [code](https://www.aclweb.org/anthology/D11-1141.pdf ) [code](https://github.com/aritter/twitter_nlp  )

5. Open domain event extraction from twitter.  Alan Ritter, Mausam, Oren Etzioni, Sam Clark [paper](https://dl.acm.org/doi/pdf/10.1145/2339530.2339704?download=true ) [code](https://github.com/aritter/ )

6. An Open-source Framework for Multi-level Semantic Similarity Measurement. Mohammad Taher Pilehvar, Roberto Navigli [paper](http://aclweb.org/anthology/N/N15/N15-3016.pdf ) [code](https://github.com/pilehvar/adw/ )

7. TX-Ray: Quantifying and Explaining Model-Knowledge Transfer in (Un-)Supervised NLP.  Nils Rethmeier and Vageesh Kumar Saxena and Isabelle Augenstein [paper](https://arxiv.org/pdf/1912.00982.pdf ) 

8. Reverse Transfer Learning: Can Word Embeddings Trained for Different NLP Tasks Improve Neural Language Models?  Lyan Verwimp, Jerome R. Bellegarda [paper](https://arxiv.org/pdf/1909.04130.pdf )  

9. Do NLP Models Know Numbers? Probing Numeracy in Embeddings. Eric Wallace, Yizhong Wang, Sujian Li, Sameer Singh, Matt Gardner [paper](https://arxiv.org/pdf/1909.07940.pdf )   

10. AllenNLP Interpret: A Framework for Explaining Predictions of NLP Models. Eric Wallace, Jens Tuyls, Junlin Wang, Sanjay Subramanian, Matt Gardner, Sameer Singh [paper](https://arxiv.org/pdf/1909.09251.pdf ) 

11. ATTENTION INTERPRETABILITY ACROSS NLP TASKS.  Shikhar Vashishth, Shyam Upadhyay, Gaurav Singh Tomar [paper](https://arxiv.org/pdf/1909.11218.pdf)    

12. Efficiency through Auto-Sizing: Notre Dame NLP’s Submission to the WNGT 2019 Efficiency Task. Kenton Murray, Brian DuSell, David Chiang [paper](https://arxiv.org/pdf/1910.07134.pdf ) 

13. NLPExplorer: Exploring the Universe of NLP Papers.  Monarch Parmar, Naman Jain, Pranjali Jain, P Jayakrishna Sahit, Soham Pachpande, Shruti Singh, and Mayank Singh [paper](https://arxiv.org/pdf/1910.07351.pdf )

14. HUBERT UNTANGLES BERT TO IMPROVE TRANSFER ACROSS NLP TASKS. Mehrad Moradshahi, Hamid Palangi, Monica S. Lam, Paul Smolensky, Jianfeng Gao [paper](https://arxiv.org/pdf/1910.12647.pdf )   

15. The State of NLP Literature: A Diachronic Analysis of the ACL Anthology.  Saif M. Mohammad [paper](https://arxiv.org/pdf/1911.03562.pdf)

16. Drug Repurposing for Cancer: An NLP Approach to Identify Low-Cost Therapies.  Shivashankar Subramanian, Ioana Baldini, Sushma Ravichandran, Dmitriy A. Katz-Rogozhnikov, Karthikeyan Natesan Ramamurthy, Prasanna Sattigeri, Kush R. Varshney, Annmarie Wang, Pradeep Mangalath, Laura B. Kleiman [paper](https://arxiv.org/pdf/1911.07819.pdf ) 

17. ERASER: A Benchmark to Evaluate Rationalized NLP Models.  Jay DeYoung, Sarthak Jain, Nazneen Fatema Rajani, Eric Lehman, Caiming Xiong, Richard Socher, and Byron C. Wallace [paper](https://arxiv.org/pdf/1911.03429.pdf ) 

18. UBC-NLP at SemEval-2019 Task 6: Ensemble Learning of Offensive Content With Enhanced Training Data. Arun Rajendran, Chiyu Zhang, Muhammad Abdul-Mageed [paper](https://arxiv.org/pdf/1906.03692.pdf  )  

19. Principled Frameworks for Evaluating Ethics in NLP Systems. Shrimai Prabhumoye, Elijah Mayfield, Alan W Black [paper](https://arxiv.org/pdf/1906.06425.pdf )   

20. When Low Resource NLP Meets Unsupervised Language Model: Meta-pretraining Then Meta-learning for Few-shot Text Classification.  Shumin Deng, Ningyu Zhang, Zhanlin Sun, Jiaoyan Chen, Huajun Chen [paper](https://arxiv.org/pdf/1908.08788.pdf)   

21. Universal Adversarial Triggers for Attacking and Analyzing NLP. Eric Wallace, Shi Feng, Nikhil Kandpal, Matt Gardner, Sameer Singh [paper](https://arxiv.org/pdf/1908.07125.pdf )   

22. What’s Wrong with Hebrew NLP? And How to Make it Right. Reut Tsarfaty, Amit Seker, Shoval Sadde, Stav Klein [paper](https://arxiv.org/pdf/1908.05453.pdf )   

23. Normalyzing Numeronyms - A NLP approach.  Avishek Garain, Sainik Kumar Mahata, Subhabrata Dutta [paper](https://arxiv.org/pdf/1907.13356.pdf )   

24. CFO: A Framework for Building Production NLP Systems. Rishav Chakravarti, Cezar Pendus, Andrzej Sakrajda, Anthony Ferritto, Lin Pan, Michael Glass, Vittorio Castelli, J. William Murdock, Radu Florian, Salim Roukos, Avirup Sil [paper](https://arxiv.org/pdf/1908.06121.pdf )

25. Energy and Policy Considerations for Deep Learning in NLP.  Emma Strubell Ananya Ganesh Andrew McCallum [paper](https://arxiv.org/pdf/1906.02243.pdf )

26. A Just and Comprehensive Strategy for Using NLP to Address Online Abuse.  David Jurgens, Eshwar Chandrasekharan, Libby Hemphill [paper](https://arxiv.org/pdf/1906.01738.pdf)   

27. System Demo for Transfer Learning across Vision and Text using Domain Specific CNN Accelerator for On-Device NLP Applications.  Baohua Sun, Lin Yang, Michael Lin, Wenhan Zhang, Patrick Dong, Charles Young and Jason Dong [paper](https://arxiv.org/pdf/1906.01145.pdf)  

28. Towards Scalable and Reliable Capsule Networks for Challenging NLP Applications.  Wei Zhao, Haiyun Peng, Steffen Eger, Erik Cambria‡ and Min Yang [paper](https://arxiv.org/pdf/1906.02829.pdf )

29. Automatic Generation of System Test Cases from Use Case Specifications: an NLP-based Approach.  Chunhui Wang, Fabrizio Pastore, Arda Goknil, and Lionel C. Briand [paper](https://arxiv.org/pdf/1907.08490.pdf) 

30. You Shall Know a User by the Company It Keeps: Dynamic Representations for Social Media Users in NLP. Marco Del Tredici, Diego Marcheggiani, Sabine Schulte im Walde, Raquel Fernandez [paper](https://arxiv.org/pdf/1909.00412.pdf )   


#### 2020

1. On Evaluation of Adversarial Perturbations for Sequence-to-Sequence Models. Paul Michel, Xian Li, Graham Neubig, Juan Miguel Pino [paper](https://www.aclweb.org/anthology/N19-1314.pdf ) [code](https://github.com/pmichel31415/teapot-nlp  )

2. FLAIR: An Easy-to-Use Framework for State-of-the-Art NLP. Alan Akbik, Tanja Bergmann, Duncan Blythe, Kashif Rasul, Stefan Schweter, Roland Vollgraf [paper](https://www.aclweb.org/anthology/N19-4010.pdf ) [code](https://github.com/flairNLP/flair )

3. Approximating Word Ranking and Negative Sampling for Word Embedding.  Guibing Guo, Shichang Ouyang, Fajie Yuan, Xingwei Wang [paper](https://www.ijcai.org/proceedings/2018/0569.pdf ) [code](https://github.com/ouououououou/OptRank )

4. Improving Neural Fine-Grained Entity Typing With Knowledge Attention. Ji Xin, Yankai Lin, Zhiyuan Liu, Maosong Sun [paper](https://www.aaai.org/ocs/index.php/AAAI/AAAI18/paper/view/16321/16167 ) [code](https://github.com/thunlp/KNET )

5. Language Models as Knowledge Bases?   Fabio Petroni, Tim Rocktaschel, ¨Patrick Lewis, Anton Bakhtin, Yuxiang Wu, Alexander H. Miller, Sebastian Riedel [paper](https://www.aclweb.org/anthology/D19-1250.pdf)  [code](https://github.com/facebookresearch/LAMA ) 

6. Towards Faithfully Interpretable NLP Systems:How should we define and evaluate faithfulness?  Alon Jacovi, Yoav Goldberg [paper](https://arxiv.org/pdf/2004.03685.pdf )   

7. Operationalizing the legal concept of ‘Incitement to Hatred’ as an NLP task.  Frederike Zufall, Huangpan Zhang, Katharina Kloppenborg, Torsten Zesch [paper](https://arxiv.org/pdf/2004.03422.pdf )

8. Orchestrating NLP Services for the Legal Domain.  Julian Moreno-Schneider, Georg Rehm, Elena Montiel-Ponsoda, V´ıctor Rodr´ıguez-Doncel, Artem Revenko, Sotirios Karampatakis, Maria Khvalchik, Christian Sageder, Jorge Gracia, Filippo Maganza [paper](https://arxiv.org/pdf/2003.12900.pdf )   

9. Word2Vec: Optimal Hyper-Parameters and Their Impact on NLP Downstream Tasks.  Tosin P. Adewumi*, Foteini Liwicki & Marcus Liwicki [paper](https://arxiv.org/pdf/2003.11645.pdf)

10. Parsing Thai Social Data: A New Challenge for Thai NLP. Sattaya Singkul, Borirat Khampingyot, Nattasit Maharattamalai, Supawat Taerungruang, Tawunrat Chalothorn [paper](https://arxiv.org/ftp/arxiv/papers/2003/2003.03069.pdf ) 

11. HyperEmbed: Tradeoffs Between Resources and Performance in NLP Tasks with Hyperdimensional Computing enabled Embedding of n-gram Statistics.  Pedro Alonso, Kumar Shridhar, Denis Kleyko, Evgeny Osipov, Marcus Liwicki [paper](https://arxiv.org/pdf/2003.01821.pdf)

12. A Nepali Rule Based Stemmer and its performance on different NLP applications Pravesh Koirala, Aman Shakya [paper](https://arxiv.org/ftp/arxiv/papers/2002/2002.09901.pdf ) 

13. Performance Comparison of Crowdworkers and NLP Tools on Named-Entity Recognition and Sentiment Analysis of Political Tweets Mona Jalal, Kate K. Mays, Lei Guo, and Margrit Betke [paper](https://arxiv.org/pdf/2002.04181.pdf ) 

14. autoNLP: NLP Feature Recommendations for Text Analytics Applications  Janardan Misra [paper](https://arxiv.org/pdf/2002.03056.pdf )  

15. FASTWORDBUG: A FAST METHOD TO GENERATE ADVERSARIAL TEXT AGAINST NLP APPLICATIONS. Dou Goodman, Lv Zhonghou & Wang Minghu [paper](https://arxiv.org/pdf/2002.00760.pdf )   

16. SemClinBr – a multi-institutional and multi-specialty semantically annotated corpus for Portuguese clinical NLP tasks.  Lucas Emanuel Silva e Oliveiraa, Ana Carolina Petersa, Adalniza Moura Pucca da Silvaa, Caroline P. Gebelucaa, Yohan Bonescki Gumiela, Lilian Mie Mukai Cinthoa, Deborah Ribeiro Carvalhoa, Sadid A. Hasanb, Claudia Maria Cabral Moro [paper](https://arxiv.org/ftp/arxiv/papers/2001/2001.10071.pdf )   

17. Applying Recent Innovations from NLP to MOOC Student Course Trajectory Modeling.  Clarence Chen, Zachary Pardos [paper](https://arxiv.org/pdf/2001.08333.pdf)    

18. Elephant in the Room: An Evaluation Framework for Assessing Adversarial Examples in NLP.  Ying Xu, Xu Zhong, Antonio Jose Jimeno Yepes, Jey Han Lau [paper](https://arxiv.org/pdf/2001.07820.pdf )  

19. Dice Loss for Data-imbalanced NLP Tasks.  Xiaoya Li, Xiaofei Sun, Yuxian Meng, Junjun Liang, Fei Wu and Jiwei Li [paper](https://arxiv.org/pdf/1911.02855.pdf )   

20. R2DE: a NLP approach to estimating IRT parameters of newly generated questions. Luca Benedetto, Andrea Cappelli, Roberto Turrin, Paolo Cremonesi [paper](https://arxiv.org/pdf/2001.07569.pdf)  

21. Evaluating NLP Models via Contrast Sets.  Matt GardnerF, Yoav ArtziΓ Victoria Basmova, Jonathan Berant, Ben Bogin, Sihao Chen, Pradeep Dasigi, Dheeru Dua, Yanai Elazar, Ananth Gottumukkala, Nitish Gupta, Hanna Hajishirzi, Gabriel Ilharco, Daniel Khashabi, Kevin Lin, Jiangming Liu, Nelson F. Liu, Phoebe Mulcaire, Qiang Ning, Sameer Singh, Noah A. Smith, Sanjay Subramanian, Reut Tsarfaty, Eric Wallace, Ally Zhang, Ben Zhou [paper](https://arxiv.org/pdf/2004.02709.pdf ) 

22. PLAYING THE LOTTERY WITH REWARDS AND MULTIPLE LANGUAGES: LOTTERY TICKETS IN RL AND NLP. Haonan Yu, Sergey Edunov, Yuandong Tian, and Ari S. Morcos [paper](https://arxiv.org/pdf/1906.02768.pdf ) 


### GAN 
#### 2018 
1. Perception-Enhanced Image Super-Resolution via Relativistic Generative Adversarial Networks   Thang Vu, Tung M. Luu, Chang D. Yoo [paper](https://link.springer.com/chapter/10.1007%2F978-3-030-11021-5_7 ) [code](https://github.com/thangvubk/PESR )

2. DeblurGAN: Blind Motion Deblurring Using Conditional Adversarial Networks Orest Kupyn, Volodymyr Budzan, Mykola Mykhailych, Dmytro Mishkin, Jiri Matas [paper](http://openaccess.thecvf.com/content_cvpr_2018/papers/Kupyn_DeblurGAN_Blind_Motion_CVPR_2018_paper.pdf ) [code](https://github.com/KupynOrest/DeblurGAN )

3. HP-GAN: Probabilistic 3D Human Motion Prediction via GAN  Emad Barsoum, John Kender, Zicheng Liu [paper](http://openaccess.thecvf.com/content_cvpr_2018_workshops/papers/w29/Barsoum_HP-GAN_Probabilistic_3D_CVPR_2018_paper.pdf) [code](https://github.com/ebarsoum/hpgan )

4. Image Synthesis with a Convolutional Capsule Generative Adversarial Network Cher Bass, Tianhong Dai, Benjamin Billot, Kai Arulkumaran, Antonia Creswell, Claudia Clopath, Vincenzo De Paola, Anil Anthony Bharath [paper](https://openreview.net/pdf?id=rJen0zC1lE) [code](https://github.com/CherBass/CapsPix2Pix/blob/master/CapsPix2Pix_paper.pdf )

5. Image Synthesis with a Convolutional Capsule Generative Adversarial Network Cher Bass, Tianhong Dai, Benjamin Billot, Kai Arulkumaran, Antonia Creswell, Claudia Clopath, Vincenzo De Paola, Anil Anthony Bharath [paper](https://openreview.net/pdf?id=rJen0zC1lE) [code](https://github.com/lalonderodney/SegCaps)  

6. Diagnosing and Enhancing VAE Models Bin Dai, David Wipf [paper](https://openreview.net/pdf?id=B1e0X3C9tQ  ) [code](https://github.com/daib13/TwoStageVAE )

7. The Unusual Effectiveness of Averaging in GAN Training  Yasin Yaz{\i}c{\i}, Chuan-Sheng Foo, Stefan Winkler, Kim-Hui Yap, Georgios Piliouras, Vijay Chandrasekhar [paper](https://openreview.net/pdf?id=SJgw_sRqFQ ) [code](https://github.com/yasinyazici/EMA_GAN)  

8. The relativistic discriminator: a key element missing from standard GAN   Alexia Jolicoeur-Martineau [paper](https://openreview.net/pdf?id=S1erHoR5t7  ) [code](https://github.com/AlexiaJM/RelativisticGAN )

9. Generating Multiple Objects at Spatially Distinct Locations Tobias Hinz, Stefan Heinrich, Stefan Wermter [paper](https://openreview.net/pdf?id=H1edIiA9KQ  ) [code](https://github.com/tohinz/multiple-objects-gan ) 

10. The relativistic discriminator: a key element missing from standard GAN   Alexia Jolicoeur-Martineau [paper](https://openreview.net/pdf?id=S1erHoR5t7  ) [code](https://github.com/AlexiaJM/RelativisticGAN )

11. InstaGAN: Instance-aware Image-to-Image Translation Sangwoo Mo, Minsu Cho, Jinwoo Shin [paper](https://openreview.net/pdf?id=ryxwJhC9YX) [code](https://github.com/sangwoomo/instagan)

12. Whitening and Coloring Batch Transform for GANs   Aliaksandr Siarohin, Enver Sangineto, Nicu Sebe [paper](https://openreview.net/pdf?id=S1x2Fj0qKQ ) [code](https://github.com/igul222/improved_wgan_training/blob/master/gan_cifar_resnet.py#L79)

13. Convergent Reinforcement Learning with Function Approximation: A Bilevel Optimization Perspective   Zhuoran Yang, Zuyue Fu, Kaiqing Zhang, Zhaoran Wang [papere](https://openreview.net/pdf?id=ryfcCo0ctQ) [code](https://github.com/openai/baselines )

14. DEEP GRAPH TRANSLATION  Xiaojie Guo, Lingfei Wu, Liang Zhao [paper](https://openreview.net/pdf?id=SJz6MnC5YQ ) [code](https://github.com/anonymous1025/Deep-Graph-Translation )

15. Brain MRI super-resolution using 3D generative adversarial networks.  Irina Sánchez , Verónica Vilaplana [paper](https://arxiv.org/pdf/1812.11440.pdf )   

#### 2019 

1. Variational Hetero-Encoder Randomized GANs for Joint Image-Text Modeling  Hao Zhang, Bo Chen, Long Tian, Zhengjue Wang, Mingyuan Zhou [paper](https://openreview.net/pdf?id=H1x5wRVtvS ) [code](https://github.com/BoChenGroup/VHE-GAN ) 

2. Unpaired Point Cloud Completion on Real Scans using Adversarial Training  Xuelin Chen, Baoquan Chen, Niloy J. Mitra [paper](https://openreview.net/pdf?id=HkgrZ0EYwB ) [code](https://github.com/xuelin-chen/pcl2pcl-gan-pub )

3. Unsupervised Video Summarization via Attention-Driven Adversarial Learning  Evlampios E. Apostolidis, Eleni Adamantidou, Alexandros I. Metsai, Vasileios Mezaris, Ioannis Patras [paper](https://link.springer.com/chapter/10.1007%2F978-3-030-37731-1_40 ) [code](https://github.com/e-apostolidis/SUM-GAN-AAE )

4. Learning Implicit Fields for Generative Shape Modeling.   Zhiqin Chen, Hao Zhang [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Chen_Learning_Implicit_Fields_for_Generative_Shape_Modeling_CVPR_2019_paper.pdf) [code](https://github.com/czq142857/implicit-decoder) 

5. Sphere Generative Adversarial Network Based on Geometric Moment Matching.   Sung Woo Park, Junseok Kwon [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Park_Sphere_Generative_Adversarial_Network_Based_on_Geometric_Moment_Matching_CVPR_2019_paper.pdf ) [code](https://github.com/pswkiki/SphereGAN ) 

6. Improving GAN with Neighbors Embedding and Gradient Matching. Ngoc-Trung Tran, Tuan-Anh Bui, Ngai-Man Cheung [paper](https://www.aaai.org/ojs/index.php/AAAI/article/view/4454/4332 ) [code](https://github.com/tntrung/gan ) 

 7. FineGAN: Unsupervised Hierarchical Disentanglement for Fine-Grained Object Generation and Discovery.   Krishna Kumar Singh, Utkarsh Ojha, Yong Jae Lee [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Singh_FineGAN_Unsupervised_Hierarchical_Disentanglement_for_Fine-Grained_Object_Generation_and_Discovery_CVPR_2019_paper.pdf) [code](https://github.com/kkanshul/finegan)

8. Consistency Regularization for Generative Adversarial Networks  Han Zhang, Zizhao Zhang, Augustus Odena, Honglak Lee [paper](https://openreview.net/pdf?id=S1lxKlSKPH ) [code](https://github.com/google/compare_gan/blob/19922d3004b675c1a49c4d7515c06f6f75acdcc8/compare_gan/architectures/sndcgan.py#L121) 


9. Non-Sequential Melody Generation  Mitchell Billard, Robert Bishop, Moustafa Elsisy, Laura Graves, Antonina Kolokolova, Vineel Nagisetty, Zachary Northcott, Heather Patey [paper](https://openreview.net/pdf?id=HkePOCNtPH ) [code](https://github.com/gan-music-generation/gan_music_generation ) 

10. Non-Sequential Melody Generation  Mitchell Billard, Robert Bishop, Moustafa Elsisy, Laura Graves, Antonina Kolokolova, Vineel Nagisetty, Zachary Northcott, Heather Patey [paper](https://openreview.net/pdf?id=HkePOCNtPH ) [code](https://github.com/gan-music-generation/gan_music_generation ) 

11. Imagining the Latent Space of a Variational Auto-Encoders Zezhen Zeng, Jonathon Hare, Adam Prügel-Bennett [paper](https://openreview.net/pdf?id=BJe4PyrFvB ) [code](https://github.com/iclr-2020-zzz/LSR-GAN  )

12. Attributing Fake Images to GANs: Learning and Analyzing GAN Fingerprints  Ning Yu, Larry Davis, Mario Fritz [paper]https://arxiv.org/pdf/1811.08180.pdf  [code](https://github.com/ningyu1991/GANFingerprints )

13. Beholder-Gan: Generation and Beautification of Facial Images with Conditioning on Their Beauty Level  Nir Diamant, Dean Zadok, Chaim Baskin, Eli Schwartz, Alex M. Bronstein [paper](https://openreview.net/pdf?id=B1g6V5DF2H ) [code](https://github.com/beholdergan/Beholder-GAN )

14. Adaptive Generation of Unrestricted Adversarial Inputs  Isaac Dunn, Hadrien Pouget, Tom Melham, Daniel Kroening [paper](https://openreview.net/pdf?id=rJg46kHYwH ) [code](https://github.com/ajbrock/BigGAN-PyTorch) 

15. Improving Model Compatibility of Generative Adversarial Networks by Boundary Calibration  Si-An Chen, Chun-Liang Li, Hsuan-Tien Lin [paper](https://openreview.net/pdf?id=S1xJikHtDH ) [code](https://github.com/MichaelArbel/Scaled-MMD-GAN ) 

16. Generalized Zero-shot ICD Coding  Congzheng Song, Shanghang Zhang, Najmeh Sadoughi, Pengtao Xie, Eric Xing [paper](https://openreview.net/pdf?id=S1lBTerYwH) [code](https://github.com/google-research/bert/blob/master/README.md#out-of-memory-issues ) 

17. TOWARDS FEATURE SPACE ADVERSARIAL ATTACK  Qiuling Xu, Guanhong Tao, Siyuan Cheng, Lin Tan, Xiangyu Zhang [paper](https://openreview.net/pdf?id=S1eqj1SKvr  ) [code](https://github.com/JerishDansolBalala/FeatureSpaceAtk )

18. Progressive Compressed Records: Taking a Byte Out of Deep Learning Data   Michael Kuchnik, George Amvrosiadis, Virginia Smith [paper](https://openreview.net/pdf?id=S1e0ZlHYDB ) [code](https://github.com/tkarras/progressive_growing_of_gans#preparing-datasets-for-training )

19. Score and Lyrics-Free Singing Voice Generation  Jen-Yu Liu, Yu-Hua Chen, Yin-Cheng Yeh, Yi-Hsuan Yang [paper](https://openreview.net/pdf?id=HygcdeBFvr ) [code](https://github.com/keums/melodyExtraction_JDC )

20. Training Generative Adversarial Networks from Incomplete Observations using Factorised Discriminators   Daniel Stoller, Sebastian Ewert, Simon Dixon [paper](https://openreview.net/pdf?id=Hye1RJHKwB ) [code](https://github.com/aalmah/augmented_cyclegan )

21. UWGAN: UNDERWATER GAN FOR REAL-WORLD UNDERWATER COLOR RESTORATION AND DEHAZING  Nan Wang, Yabin Zhou, Fenglei Han, Lichao Wan, Haitao Zhu, Yaojing Zheng [paper](https://openreview.net/pdf?id=HkgMxkHtPH  ) [code](https://github.com/infrontofme/UWGAN_UIE ) 

22. Adversarial Lipschitz Regularization  Dávid Terjék [paper](https://openreview.net/pdf?id=Bke_DertPB ) [code](https://github.com/tensorflow/tensorflow/blob/r1.8/tensorflow/contrib/gan/python/eval/python/classifier_metrics_impl.py )

23. Language GANs Falling Short   Massimo Caccia, Lucas Caccia, William Fedus, Hugo Larochelle, Joelle Pineau, Laurent Charlin [paper](https://openreview.net/pdf?id=BJgza6VtPB  ) [code](https://github.com/pclucas14/GansFallingShort )

24. RPGAN: random paths as a latent space for GAN interpretability  Andrey Voynov, Artem Babenko [paper](https://openreview.net/pdf?id=BJgctpEKwr) [code](https://github.com/rpgan-ICLR2020/RPGAN )

25. BRIDGING ADVERSARIAL SAMPLES AND ADVERSARIAL NETWORKS Faqiang Liu, Mingkun Xu, Guoqi Li, Jing Pei, Luping Shi [paper](https://openreview.net/pdf?id=rklPITVKvS) [code](https://github.com/mseitzer/pytorch-fid )

26. LIA: Latently Invertible Autoencoder with Adversarial Learning  Jiapeng Zhu, Deli Zhao, Bolei Zhou, Bo Zhang [paper](https://openreview.net/pdf?id=ryefE1SYDr ) [code](https://github.com/genforce/interfacegan )

27. LIA: Latently Invertible Autoencoder with Adversarial Learning  Jiapeng Zhu, Deli Zhao, Bolei Zhou, Bo Zhang [paper](https://openreview.net/pdf?id=ryefE1SYDr  ) [code](https://github.com/genforce/interfacegan  )

28. Observational Overfitting in Reinforcement Learning Xingyou Song, Yiding Jiang, Stephen Tu, Yilun Du, Behnam Neyshabur [paper](https://openreview.net/pdf?id=HJli2hNKDH  ) [code](https://github.com/openai/baselines/blob/master/baselines/ppo2/ppo2.py#L21 ) 

29. Language GANs Falling Short Massimo Caccia, Lucas Caccia, William Fedus, Hugo Larochelle, Joelle Pineau, Laurent Charlin [paper](https://openreview.net/pdf?id=BJgza6VtPB ) [code](https://github.com/pclucas14/GansFallingShort )

30. Expected Information Maximization: Using the I-Projection for Mixture Density Estimation  Philipp Becker, Oleg Arenz, Gerhard Neumann [paper](https://openreview.net/pdf?id=ByglLlHFDS) [code](https://github.com/pbecker93/ExpectedInformationMaximization )

31. Expected Information Maximization: Using the I-Projection for Mixture Density Estimation  Philipp Becker, Oleg Arenz, Gerhard Neumann [paper](https://openreview.net/pdf?id=ByglLlHFDS ) [code](https://github.com/pbecker93/ExpectedInformationMaximization )

32. Expected Information Maximization: Using the I-Projection for Mixture Density Estimation  Philipp Becker, Oleg Arenz, Gerhard Neumann [paper](https://openreview.net/pdf?id=ByglLlHFDS  ) [code](https://github.com/pbecker93/ExpectedInformationMaximization ) 

33. BRIDGING ADVERSARIAL SAMPLES AND ADVERSARIAL NETWORKS Faqiang Liu, Mingkun Xu, Guoqi Li, Jing Pei, Luping Shi  [paper](https://openreview.net/pdf?id=rklPITVKvS  ) [code](https://github.com/mseitzer/pytorch-fid )

34. Implicit competitive regularization in GANs Florian Schaefer, Hongkai Zheng, Anima Anandkumar [paper](https://openreview.net/pdf?id=SkxaueHFPB ) [code](https://github.com/EmilienDupont/wgan-gp/blob/master/models.py ) 

35. Progressive Augmentation of GANs  Dan Zhang, Anna Khoreva [paper](https://openreview.net/pdf?id=B1fJj4SeUS ) [code]( https://github.com/boschresearch/PA-GAN )

36. Learning from Label Proportions with Generative Adversarial Networks  Jiabin Liu, Bo Wang, Zhiquan Qi, YingJie Tian, Yong Shi [paper](https://openreview.net/pdf?id=HJe-nESlIH ) [code](https://github.com/liujiabin008/LLP-GAN )

37. Shape Features Improve General Model Robustness Chaowei Xiao, Mingjie Sun, Haonan Qiu, Han Liu, Mingyan Liu, Bo Li [paper](https://openreview.net/pdf?id=SJlPZlStwS  ) [code](https://github.com/bethgelab/foolbox  )

38. High Fidelity Speech Synthesis with Adversarial Networks  Mikołaj Bińkowski, Jeff Donahue, Sander Dieleman, Aidan Clark, Erich Elsen, Norman Casagrande, Luis C. Cobo, Karen Simonyan [paper](https://openreview.net/pdf?id=r1gfQgSFDr ) [code](https://github.com/mbinkowski/DeepSpeechDistances )

39. Small-GAN: Speeding up GAN Training using Core-Sets Samarth Sinha, Han Zhang, Anirudh Goyal, Yoshua Bengio, Hugo Larochelle, Augustus Odena [paper](https://openreview.net/pdf?id=rkeNr6EKwB ) [code](https://github.com/heykeetae/Self-Attention-GAN)

40. Defense against Adversarial Examples by Encoder-Assisted Search in the Latent Coding Space  Wenjing Huang, Shikui Tu, Lei Xu [paper](https://openreview.net/pdf?id=Hyg53gSYPB ) [code](https://github.com/anishathalye/obfuscated-gradients ) 


41. PAGANDA: An Adaptive Task-Independent Automatic Data Augmentation Boli Fang, Miao Jiang, Jerry Shen [paper](https://openreview.net/pdf?id=S1xKEqrs3E  ) [code](https://github.com/miaojiang1987/k-folder-data-augmentation-gan/  )


42. Asymmetric Generative Adversarial Networks for Image-to-Image Translation Hao Tang, Dan Xu, Hong Liu and Nicu Sebe [paper](https://arxiv.org/pdf/1912.06931.pdf )

43. cGANs with Multi-Hinge Loss Ilya Kavalerov, Wojciech Czaja, Rama Chellappa [paper](https://arxiv.org/pdf/1912.04216.pdf  )  

44. Invert and Defend: Model-based Approximate Inversion of Generative Adversarial Networks for Secure Inference  Wei-An Lin, Yogesh Balaji, Pouya Samangouei, Rama Chellappa [paper](https://arxiv.org/pdf/1911.10291.pdf )   

45. Adversarial Fisher Vectors for Unsupervised Representation Learning Shuangfei Zhai Walter Talbott Carlos Guestrin Joshua M. Susskind [paper](https://arxiv.org/pdf/1910.13101.pdf   ) 

46. Alleviating Feature Confusion for Generative Zero-shot Learning Jingjing Li, Mengmeng Jing, Ke Lu, Lei Zhu, Yang Yang, Zi Huang [paper](https://arxiv.org/pdf/1909.07615.pdf   )

47. Synthesizing Coupled 3D Face Modalities by Trunk-Branch Generative Adversarial Networks.  Baris Gecer, Alexander Lattas, Stylianos Ploumpis, Jiankang Deng, Athanasios Papaioannou, Stylianos Moschoglou, and Stefanos Zafeiriou [paper](https://arxiv.org/pdf/1909.02215.pdf)

48. Spectral Regularization for Combating Mode Collapse in GANs.  Kanglin Liu, Wenming Tang, Ruitao Xie, and Guoping Qiu [paper](https://arxiv.org/pdf/1908.10999.pdf )

49. Adversarial regression training for visualizing the progression of chronic obstructive pulmonary disease with chest x-rays. Ricardo Bigolin Lanfredi, Joyce D. Schroeder,  Clement Vachet, and Tolga Tasdizen [paper](https://arxiv.org/pdf/1908.10468.pdf )

50. Learning Fixed Points in Generative Adversarial Networks: From Image-to-Image Translation to Disease Detection and Localization.  Md Mahfuzur Rahman Siddiquee, Zongwei Zhou1,3, Nima Tajbakhsh, Ruibin Feng, Michael B. Gotway, Yoshua Bengio, and Jianming Liang [paper](https://arxiv.org/pdf/1908.06965.pdf )   

51. AutoGAN: Neural Architecture Search for Generative Adversarial Networks.  Xinyu Gong, Shiyu Chang, Yifan Jiang, Zhangyang Wang [paper](https://arxiv.org/pdf/1908.03835.pdf  )

52. DeblurGAN-v2: Deblurring (Orders-of-Magnitude) Faster and Better. Orest Kupyn, Tetiana Martyniuk, Junru Wu, Zhangyang Wang [paper](https://arxiv.org/pdf/1908.03826.pdf  )

53. Cosmological N-body simulations: a challenge for scalable generative models.  Nathana¨el Perraudin, Ankit Srivastava, Aurelien Lucchi, Tomasz Kacprzak, Thomas Hofmann and Alexandre R´efr´egier [paper](https://arxiv.org/pdf/1908.05519.pdf ) 

54. Progressive Perception-Oriented Network for Single Image Super-Resolution.  Zheng Hui, Jie Li, Xinbo Gao, Senior Member, IEEE and Xiumei Wang [paper](https://arxiv.org/pdf/1907.10399.pdf)  

55. Cascade Attention Guided Residue Learning GAN for Cross-Modal Translation.  Bin Duanb, Wei Wang, Hao Tang, Hugo Latapie [paper](https://arxiv.org/pdf/1907.01826.pdf )   

56. CELLULAR STATE TRANSFORMATIONS USING GENERATIVE ADVERSARIAL NETWORKS. Colin Targonski, Benjamin T. Shealy, Melissa C. Smith, F. Alex Feltus [paper](https://arxiv.org/pdf/1907.00118.pdf )  

57. Adversarial Sub-sequence for Text Generation. Xingyuan Chen, Yanzhe Li, Peng Jin, Jiuhua Zhang, Xinyu Dai, Jiajun Chen, Gang Song [paper](https://arxiv.org/pdf/1905.12835.pdf )  

58. Structured Coupled Generative Adversarial Networks for Unsupervised Monocular Depth Estimation. Mihai Marian Puscas, Dan Xu, Andrea Pilzer, Niculae Sebe [paper](https://arxiv.org/pdf/1908.05794.pdf)

59. Attention-Guided Generative Adversarial Networks for Unsupervised Image-to-Image Translation. Hao Tang, Dan Xu, Nicu Sebe, Yan Yan [paper](https://arxiv.org/pdf/1903.12296.pdf )   

60. Diagnosing and Enhancing VAE Models.  Bin Dai, David Wipf [paper](https://arxiv.org/pdf/1903.05789.pdf )  

61. Virtual Conditional Generative Adversarial Networks.  Haifeng Shi Guanyu Cai Yuqin Wang Shaohua Shang Lianghua He [paper](https://arxiv.org/pdf/1901.09822.pdf )   

62. CSGAN: Cyclic-Synthesized Generative Adversarial Networks for Image-to-Image Transformation.  Kishan Babu Kancharagunta and Shiv Ram Dubey  [paper](https://arxiv.org/pdf/1901.03554.pdf  )

63. TF-REPLICATOR: DISTRIBUTED MACHINE LEARNING FOR RESEARCHERS.  Peter Buchlovsky,  David Budden, Dominik Grewe, Chris Jones, John Aslanides, Frederic Besse, Andy Brock, Aidan Clark, Sergio Gomez Colmenarejo, Aedan Pope, Fabio Viola, Dan Belov [paper](https://arxiv.org/pdf/1902.00465.pdf )

#### 2020 

1. 4D Semantic Cardiac Magnetic Resonance Image Synthesis on XCAT Anatomical Model   anonymus [paper](https://openreview.net/pdf?id=tRdOL-DcPA) [code](https://github.com/NVlabs/SPADE )

2. Rubeus-GAN: Attacking class imbalance via conditioned generation. A medical imaging perspective   Anonymous [paper](https://openreview.net/pdf?id=UHtZuvXHoA  ) [code](https://github.com/soumith/ganhacks)


3. Unsupervised Video Summarization via Attention-Driven Adversarial Learning  Evlampios E. Apostolidis, Eleni Adamantidou, Alexandros I. Metsai, Vasileios Mezaris, Ioannis Patras [paper](https://link.springer.com/chapter/10.1007%2F978-3-030-37731-1_40 ) [code](https://github.com/e-apostolidis/SUM-GAN-AAE ) 

4. Discriminative region proposal adversarial network for high-quality image-to-image translation  Chao Wang, Wenjie Niu, Yufeng Jiang, Haiyong Zheng, Zhibin Yu, Zhaorui Gu, Bing Zheng [paper](https://link.springer.com/content/pdf/10.1007/s11263-019-01273-2.pdf) [code](https://github.com/godisboy/DRPAN )

5. FineGAN: Unsupervised Hierarchical Disentanglement for Fine-Grained Object Generation and Discovery   Krishna Kumar Singh [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Singh_FineGAN_Unsupervised_Hierarchical_Disentanglement_for_Fine-Grained_Object_Generation_and_Discovery_CVPR_2019_paper.pdf )  [code](https://github.com/kkanshul/finegan )


6. Deep Generative Image Models using a Laplacian Pyramid of Adversarial Networks  Emily Denton∗, Soumith Chintala, Arthur Szlam,  Rob Fergus  [paper](https://papers.nips.cc/paper/5773-deep-generative-image-models-using-a-laplacian-pyramid-of-adversarial-networks.pdf)  

7. Regression via Implicit Models and Optimal Transport Cost Minimization. Saurav Manchanda, Khoa Doan, Pranjul Yadav, S. Sathiya Keerthi [paper]( https://arxiv.org/pdf/2003.01296.pdf   )

8. PCSGAN: Perceptual Cyclic-Synthesized Generative Adversarial Networks for Thermal and NIR to Visible Image Transformation Kancharagunta Kishan Babu and Shiv Ram Dubey [paper](https://arxiv.org/pdf/2002.07082.pdf)  

9. Image Fine-grained Inpainting Zheng Hui, Jie Li, Xiumei Wang, and Xinbo Gao∗  School of Electronic Engineering, Xidian University, Xi’an, China [paper](https://arxiv.org/pdf/2002.02609.pdf ) 

10. CorGAN: Correlation-Capturing Convolutional Generative Adversarial Networks for Generating Synthetic Healthcare Records Amirsina Torfi, Edward A. Fox [paper](https://arxiv.org/pdf/2001.09346.pdf  ) 

11. S2OMGAN: Shortcut from Remote Sensing Images to Online Maps Xu Chen, Songqiang Chen, Tian Xu, Bangguo Yin, Jian Peng, Xiaoming Mei, Haifeng Li∗ [paper]( https://arxiv.org/pdf/2001.07712.pdf )

12. Freeze the Discriminator: a Simple Baseline for Fine-Tuning GANs  Sangwoo Mo, Minsu Cho, Jinwoo Shin [paper]( https://arxiv.org/pdf/2002.10964.pdf )   

13. UWGAN: Underwater GAN for Real-world Underwater Color Restoration and Dehazing  Nan Wang, Yabin Zhou, Fenglei Han, Haitao Zhu, Yaojing Zheng  [paper](https://arxiv.org/ftp/arxiv/papers/1912/1912.10269.pdf )   

14. MineGAN: effective knowledge transfer from GANs to target domains with few images Yaxing Wang, Abel Gonzalez-Garcia, David Berga, Luis Herranz, Faha Shahbaz Khan, Joost van de Weijer  [paper](https://arxiv.org/pdf/1912.05270.pdf )

15. AdversarialNAS: Adversarial Neural Architecture Search for GANs.  Chen Gao, Yunpeng Chen, Si Liu, Zhenxiong Tan, Shuicheng Yan [paper]( https://arxiv.org/pdf/1912.02037.pdf )

16. Noise Robust Generative Adversarial Networks  Takuhiro Kaneko, Tatsuya Harada [paper]( https://arxiv.org/pdf/1911.11776.pdf  )  

17. Self-supervised GAN: Analysis and Improvement with Multi-class Minimax Game Ngoc-Trung Tran, Viet-Hung Tran, Ngoc-Bao Nguyen, Linxiao Yang, Ngai-Man Cheung[paper]( https://arxiv.org/pdf/1911.06997.pdf )   

18. Reusing Discriminators for Encoding: Towards Unsupervised Image-to-Image Translation. Runfa Chen, Wenbing Huang, Binghui Huang, Fuchun Sun, Bin Fang [paper]( https://arxiv.org/pdf/2003.00273.pdf )  

19. A NEURO-AI INTERFACE FOR EVALUATING GENERATIVE ADVERSARIAL NETWORKS.  Zhengwei Wang, Qi She, Alan F. Smeaton, Tomas E. Ward ´& Graham Healy [paper](https://arxiv.org/pdf/2003.03193.pdf  ) 

20. Exploiting Deep Generative Prior for Versatile Image Restoration and Manipulation Xingang Pan, Xiaohang Zhan, Bo Dai, Dahua Lin, Chen Change Loy, and Ping Luo  [paper](https://arxiv.org/pdf/2003.13659.pdf )  

21. Feature Quantization Improves GAN Training. Yang Zhao, Chunyuan Li, Ping Yu, Jianfeng Gao, Changyou Chen [paper]( https://arxiv.org/pdf/2004.02088.pdf ) 

22. Generative Adversarial Networks in Computer Vision: A Survey and Taxonomy.  ZHENGWEI WANG, QI SHE, QI SHE [paper](https://arxiv.org/pdf/1906.01529.pdf )   

23. Fast Underwater Image Enhancement for Improved Visual Perception. Md Jahidul Islam, Youya Xia and Junaed Sattar [paper](https://arxiv.org/pdf/1903.09766.pdf ) 


### VAE
#### 2018 

1. Practical lossless compression with latent variables using bits back coding   James Townsend, Thomas Bird, David Barber [paper](https://openreview.net/pdf?id=ryE98iR5tm  ) [code](https://github.com/bits-back/bits-back ) 

2. Variational Inference of Disentangled Latent Concepts from Unlabeled Observations   Abhishek Kumar, Prasanna Sattigeri, Avinash Balakrishnan  [paper](https://openreview.net/pdf?id=H1kG7GZAW ) [code](https://github.com/deepmind/dsprites-dataset)

3. Directed-Info GAIL: Learning Hierarchical Policies from Unsegmented Demonstrations using Directed Information   Mohit Sharma, Arjun Sharma, Nicholas Rhinehart, Kris M. Kitani [paper]( https://openreview.net/pdf?id=BJeWUs05KQ  ) [code](https://github.com/deepmind/dm_control ) 

4. Practical lossless compression with latent variables using bits back coding   James Townsend, Thomas Bird, David Barber [paper](https://openreview.net/pdf?id=ryE98iR5tm  ) [code](https://github.com/bits-back/bits-back ) 

5. GO Gradient for Expectation-Based Objectives  Yulai Cong, Miaoyun Zhao, Ke Bai, Lawrence Carin [paper]( https://openreview.net/pdf?id=ryf6Fs09YX  ) [code](https://github.com/yorkerlin/VB-MixEF/blob/master/poster_workshop.pdf )

6. Practical lossless compression with latent variables using bits back coding   James Townsend, Thomas Bird, David Barber [paper]( https://openreview.net/pdf?id=ryE98iR5tm ) [code](https://github.com/bits-back/bits-back ) 

7. Switching Linear Dynamics for Variational Bayes Filtering   Philip Becker-Ehmck, Jan Peters, Patrick van der Smagt [paper]( https://openreview.net/pdf?id=B1MbDj0ctQ  ) [code](https://github.com/emtiyaz/vmp-for-svae )

8. ISA-VAE: Independent Subspace Analysis with Variational Autoencoders  Jan Stühmer, Richard Turner, Sebastian Nowozin [paper]( https://openreview.net/pdf?id=rJl_NhR9K7 ) [code](https://github.com/rtqichen/beta-tcvae ) 

9. Generative Models from the perspective of Continual Learning  Timothée Lesort, Hugo Caselles-Dupré, Michael Garcia-Ortiz, Jean-François Goudou, David Filliat [paper](https://openreview.net/pdf?id=S1eFtj0cKQ ) 
[code](https://github.com/anonymous-authors-2018/Generative_models_from_the_perspective_of_Continual_learning  )

10. HyperGAN: Exploring the Manifold of Neural Networks   Neale Ratzlaff, Li Fuxin  [paper](https://openreview.net/pdf?id=B1GHJ3R9tQ ) [code](https://github.com/ICLR19HyperGAN/HyperGAN  )

11. STCN: Stochastic Temporal Convolutional Networks  Emre Aksan, Otmar Hilliges [paper](https://openreview.net/pdf?id=HkzSQhCcK7 ) [code](https://github.com/tensorflow/models/tree/master/research/fivo ) 

12. Understanding and Improving Interpolation in Autoencoders via an Adversarial Regularizer  David Berthelot*, Colin Raffel*, Aurko Roy, Ian Goodfellow [paper](https://openreview.net/pdf?id=S1fQSiCcYm  ) [code](https://github.com/anonymous-iclr-2019/acai-iclr-2019/blob/master/lrae.py#L61 )

13. Variational Sparse Coding   Francesco Tonolini, Bjorn Sand Jensen, Roderick Murray-Smith [paper](https://openreview.net/pdf?id=SkeJ6iR9Km ) [code](https://github.com/Alfo5123/Variational-Sparse-Coding )

14. Practical lossless compression with latent variables using bits back coding   James Townsend, Thomas Bird, David Barber [paper]( https://openreview.net/pdf?id=ryE98iR5tm ) [code](https://github.com/bits-back/bits-back )

15. Diagnosing and Enhancing VAE Models   Bin Dai, David Wipf [paper](https://openreview.net/pdf?id=B1e0X3C9tQ ) [code](https://github.com/daib13/TwoStageVAE )


#### 2019
1. Disentangling and learning robust representations with naturual clustering  . Antoran, Miguel [paper]( https://arxiv.org/abs/1901.09415)

2. Inherent tradeoffs in learning fair representations.  Zhao, Gordon  [paper](https://arxiv.org/abs/1906.08386)

3. Affine variational autoencoders: an efficient approach for improving generalization and robustness to distribution shift. Bidart, Wong  [paper](https://arxiv.org/pdf/1905.05300.pdf)

4. Learning deep controllable and structured representations for image synthesis, structured prediction and beyond.  Yan [paper](https://deepblue.lib.umich.edu/handle/2027.42/153334)


5. Continual unsupervised representation learning  . Rao, Visin, Rusu, The, Pascanu, Hadsell  [paper](https://arxiv.org/pdf/1910.14481.pdf)

6. Group-based learning of disentangled representations with generalizability for novel contents.  Hosoya  [paper](https://www.ijcai.org/Proceedings/2019/0348.pdf)

7. Task-Conditioned variational autoencoders for learning movement primitives. Noseworthy, Paul, Roy, Park, Roy [paper]( https://groups.csail.mit.edu/rrg/papers/noseworthy_corl_19.pdf)

8. Multimodal generative models for compositional representation learning. Wu, Goodman [paper](https://arxiv.org/pdf/1912.05075.pdf)

9. dpVAEs: fixing sample generation for regularized VAEs.  Bhalodia, Lee, Elhabian [paper](https://arxiv.org/pdf/1911.10506.pdf)

10. From variational to deterministic autoencoders.   Ghosh, Sajjadi, Vergai, Black, Scholkopf  [paper](https://arxiv.org/pdf/1903.12436.pdf)

11. Learning representations by maximizing mutual information in variational autoencoder. Rezaabad, Vishwanath  (https://arxiv.org/pdf/1912.13361.pdf )

12. Disentangled representation learning with Wasserstein total correlation.  Xiao, Wang  [paper](https://arxiv.org/pdf/1912.12818.pdf ) 

13. Wasserstein dependency measure for representation learning.   Ozair, Lynch, Bengio, van den Oord, Levine, Sermanent [paper](https://arxiv.org/pdf/1903.11780.pdf  )

14. GP-VAE: deep probabilistic time series imputation.  Fortuin, Baranchuk, Ratsch, Mandt [paper](https://arxiv.org/pdf/1907.04155.pdf) [code]  (https://github.com/ratschlab/GP-VAE)


15. Gated Variational Autoencoders: Incorporating weak supervision to encourage disentanglement.  Vowels, Camgoz, Bowden   [paper](https://arxiv.org/pdf/1911.06443.pdf )

16. An introduction to variational autoencoders.  Kingma, Welling [paper](https://arxiv.org/pdf/1906.02691.pdf)

17. Adaptive density estimation for generative models Lucas, Shmelkov, Schmid, Alahari, Verbeek [paper](https://papers.nips.cc/paper/9370-adaptive-density-estimation-for-generative-models.pdf)

18. Data efficient mutual information neural estimator  Lin, Sur, Nastase, Divakaran, Hasson, Amer  [paper](https://arxiv.org/pdf/1905.03319.pdf)

19. RecVAE: a new variational autoencoder for Top-N recommendations with implicit feedback. Shenbin, Alekseev, Tutubalina, Malykh, Nikolenko  [paper](https://arxiv.org/pdf/1912.11160.pdf)

20. Vibration signal generation using conditional variational autoencoder for class imbalance problem.  Ko, Kim, Kong, Lee, Youn  [paper](http://icmr2019.ksme.or.kr/wp/pdf/190090.pdf)

21. The usual suspects? Reassessing blame for VAE posterior collapse.   Dai, Wang, Wipf [paper](https://arxiv.org/pdf/1912.10702.pdf)

22. What does the free energy principle tell us about the brain?  Gershman  [paper](https://arxiv.org/pdf/1901.07945.pdf)

23. Sub-band vector quantized variational autoencoder for spectral envelope quantization. Srikotr, Mano [paper](https://ieeexplore.ieee.org/abstract/document/8929436 )

24. A variational-sequential graph autoencoder for neural performance prediction. Friede, Lukasik, Stuckenschmidt, Keuper [paper](https://arxiv.org/pdf/1912.05317.pdf  )

25. Explicit disentanglement of appearance and perspective in generative models.  Skafte, Hauberg [paper](https://papers.nips.cc/paper/8387-explicit-disentanglement-of-appearance-and-perspective-in-generative-models.pdf )

26. Disentangled behavioural representations. Dezfouli, Ashtiani, Ghattas, Nock, Dayan, Ong [paper](https://papers.nips.cc/paper/8497-disentangled-behavioural-representations.pdf  )

27. Learning disentangled representations for robust person re-identification.  Eom, Ham  [paper](https://papers.nips.cc/paper/8771-learning-disentangled-representation-for-robust-person-re-identification.pdf)  

28. Towards latent space optimality for auto-encoder based generative models. Mondal, Chowdhury, Jayendran, Singla, Asnani, AP  [paper](https://arxiv.org/pdf/1912.04564.pdf  )

29. Don't blame the ELBO! A linear VAE perspective on posterior collapse. Lucas, Tucker, Grosse, Norouzi [paper]( https://128.84.21.199/pdf/1911.02469.pdf)

30. Bridging the ELBO and MMD.  Ucar  [paper](https://arxiv.org/pdf/1910.13181.pdf)

31. Learning disentangled representations for counterfactual regression.  Hassanpour, Greiner [paper](https://pdfs.semanticscholar.org/1df4/204e14da51b05a14781e2a4dc3e0d7da562d.pdf)

32. Learning disentangled representations for recommendation. Ma, Zhou, Cui, Yang, Zhu  [paper](https://arxiv.org/pdf/1910.14238.pdf)

33. A vector quantized variational autoencoder (VQ-VAE) autoregressive neural F0 model for statistical parametric speech synthesis. Wang, Takaki, Yamagishi, King, Tokuda [paper](https://ieeexplore.ieee.org/abstract/document/8884734)

34. Diversity-aware event prediction based on a conditional variational autoencoder with reconstruction.  Kiyomaru, Omura, Murawaki, Kawahara, Kurohashi  [paper](https://www.aclweb.org/anthology/D19-6014.pdf)

35. Learning multimodal representations with factorized deep generative models. Tsai, Liang, Zadeh, Morency, Salakhutdinov [paper](https://pdfs.semanticscholar.org/7416/6384ad391513e8e8bf48cbeaff2516b8c332.pdf)

36. High-dimensional nonlinear profile monitoring based on deep probabilistic autoencoders. Sergin, Yan [paper](https://arxiv.org/pdf/1911.00482.pdf)

37. Leveraging directed causal discovery to detect latent common causes.  Lee, Hart, Richens, Johri [paper](https://arxiv.org/pdf/1910.10174.pdf)

38. Robust discrimination and generation of faces using compact, disentangled embeddings. Browatzki, Wallraven  [paper](http://openaccess.thecvf.com/content_ICCVW_2019/papers/RSL-CV/Browatzki_Robust_Discrimination_and_Generation_of_Faces_using_Compact_Disentangled_Embeddings_ICCVW_2019_paper.pdf)

39. Coulomb Autoencoders. Sansone, Ali, Sun [paper](https://arxiv.org/pdf/1802.03505.pdf)

40. Contrastive learning of structured world models.  Kipf, Pol, Welling  [paper](https://arxiv.org/pdf/1911.12247.pdf)

41. No representation without transformation. Giannone, Masci, Osendorfer [paper](https://pgr-workshop.github.io/img/PGR007.pdf)

42. Neural density estimation.  Papamakarios  [paper](https://arxiv.org/pdf/1910.13233.pdf)

43. Variational autoencoder-based approach for rail defect identification.  Wei, Ni [paper](http://www.dpi-proceedings.com/index.php/shm2019/article/view/32432)

44. Variational learning with disentanglement-pytorch.  Abdi, Abolmaesumi, Fels [paper](https://openreview.net/pdf?id=rJgUsFYnir)

45. PVAE: learning disentangled representations with intrinsic dimension via approximated L0 regularization.  Shi, Glocker, Castro  [paper](https://openreview.net/pdf?id=HJg8stY2oB)

46. Mixed-curvature variational autoencoders.   Skopek, Ganea, Becigneul  [paper](https://arxiv.org/pdf/1911.08411.pdf)

47. Continuous hierarchical representations with poincare variational autoencoders.   Mathieu, Le Lan, Maddison, Tomioka  [paper](https://arxiv.org/pdf/1901.06033.pdf)

48. VIREL: A variational inference framework for reinforcement learning.  Fellows, Mahajan, Rudner, Whiteson [paper]( https://arxiv.org/pdf/1811.01132.pdf)

49. Disentangling video with independent prediction.  Whitney, Fergus[paper]( https://arxiv.org/pdf/1901.05590.pdf)

50. Disentangling state space representations Miladinovic, Gondal, Scholkopf, Buhmann, Bauer  [paper](https://arxiv.org/pdf/1906.03255.pdf)

51. Likelihood conribution based multi-scale architecture for generative flows. Das, Abbeel, Spanos [paper](https://arxiv.org/pdf/1908.01686.pdf)

52. AlignFlow: cycle consistent learning from multiple domains via normalizing flows  Grover, Chute, Shu, Cao, Ermon  [paper](https://arxiv.org/pdf/1905.12892.pdf)


53. IB-GAN: disentangled representation learning with information bottleneck GAN.   Jeon, Lee, Kim  [paper](https://openreview.net/forum?id=ryljV2A5KX)

54. Learning hierarchical priors in VAEs.  Klushyn, Chen, Kurle, Cseke, van der Smagt [paper](https://papers.nips.cc/paper/8553-learning-hierarchical-priors-in-vaes.pdf)

55. ODE2VAE: Deep generative second order ODEs with Bayesian neural networks. Yildiz, Heinonen, Lahdesmaki [paper]( https://papers.nips.cc/paper/9497-ode2vae-deep-generative-second-order-odes-with-bayesian-neural-networks.pdf)

56. Explicitly disentangling image content from translation and rotation with spatial-VAE.  Bepler, Zhong, Kelley, Brignole, Berger [paper](https://papers.nips.cc/paper/9677-explicitly-disentangling-image-content-from-translation-and-rotation-with-spatial-vae.pdf)

57. A primal-dual link between GANs and autoencoders. Husain, Nock, Williamson  [paper](https://papers.nips.cc/paper/8333-a-primal-dual-link-between-gans-and-autoencoders.pdf)

58. Exact rate-distortion in autoencoders via echo noise. Brekelmans, Moyer, Galstyan, ver Steeg  [paper](https://papers.nips.cc/paper/8644-exact-rate-distortion-in-autoencoders-via-echo-noise.pdf)

59. Direct optimization through arg max for discrete variational auto-encoder.  Lorberbom, Jaakkola, Gane, Hazan [paper]( https://papers.nips.cc/paper/8851-direct-optimization-through-arg-max-for-discrete-variational-auto-encoder.pdf)

60. Semi-implicit graph variational auto-encoders.  Hasanzadeh, Hajiramezanali, Narayanan, Duffield, Zhou, Qian [paper]( https://papers.nips.cc/paper/9255-semi-implicit-graph-variational-auto-encoders.pdf)

61. The continuous Bernoulli: fixing a pervasive error in variational autoencoders. Loaiza-Ganem, Cunningham  [paper](https://papers.nips.cc/paper/9484-the-continuous-bernoulli-fixing-a-pervasive-error-in-variational-autoencoders.pdf)

62. Provable gradient variance guarantees for black-box variational inference.  Domke [paper](https://papers.nips.cc/paper/8325-provable-gradient-variance-guarantees-for-black-box-variational-inference.pdf)

63. Conditional structure generation through graph variational generative adversarial nets. Yang, Zhuang, Shi, Luu, Li  [paper](https://papers.nips.cc/paper/8415-conditional-structure-generation-through-graph-variational-generative-adversarial-nets.pdf)

64. Scalable spike source localization in extracellular recordings using amortized variational inference. Hurwitz, Xu, Srivastava, Buccino, Hennig  [paper](https://papers.nips.cc/paper/8720-scalable-spike-source-localization-in-extracellular-recordings-using-amortized-variational-inference.pdf)

65. A latent variational framework for stochastic optimization. Casgrain  [paper](https://papers.nips.cc/paper/8802-a-latent-variational-framework-for-stochastic-optimization.pdf)

66. MAVEN: multi-agent variational exploration. Mahajan, Rashid, Samvelyan, Whiteson  [paper](https://papers.nips.cc/paper/8978-maven-multi-agent-variational-exploration.pdf)

67. Variational graph recurrent neural networks.  Hajiramezanali, Hasanzadeh, Narayanan, Duffield, Zhou, Qian [paper](https://papers.nips.cc/paper/9254-variational-graph-recurrent-neural-networks.pdf)

68. The thermodynamic variational objective.  Masrani, Le, Wood [paper](https://papers.nips.cc/paper/9328-the-thermodynamic-variational-objective.pdf)

69. Variational temporal abstraction.   Kim, Ahn, Bengio  [paper](https://papers.nips.cc/paper/9332-variational-temporal-abstraction.pdf)

70. Exploiting video sequences for unsupervised disentangling in generative adversarial networks. Tuesca, Uzal  [paper](https://arxiv.org/pdf/1910.11104.pdf)

71. Couple-VAE: mitigating the encoder-decoder incompatibility in variational text modeling with coupled deterministic networks.    [paper](https://openreview.net/pdf?id=SJlo_TVKwS)

72. Variational mixture-of-experts autoencoders for multi-modal deep generative models. Shi, Siddharth, Paige, Torr [paper](https://papers.nips.cc/paper/9702-variational-mixture-of-experts-autoencoders-for-multi-modal-deep-generative-models.pdf)

73. Invertible convolutional flow.  Karami, Schuurmans, Sohl-Dickstein, Dinh, Duckworth [paper](https://papers.nips.cc/paper/8801-invertible-convolutional-flow.pdf)

74. Implicit posterior variational inference for deep Gaussian processes. Yu, Chen, Dai, Low, Jaillet [paper](https://papers.nips.cc/paper/9593-implicit-posterior-variational-inference-for-deep-gaussian-processes.pdf)

75. MaCow: Masked convolutional generative flow.  Ma, Kong, Zhang, Hovy [paper](https://papers.nips.cc/paper/8824-macow-masked-convolutional-generative-flow.pdf)

76. Residual flows for invertible generative modeling.  Chen, Behrmann, Duvenaud, Jacobsen  [paper](https://papers.nips.cc/paper/9183-residual-flows-for-invertible-generative-modeling.pdf)

77. Discrete flows: invertible generative models of discrete data.  Tran, Vafa, Agrawal, Dinh, Poole  [paper](https://papers.nips.cc/paper/9612-discrete-flows-invertible-generative-models-of-discrete-data.pdf)

78. Re-examination of the role of latent variables in sequence modeling.  Lai, Dai, Yang, Yoo [paper](https://papers.nips.cc/paper/8996-re-examination-of-the-role-of-latent-variables-in-sequence-modeling.pdf)

79. Learning-in-the-loop optimization: end-to-end control and co-design of soft robots through learned deep latent representations. Spielbergs, Zhao, Hu, Du, Matusik, Rus  [paper](https://papers.nips.cc/paper/9038-learning-in-the-loop-optimization-end-to-end-control-and-co-design-of-soft-robots-through-learned-deep-latent-representations.pdf)

80. Triad constraints for learning causal structure of latent variables.  Cai, Xie, Glymour, Hao, Zhang [paper](https://papers.nips.cc/paper/9448-triad-constraints-for-learning-causal-structure-of-latent-variables.pdf)

81. Disentangling influence: using disentangled representations to audit model predictions. Marx, Phillips, Friedler, Scheidegger, Venkatasubramanian [paper](https://papers.nips.cc/paper/8699-disentangling-influence-using-disentangled-representations-to-audit-model-predictions.pdf)

82. Symmetry-based disentangled representation learning requires interaction with environments. Caselles-Dupre, Ortiz, Filliat  [paper](https://papers.nips.cc/paper/8709-symmetry-based-disentangled-representation-learning-requires-interaction-with-environments.pdf)

83. Weakly supervised disentanglement with guarantees.  Shu, Chen, Kumar, Ermon, Poole  [paper](https://arxiv.org/pdf/1910.09772.pdf)

84. Demystifying inter-class disentanglement. Gabbay, Hoshen  [paper](https://arxiv.org/pdf/1906.11796.pdf)

85. Spectral regularization for combating mode collapse in GANs.  Liu, Tang, Xie, Qiu [paper](https://arxiv.org/pdf/1908.10999.pdf)

86. Geometric disentanglement for generative latent shape models. Aumentado-Armstrong, Tsogkas, Jepson, Dickinson [paper](https://arxiv.org/pdf/1908.06386.pdf)

87. Cross-dataset person re-identification via unsupervised pose disentanglement and adaptation.  Li, Lin, Lin, Wang [paper]( https://arxiv.org/pdf/1909.09675.pdf)

88. Identity from here, pose from there: self-supervised disentanglement and generation of objects using unlabeled videos.  Xiao, Liu, Lee  [paper](https://web.cs.ucdavis.edu/~yjlee/projects/iccv2019_disentangle.pdf)

89. Content and style disentanglement for artistic style transfer.  Kotovenko, Sanakoyeu, Lang, Ommer [paper](https://compvis.github.io/content-style-disentangled-ST/paper.pdf)

90. Unsupervised robust disentangling of latent characteristics for image synthesis.  Esser, Haux, Ommer  [paper](https://arxiv.org/pdf/1910.10223.pdf)

91. LADN: local adversarial disentangling network for facial makeup and de-makeup.  Gu, Wang, Chiu, Tai, Tang [paper](https://arxiv.org/pdf/1904.11272.pdf)

92. Video compression with rate-distortion autoencoders.  Habibian, van Rozendaal, Tomczak, Cohen [paper](https://arxiv.org/pdf/1908.05717.pdf)

93. Variable rate deep image compression with a conditional autoencoder.  Choi, El-Khamy, Lee [paper](https://arxiv.org/pdf/1909.04802.pdf)

94. Memorizing normality to detect anomaly: memory-augmented deep autoencoder for unsupervised anomaly detection. Gong, Liu, Le, Saha [paper](https://arxiv.org/pdf/1904.02639.pdf)

95. AVT: unsupervise d learning of transformation equivariant representations by autoencoding variational transformations.  Qi, Zhang, Chen, Tian [paper](https://arxiv.org/pdf/1903.10863.pdf)

96. Deep clustering by Gaussian mixture variational autoencoders with graph embedding.  Yang, Cheung, Li, Fang  [paper](http://openaccess.thecvf.com/content_ICCV_2019/papers/Yang_Deep_Clustering_by_Gaussian_Mixture_Variational_Autoencoders_With_Graph_Embedding_ICCV_2019_paper.pdf)

97. Variational adversarial active learning.  Sinha, Ebrahimi, Darrell  [paper](https://arxiv.org/pdf/1904.00370.pdf)

98. Variational few-shot learning.  Zhang, Zhao, Ni, Xu, Yang [paper](http://openaccess.thecvf.com/content_ICCV_2019/papers/Zhang_Variational_Few-Shot_Learning_ICCV_2019_paper.pdf)

99. Multi-angle point cloud-VAE: unsupervised feature learning for 3D point clouds from multiple angles by joint self-reconstruction and half-to-half prediction. Han, Wang, Liu, Zwicker [paper](https://arxiv.org/pdf/1907.12704.pdf)

100. LayoutVAE: stochastic scene layout generation from a label set.  Jyothi, Durand, He, Sigal, Mori  [paper](https://arxiv.org/pdf/1907.10719.pdf)

101. VV-NET: Voxel VAE Net with group convolutions for point cloud segmentation. Meng, Gao, Lai, Manocha [paper](https://arxiv.org/pdf/1811.04337.pdf)

102. Bayes-Factor-VAE: hierarchical bayesian deep auto-encoder models for factor disentanglement.  Kim, Wang, Sahu, Pavlovic [paper](https://arxiv.org/pdf/1909.02820.pdf)


103. Robust ordinal VAE: Employing noisy pairwise comparisons for disentanglement. Chen, Batmanghelich [paper](https://arxiv.org/pdf/1910.05898.pdf)

104. Evaluating disentangled representations.  Sepliarskaia, A. and Kiseleva, J. and de Rijke, M.  [paper](https://arxiv.org/pdf/1910.05587.pdf)

105. A stable variational autoencoder for text modelling.  Li, R. and Li, X. and Lin, C. and Collinson, M. and Mao, R. [paper](https://abdn.pure.elsevier.com/en/publications/a-stable-variational-autoencoder-for-text-modelling)

106. Hamiltonian generative networks.  Toth, Rezende, Jaegle, Racaniere, Botev, Higgins  [paper](https://128.84.21.199/pdf/1909.13789.pdf)

107. LAVAE: Disentangling location and appearance. Dittadi, Winther  [paper](https://arxiv.org/pdf/1909.11813.pdf)

108. Interpretable models in probabilistic machine learning. Kim [paper](https://ora.ox.ac.uk/objects/uuid:b238ed7d-7155-4860-960e-6227c7d688fb/download_file?file_format=pdf&safe_filename=PhD_Thesis_of_University_of_Oxford.pdf&type_of_work=Thesis)


109. Disentangling speech  and non-speech components for building robust acoustic models from found data.  Gurunath, Rallabandi, Black [paper](https://arxiv.org/pdf/1909.11727.pdf)

110. Joint separation, dereverberation and classification of multiple sources using multichannel variational autoencoder with auxiliary classifier.  Inoue, Kameoka, Li, Makino  [paper](http://pub.dega-akustik.de/ICA2019/data/articles/000906.pdf)

111. SuperVAE: Superpixelwise variational autoencoder for salient object detection.  Li, Sun, Guo  [paper](https://www.aaai.org/ojs/index.php/AAAI/article/view/4876)

112. Implicit discriminator in variational autoencoder.  Munjal, Paul, Krishnan [paper]( https://arxiv.org/pdf/1909.13062.pdf)

113. TransGaGa: Geometry-aware unsupervised image-to-image translation.  Wu, Cao, Li, Qian, Loy  [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Wu_TransGaGa_Geometry-Aware_Unsupervised_Image-To-Image_Translation_CVPR_2019_paper.pdf)

114. Variational attention using articulatory priors for generating code mixed speech using monolingual corpora. Rallabandi, Black.  [paper](https://www.isca-speech.org/archive/Interspeech_2019/pdfs/1103.pdf)

115. One-class collaborative filtering with the queryable variational autoencoder. Wu, Bouadjenek, Sanner. [paper](https://people.eng.unimelb.edu.au/mbouadjenek/papers/SIGIR_Short_2019.pdf)

116. Predictive auxiliary variational autoencoder for representation learning of global speech characteristics.  Springenberg, Lakomkin, Weber, Wermter. [paper](https://www.isca-speech.org/archive/Interspeech_2019/pdfs/2845.pdf)

117. Data augmentation using variational autoencoder for embedding based speaker verification. Wu, Wang, Qian, Yu  [paper](https://zhanghaowu.me/assets/VAE_Data_Augmentation_proceeding.pdf)

118. One-shot voice conversion with disentangled representations by leveraging phonetic posteriograms. Mohammadi, Kim. [paper](https://www.isca-speech.org/archive/Interspeech_2019/pdfs/1798.pdf)

119. EEG-based adaptive driver-vehicle interface using variational autoencoder and PI-TSVM.  Bi, Zhang, Lian [paper](https://www.researchgate.net/profile/Luzheng_Bi2/publication/335619300_EEG-Based_Adaptive_Driver-Vehicle_Interface_Using_Variational_Autoencoder_and_PI-TSVM/links/5d70bb234585151ee49e5a30/EEG-Based-Adaptive-Driver-Vehicle-Interface-Using-Variational-Autoencoder-and-PI-TSVM.pdf)

120. Neural gaussian copula for variational autoencoder  Wang, Wang  [paper](https://arxiv.org/pdf/1909.03569.pdf)

121. Enhancing VAEs for collaborative filtering: Flexible priors and gating mechanisms.  Kim, Suh  [paper](http://delivery.acm.org/10.1145/3350000/3347015/p403-kim.pdf?ip=86.162.136.199&id=3347015&acc=OPEN&key=4D4702B0C3E38B35%2E4D4702B0C3E38B35%2E4D4702B0C3E38B35%2E6D218144511F3437&__acm__=1568726810_89cfa7cbc7c1b0663405d4446f9fce85)

122. Riemannian normalizing flow on variational wasserstein autoencoder for text modeling. Wang, Wang [paper](https://arxiv.org/pdf/1904.02399.pdf)

123. Disentanglement with hyperspherical latent spaces using diffusion variational autoencoders. Rey [paper](https://openreview.net/pdf?id=SylFDSU6Sr)

124. Learning deep representations by mutual information estimation and maximization.  Hjelm, Fedorov, Lavoie-Marchildon, Grewal, Bachman, Trischler, Bengio [paper](https://arxiv.org/pdf/1808.06670.pdf) [code](https://github.com/rdevon/DIM)

125. Novel tracking approach based on fully-unsupervised disentanglement of the geometrical factors of variation.  Vladymyrov, Ariga [paper](https://arxiv.org/pdf/1909.04427.pdf)

126. Real time trajectory prediction using conditional generative models.  Gomez-Gonzalez, Prokudin, Scholkopf, Peters [paper](https://arxiv.org/pdf/1909.03895.pdf)

127. Disentanglement challenge: from regularization to reconstruction. Qiao, Li, Cai [paper](https://openreview.net/pdf?id=ByecPrUaHH)

128. Improved disentanglement through aggregated convolutional feature maps. Seitzer [paper](https://openreview.net/pdf?id=ryxOvH86SH)

129. Linked variational autoencoders for inferring substitutable and supplementary items.  Rakesh, Wang, Shu [paper](http://www.public.asu.edu/~skai2/files/wsdm_2019_lvae.pdf)

130. On the fairness of disentangled representations.  Locatello, Abbati, Rainforth, Bauer, Scholkopf, Bachem  [paper](https://arxiv.org/pdf/1905.13662.pdf)

131. Learning robust representations by projecting superficial statistics out. Wang, He, Lipton, Xing  [paper](https://openreview.net/pdf?id=rJEjjoR9K7)

132. Understanding posterior collapse in generative latent variable models.  Lucas, Tucker, Grosse, Norouzi  [paper](https://openreview.net/pdf?id=r1xaVLUYuE)

133. On the transfer of inductive bias from simulation to the real world: a new disentanglement dataset. Gondal, Wuthrich, Miladinovic, Locatello, Breidt, Volchkv, Akpo, Bachem, Scholkopf, Bauer [paper](https://arxiv.org/pdf/1906.03292.pdf)  [code](https://github.com/rr-learning/disentanglement_dataset)

134. DIVA: domain invariant variational autoencoder. Ilse, Tomczak, Louizos, Welling [paper](https://arxiv.org/pdf/1905.10427.pdf) [code](https://github.com/AMLab-Amsterdam/DIVA)

135. Comment: Variational Autoencoders as empirical Bayes. Wang, Miller, Blei  [paper](http://www.stat.columbia.edu/~yixinwang/papers/WangMillerBlei2019.pdf )

136. Fast MVAE: joint separation and classification of mixed sources based on multichannel variational autoencoder with auxiliary classifier.  Li, Kameoka, Makino [paper](https://ieeexplore.ieee.org/abstract/document/8682623 )

137. Reweighted expectation maximization.  Dieng, Paisley  [paper](https://arxiv.org/pdf/1906.05850.pdf)   [code](https://github.com/adjidieng/REM)

138. Semisupervised text classification by variational autoencoder.  Xu, Tan [paper](https://ieeexplore.ieee.org/abstract/document/8672806 )

139. Learning deep latent-variable MRFs with amortized Bethe free-energy minimization. Wiseman [paper](https://openreview.net/pdf?id=ByeMHULt_N)

140. Contrastive variational autoencoder enhances salient features.  Abid, Zou [paper](https://arxiv.org/pdf/1902.04601.pdf) [code](https://github.com/abidlabs/contrastive_vae)

141. Learning latent superstructures in variational autoencoders for deep multidimensional clustering. Li, Chen, Poon, Zhang [paper](https://openreview.net/pdf?id=SJgNwi09Km)


142. Tighter variational bounds are not necessarily better.  Rainforth, Kosiorek, Le, Maddison, Igl, Wood, The [paper](https://arxiv.org/pdf/1802.04537.pdf)  [code](https://github.com/lxuechen/DReG-PyTorch)

143. ISA-VAE: Independent subspace analysis with variational autoencoders. Anon. [paper](https://openreview.net/pdf?id=rJl_NhR9K7)


144. Manifold mixup: better representations by interpolating hidden states. Verma, Lamb, Beckham, Najafi, Mitliagkas, Courville, Lopez-Paz, Bengio. 
[paper](https://arxiv.org/pdf/1806.05236.pdf ) [code](https://github.com/vikasverma1077/manifold_mixup)

145. Bit-swap: recursive bits-back coding for lossless compression with hierarchical latent variables. Kingma, Abbeel, Ho.[paper]( http://proceedings.mlr.press/v97/kingma19a/kingma19a.pdf ) [code](https://github.com/fhkingma/bitswap)

146. Practical lossless compression with latent variables using bits back coding.  Townsend, Bird, Barber. [paper](https://arxiv.org/pdf/1901.04866.pdf)  [code](https://github.com/bits-back/bits-back)

147. BIVA:  a very deep hierarchy of latent variables for generative modeling. Maaloe, Fraccaro, Lievin, Winther.  [paper](https://arxiv.org/pdf/1902.02102.pdf)

148. Flow++: improving flow-based generative models with variational dequantization and architecture design. Ho, Chen, Srinivas, Duan, Abbeel. [paper](https://arxiv.org/pdf/1902.00275.pdf)  [code](https://github.com/aravindsrinivas/flowpp)

149. Sylvester normalizing flows for variational inference.  van den Berg, Hasenclever, Tomczak, Welling.  [paper](https://arxiv.org/pdf/1803.05649.pdf)  [code](https://github.com/riannevdberg/sylvester-flows)

150. Unbiased implicit variational inference.  Titsias, Ruiz.  [paper](https://arxiv.org/pdf/1808.02078.pdf)

151. Robustly disentangled causal mechanisms: validating deep representations for interventional robustness.   Suter, Miladinovic, Scholkopf, Bauer. [paper](https://arxiv.org/pdf/1811.00007.pdf)

152. Tutorial: Deriving the standard variational autoencoder (VAE) loss function.  Odaibo  [paper](https://arxiv.org/pdf/1907.08956.pdf)

153. Learning disentangled representations with reference-based variational autoencoders.  Ruiz, Martinez, Binefa, Verbeek.  [paper](https://arxiv.org/pdf/1901.08534)

154. Disentangling factors of variation using few labels.  Locatello, Tschannen, Bauer, Ratsch, Scholkopf, Bachem  [paper](https://arxiv.org/pdf/1905.01258.pdf ) 

155. Disentangling disentanglement in variational autoencoders Mathieu, Rainforth, Siddharth, The, [paper](https://arxiv.org/pdf/1812.02833.pdf)  [code](https://github.com/iffsid/disentangling-disentanglement)

156. LIA: latently invertible autoencoder with adversarial learning  Zhu, Zhao, Zhang  [paper](https://arxiv.org/pdf/1906.08090.pdf ) 

157. Emerging disentanglement in auto-encoder based unsupervised image content transfer. Press, Galanti, Benaim, Wolf  [paper](https://openreview.net/pdf?id=BylE1205Fm) [code](https://github.com/oripress/ContentDisentanglement)

158. MAE: Mutual posterior-divergence regularization for variational autoencoders  Ma, Zhou, Hovy  [paper](https://arxiv.org/pdf/1901.01498.pdf) [code](https://github.com/XuezheMax/mae)

159. Overcoming the disentanglement vs reconstruction trade-off via Jacobian supervision.  Lezama  [paper](https://openreview.net/pdf?id=Hkg4W2AcFm) [code](https://github.com/jlezama/disentangling-jacobian) [code](https://github.com/jlezama/disentangling-jacobian/tree/master/unsupervised_disentangling)

160. Challenging common assumptions in the unsupervised learning of disentangled representations.  Locatello, Bauer, Lucic, Ratsch, Gelly, Scholkopf, Bachem [paper](https://arxiv.org/abs/1811.12359) [code](https://github.com/google-research/disentanglement_lib/blob/master/README.md)

161. Variational prototyping encoder: one shot learning with prototypical images.  Kim, Oh, Lee, Pan, Kweon  [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Kim_Variational_Prototyping-Encoder_One-Shot_Learning_With_Prototypical_Images_CVPR_2019_paper.pdf ) 

162. Diagnosing and enchanving VAE models (conf and journal paper both available). Dai, Wipf [paper](https://arxiv.org/pdf/1903.05789.pdf)  [code](https://github.com/daib13/TwoStageVAE)

163. Disentangling latent hands for image synthesis and pose estimation. Yang, Yao [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Yang_Disentangling_Latent_Hands_for_Image_Synthesis_and_Pose_Estimation_CVPR_2019_paper.pdf )

164. Rare event detection using disentangled representation learning.  Hamaguchi, Sakurada, Nakamura [paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Hamaguchi_Rare_Event_Detection_Using_Disentangled_Representation_Learning_CVPR_2019_paper.pdf) 

165. Disentangling latent space for VAE by label relevant/irrelvant dimensions.  Zheng, Sun  [paper](https://arxiv.org/pdf/1812.09502.pdf)  [code](https://github.com/ZhilZheng/Lr-LiVAE)

166. Variational autoencoders pursue PCA directions (by accident). Rolinek, Zietlow, Martius [paper](https://arxiv.org/pdf/1812.06775.pdf)  

167. Disentangled Representation learning for 3D face shape. Jiang, Wu, Chen, Zhang  [paper](https://arxiv.org/pdf/1902.09887.pdf) [code](https://github.com/zihangJiang/DR-Learning-for-3D-Face)

168. Preventing posterior collapse with delta-VAEs.  Razavi, van den Oord, Poole, Vinyals  [paper](https://arxiv.org/pdf/1901.03416.pdf)  [code](https://github.com/mattjj/svae)

169. Gait recognition via disentangled representation learning.  Zhang, Tran, Yin, Atoum, Liu, Wan, Wang [paper](https://arxiv.org/pdf/1904.04925.pdf)  

170. Hierarchical disentanglement of discriminative latent features for zero-shot learning.  Tong, Wang, Klinkigt, Kobayashi, Nonaka
[paper](http://openaccess.thecvf.com/content_CVPR_2019/papers/Tong_Hierarchical_Disentanglement_of_Discriminative_Latent_Features_for_Zero-Shot_Learning_CVPR_2019_paper.pdf ) 

171. Generalized zero- and few-shot learning via aligned variational autoencoders. Schonfeld, Ebrahimi, Sinha, Darrell, Akata  [paper](https://arxiv.org/pdf/1812.01784.pdf) [code](https://github.com/chichilicious/Generalized-Zero-Shot-Learning-via-Aligned-Variational-Autoencoders)

172. Unsupervised part-based disentangling of object shape and appearance. Lorenz, Bereska, Milbich, Ommer [paper](https://arxiv.org/pdf/1903.06946.pdf)  

173. A semi-supervised Deep generative model for human body analysis.  de Bem, Ghosh, Ajanthan, Miksik, Siddaharth, Torr [paper](http://www.robots.ox.ac.uk/~tvg/publications/2018/W21P20.pdf)

174. Multi-object representation learning with iterative variational inference.  Greff, Kaufman, Kabra, Watters, Burgess, Zoran, Matthey, Botvinick, Lerchner [paper]( https://arxiv.org/pdf/1903.00450.pdf)  [code](https://github.com/MichaelKevinKelly/IODINE)

175. Generating diverse high-fidelity images with VQ-VAE-2.  Razavi, van den Oord, Vinyals [paper](https://arxiv.org/pdf/1906.00446.pdf) [code](https://github.com/deepmind/sonnet/blob/master/sonnet/examples/vqvae_example.ipynb)  [code](https://github.com/rosinality/vq-vae-2-pytorch)


176. MONet: unsupervised scene decomposition and representation. Burgess, Matthey, Watters, Kabra, Higgins, Botvinick, Lerchner  [paper](https://arxiv.org/pdf/1901.11390.pdf ) 

177. Structured disentangled representations and Hierarchical disentangled representations.  Esmaeili, Wu, Jain, Bozkurt, Siddarth, Paige, Brooks, Dy, van de Meent  [paper](https://arxiv.org/pdf/1804.02086.pdf  )

178. Spatial Broadcast Decoder: A  simple architecture for learning disentangled representations in VAEs.  Watters, Matthey, Burgess, Lerchner [paper](https://arxiv.org/pdf/1901.07017.pdf)  [code](https://github.com/lukaszbinden/spatial-broadcast-decoder)

179. Resampled priors for variational autoencoders.  Bauer, Mnih [paper](https://arxiv.org/pdf/1802.06847.pdf)

180. Weakly supervised disentanglement by pairwise similiarities.  Chen, Batmanghelich [paper](https://arxiv.org/pdf/1906.01044.pdf ) 

181. Deep variational information bottleneck.  Aelmi, Fischer, Dillon, Murphy  [paper](https://arxiv.org/pdf/1612.00410.pdf) [code](https://github.com/alexalemi/vib_demo)

182. Generalized variational inference.  Knoblauch, Jewson, Damoulas [paper](https://arxiv.org/pdf/1904.02063.pdf ) 

183. Variational autoencoders and nonlinear ICA: a unifying framework. Khemakhem, Kingma [paper](https://arxiv.org/pdf/1907.04809.pdf ) 

184. Lagging inference networks and posterior collapse in variational autoencoders.  He, Spokoyny, Neubig, Berg-Kirkpatrick  [paper](https://arxiv.org/pdf/1901.05534.pdf)  [code](https://github.com/jxhe/vae-lagging-encoder)

185. Avoiding latent variable collapse with generative skip models.  Dieng, Kim, Rush, Blei  [paper](https://arxiv.org/pdf/1807.04863.pdf)  

186. Distribution Matching in Variational inference. Rosca, Lakshminarayana, Mohamed [paper](https://arxiv.org/pdf/1802.06847.pdf  )
A variational auto-encoder model for stochastic point process.  Mehrasa, Jyothi, Durand, He, Sigal, Mori  [paper](https://arxiv.org/pdf/1904.03273.pdf)  

187. Sliced-Wasserstein auto-encoders. Kolouri, Pope, Martin, Rohde  [paper](https://openreview.net/pdf?id=H1xaJn05FQ) [code](https://github.com/skolouri/swae)

188. A deep generative model for graph layout. Kwon, Ma  [paper](https://arxiv.org/pdf/1904.12225.pdf ) 

189. Differentiable perturb-and-parse semi-supervised parsing with a structured variational autoencoder. Corro, Titov  [paper](https://openreview.net/pdf?id=BJlgNh0qKQ) [code](https://github.com/FilippoC/diffdp)

190. Variational autoencoders with jointly optimized latent dependency structure.  He, Gong, Marino, Mori, Lehrmann  [paper](https://openreview.net/pdf?id=SJgsCjCqt7)  [code](https://github.com/ys1998/vae-latent-structure)

191. Unsupervised learning of spatiotemporally coherent metrics  Goroshin, Bruna, Tompson, Eigen, LeCun  [paper](https://arxiv.org/pdf/1412.6056.pdf)

192. Temporal difference variational auto-encoder. Gregor, Papamakarios, Besse, Buesing, Weber [paper](https://arxiv.org/pdf/1806.03107.pdf) [code](https://github.com/xqding/TD-VAE)

193. Representation learning with contrastive predictive coding. van den Oord, Li, Vinyals [paper](https://arxiv.org/pdf/1807.03748.pdf) [code](https://github.com/davidtellez/contrastive-predictive-coding)

194. Representation disentanglement  for multi-task learning with application to fetal ultrasound  Meng, Pawlowski, Rueckert, Kainz  [paper](https://arxiv.org/pdf/1908.07885.pdf)

195. M$2$VAE - derivation of a multi-modal variational autoencoder objective from the marginal joint log-likelihood. Korthals  [paper](https://arxiv.org/pdf/1903.07303.pdf)

196. Predicting visual memory schemas with variational autoencoders. Kyle-Davidson, Bors, Evans  [paper](https://arxiv.org/pdf/1907.08514.pdf)

197. T-CVAE: Transformer -based conditioned variational autoencoder for story completion.  Wang, Wan [paper](https://www.ijcai.org/proceedings/2019/0727.pdf) [code](https://github.com/sodawater/T-CVAE)

198. PuVAE: A variational autoencoder to purify adversarial examples.  Hwang, Park, Jang, Yoon, Cho  [paper](https://arxiv.org/pdf/1903.00585.pdf)

200. Coupled VAE: Improved accuracy and robustness of a variational autoencoder.   Cao, Li, Nelson [paper](https://arxiv.org/pdf/1906.00536.pdf)

201. D-VAE: A variational autoencoder for directed acyclic graphs. Zhang, Jiang, Cui, Garnett, Chen  [paper](https://arxiv.org/abs/1904.11088) [code](https://github.com/muhanzhang/D-VAE)

202. Are disentangled representations helpful for abstract reasoning?  van Steenkiste, Locatello, Schmidhuber, Bachem  [paper](https://arxiv.org/pdf/1905.12506.pdf)

203. A heuristic for unsupervised model selection for variational disentangled representation learning.  Duan, Watters, Matthey, Burgess, Lerchner, Higgins  [paper](https://arxiv.org/pdf/1905.12614.pdf)

204. Dual space learning with variational autoencoders.  Okamoto, Suzuki, Higuchi, Ohsawa, Matsuo  [paper](https://pdfs.semanticscholar.org/ea70/6495d4a6214b3d6174bb7fd99c5a9c34c2e6.pdf)

205. Variational autoencoders for sparse and overdispersed discrete data.  Zhao, Rai, Du, Buntine  [paper](https://arxiv.org/pdf/1905.00616.pdf)

206. Variational auto-decoder. Zadeh, Lim, Liang, Morency. [paper](https://arxiv.org/pdf/1903.00840.pdf)

207. Causal discovery with attention-based convolutional neural networks.  Naura, Bucur, Seifert   [paper](https://www.mdpi.com/2504-4990/1/1/19/pdf)

208. Variational laplace autoencoders. Park, Kim, Kim  [paper](http://proceedings.mlr.press/v97/park19a/park19a.pdf)

209. Variational autoencoders with normalizing flow decoders.    [paper](https://openreview.net/forum?id=r1eh30NFwB)

210. Gaussian process priors for view-aware inference. Hou, Heljakka, Solin [paper]( https://arxiv.org/pdf/1912.03249.pdf)

211. SGVAE: sequential graph variational autoencoder.  Jing, Chi, Tang [paper](https://arxiv.org/pdf/1912.07800.pdf ) 

212. improving multimodal generative models with disentangled latent partitions. Daunhawer, Sutter, Vogt [paper](http://bayesiandeeplearning.org/2019/papers/103.pdf )

213. Cross-population variational autoencoders.  Davison, Severson, Ghosh  [paper](https://openreview.net/pdf?id=r1eWdlBFwS) [paper](http://bayesiandeeplearning.org/2019/papers/96.pdf )

214. Evidential disambiguation of latent multimodality in conditional variational autoencoders.  Itkina, Ivanovic, Senanayake, Kochenderfer, Pavone  [paper](http://bayesiandeeplearning.org/2019/papers/34.pdf )

215. Increasing the generalisation capacity of conditional VAEs. Klushyn, Chen, Cseke, Bayer, van der Smagt  [paper](https://link.springer.com/chapter/10.1007/978-3-030-30484-3_61 ) 

216. Multi-source neural variational inference.  Kurle, Gunnemann, van der Smagt [paper](https://wvvw.aaai.org/ojs/index.php/AAAI/article/view/4311 ) 

217. Early integration for movement modeling in latent spaces. Hornung, Chen, van der Smagt [paper]( https://books.google.co.uk/books?hl=en&lr=&id=M1WfDwAAQBAJ&oi=fnd&pg=PA305&dq=info:MRhvAh4qD7wJ:scholar.google.com&ots=hN84xN5saO&sig=TBMgkFo6z9wrL64TcvzjU4G5gCQ&redir_esc=y#v=onepage&q&f=false)
  
218. Building face recognition system with triplet-based stacked variational denoising autoencoder.  LEe, Hart, Richens, Johri [paper](https://dl.acm.org/citation.cfm?id=3369707  )

219. Cross-domain variational autoencoder for recommender systems. Shi, Wang  [paper](https://ieeexplore.ieee.org/abstract/document/8935901 ) 
Predictive coding, variational autoencoders, and biological connections.  Marino  [paper](https://openreview.net/pdf?id=SyeumQYUUH ) 

220. A general and adaptive robust loss function Barron  [paper](https://arxiv.org/pdf/1701.03077.pdf ) 

221. Variational autoencoder trajectory primitives and discrete latent. Osa, Ikemoto [paper](https://arxiv.org/pdf/1912.04063.pdf  )

222. Faster attend-infer-repeat with tractable probabilistic models. Stelzner, Peharz, Kersting  [paper](http://proceedings.mlr.press/v97/stelzner19a/stelzner19a.pdf)  [code](https://github/stelzner/supair)

223. Learning predictive models from observation and interaction.  Schmeckpeper, Xie, Rybkin, Tian, Daniilidis, Levine, Finn [paper](https://arxiv.org/pdf/1912.12773.pdf)

224. Translating visual art into music Muller-Eberstein, van Noord [paper](http://openaccess.thecvf.com/content_ICCVW_2019/papers/CVFAD/Muller-Eberstein_Translating_Visual_Art_Into_Music_ICCVW_2019_paper.pdf)

225. Non-parallel voice conversion with controllable speaker individuality using variational autoencoder.  Ho, Akagi [paper]( http://www.apsipa.org/proceedings/2019/pdfs/68.pdf)

226. Derivation of the variational Bayes equations.  Maren [paper](https://arxiv.org/pdf/1906.08804.pdf)



#### 2019 (with code)

1. Explicitly disentangling image content from translation and rotation with spatial-VAE Tristan W Bepler, Ellen Zhong, Kotaro Kelley, Edward Brignole, Bonnie Berger [paper](https://openreview.net/pdf?id=Hyl66SBgIS ) [code](https://github.com/tbepler/spatial-VAE ) 

2. Diagnosing and Enhancing VAE Models.  Bin Dai, David Wipf [paper](https://openreview.net/pdf?id=B1e0X3C9tQ ) [code](https://github.com/daib13/TwoStageVAE%7D) 

3. D-VAE: A Variational Autoencoder for Directed Acyclic Graphs  Muhan Zhang, Shali Jiang, Zhicheng Cui, Roman Garnett, Yixin Chen [paper](https://openreview.net/pdf?id=r1lIr4BgIS  ) [code](https://github.com/muhanzhang/D-VAE )

4. Good Semi-supervised VAE Requires Tighter Evidence Lower Bound  Haozhe Feng, Kezhi Kong, Tianye Zhang, Siyue Xue, Wei Chen [paper](https://openreview.net/pdf?id=S1ejj64YvS  ) [code](https://github.com/PaperCodeSubmission/ICML2020-697 )

5. An Information Theoretic Perspective on Disentangled Representation Learning  Xiaojiang Yang, Wendong Bi, Yu Cheng, Junchi Yan [paper](https://openreview.net/pdf?id=rJlhYa4FPB  ) [code](https://github.com/website-for-iclr/our-dlib  )

6. Good Semi-supervised VAE Requires Tighter Evidence Lower Bound  Haozhe Feng, Kezhi Kong, Tianye Zhang, Siyue Xue, Wei Chen [paper]( https://openreview.net/pdf?id=S1ejj64YvS  ) [code](https://github.com/PaperCodeSubmission/ICML2020-697 )

7. Disentanglement by Nonlinear ICA with General Incompressible-flow Networks (GIN)  Peter Sorrenson, Carsten Rother, Ullrich Köthe  [paper](https://openreview.net/pdf?id=rygeHgSFDH  ) [code](https://github.com/deepmind/dsprites-dataset)  

8. RTC-VAE: HARNESSING THE PECULIARITY OF TOTAL CORRELATION IN LEARNING DISENTANGLED REPRESENTATIONS   Ze Cheng, Juncheng B Li, Chenxu Wang, Jixuan Gu, Hao Xu, Xinjian Li, Florian Metze [paper]( https://openreview.net/pdf?id=SkeuipVKDH  ) [code](https://github.com/google-research/disentanglement_lib ) 

9. RaCT: Toward Amortized Ranking-Critical Training For Collaborative Filtering  Sam Lobel*, Chunyuan Li*, Jianfeng Gao, Lawrence Carin  [paper](https://openreview.net/pdf?id=HJxR7R4FvS ) [code](https://github.com/samlobel/RaCT_CF )

10. Augmenting Genetic Algorithms with Deep Neural Networks for Exploring the Chemical Space  AkshatKumar Nigam, Pascal Friederich, Mario Krenn, Alan Aspuru-Guzik [paper](https://openreview.net/pdf?id=H1lmyRNFvr ) [code](https://github.com/aspuru-guzik-group/GA ) 

11. Explicitly disentangling image content from translation and rotation with spatial-VAE   Tristan W Bepler, Ellen Zhong, Kotaro Kelley, Edward Brignole, Bonnie Berger  [paper](https://openreview.net/pdf?id=Hyl66SBgIS ) [code](https://github.com/tbepler/spatial-VAE ) 

12. Learning to Dress 3D People in Generative Clothing  Qianli Ma, Jinlong Yang, Anurag Ranjan, Sergi Pujades, Gerard Pons-Moll, Siyu Tang, Michael J. Black [paper]( https://arxiv.org/pdf/1907.13615 ) 

13. Don't Blame the ELBO! A Linear VAE Perspective on Posterior Collapse  James Lucas, George Tucker, Roger B. Grosse, Mohammad Norouzi [paper]( http://papers.nips.cc/paper/9138-dont-blame-the-elbo-a-linear-vae-perspective-on-posterior-collapse.pdf )

14. Generating Diverse High-Resolution Images with VQ-VAE Ali Razavi, Aaron van den Oord, Oriol Vinyals [paper](https://openreview.net/pdf?id=ryeBN88Ku4  ) 

15. WiSE-ALE: Wide Sample Estimator for Approximate Latent Embedding. Shuyu Lin, Ronald Clark, Robert Birke, Niki Trigoni, Stephen Roberts   [paper](https://arxiv.org/pdf/1902.06160.pdf )

16. Diagnosing and Enhancing VAE Models.  Bin Dai, David Wipf [paper](https://arxiv.org/pdf/1903.05789.pdf ) 

17. VV-Net: Voxel VAE Net With Group Convolutions for Point Cloud Segmentation. Hsien-Yu Meng, Lin Gao, Yu-Kun Lai, Dinesh Manocha  [paper](http://openaccess.thecvf.com/content_ICCV_2019/papers/Meng_VV-Net_Voxel_VAE_Net_With_Group_Convolutions_for_Point_Cloud_ICCV_2019_paper.pdf )  

18. Uncertainty Analysis of VAE-GANs for Compressive Medical Imaging  Mardani, Joseph Cheng, Shreyas Vasanawala, John Pauly [paper](https://arxiv.org/pdf/1901.11228.pdf  )

19. Disentangling Latent Space for VAE by Label Relevant/Irrelevant Dimensions. Zhilin Zheng, Li Sun    [paper]( http://openaccess.thecvf.com/content_CVPR_2019/papers/Zheng_Disentangling_Latent_Space_for_VAE_by_Label_RelevantIrrelevant_Dimensions_CVPR_2019_paper.pdf )

20. Dr.VAE: improving drug response prediction via modeling of drug perturbation effects. Ladislav Rampášek, Daniel Hidru, Petr Smirnov, Benjamin Haibe-Kains, Anna Goldenberg  [paper](https://academic.oup.com/bioinformatics/article-pdf/35/19/3743/30061484/btz158.pdf )

21. PQ-VAE:EfficientRecommendation UsingQuantizedEmbeddings Jan Van Balen, Mark Levy  [paper](http://ceur-ws.org/Vol-2431/paper10.pdf )

22. Bayes-Factor-VAE: Hierarchical Bayesian Deep Auto-Encoder Models for Factor Disentanglement Minyoung Kim, Yuting Wang, Pritish Sahu, Vladimir Pavlovic [paper]( http://openaccess.thecvf.com/content_ICCV_2019/papers/Kim_Bayes-Factor-VAE_Hierarchical_Bayesian_Deep_Auto-Encoder_Models_for_Factor_Disentanglement_ICCV_2019_paper.pdf )

23. Improving VAE generations of multimodal data through data-dependent conditional priors.   Frantzeska Lavda, Magda Gregorová, Alexandros Kalousis [paper]( https://arxiv.org/pdf/1911.10885 )

24. D-VAE: A Variational Autoencoder for Directed Acyclic Graphs  Muhan Zhang, Shali Jiang, Zhicheng Cui, Roman Garnett, Yixin Chen [paper]( http://papers.nips.cc/paper/8437-d-vae-a-variational-autoencoder-for-directed-acyclic-graphs.pdf  )  

25. Explicitly disentangling image content from translation and rotation with spatial-VAE Tristan Bepler, Ellen Zhong, Kotaro Kelley, Edward Brignole, Bonnie Berger [paper]( http://papers.nips.cc/

26. paper/9677-explicitly-disentangling-image-content-from-translation-and-rotation-with-spatial-vae.pdf  ) 

27. Solving Inverse Problems by Joint Posterior Maximization with a VAE Prior.  Mario González, Andrés Almansa, Mauricio Delbracio, Pablo Musé, Pauline Tan [paper](https://arxiv.org/pdf/1911.06379  ) 

28. ODE2VAE: Deep generative second order ODEs with Bayesian neural networks. Çağatay Yıldız, Markus Heinonen, Harri Lähdesmäki [paper](https://arxiv.org/pdf/1905.10994 ) 

29. Relevance Factor VAE: Learning and Identifying Disentangled Factors Minyoung Kim, Yuting Wang, Pritish Sahu, Vladimir Pavlovic  [paper](https://arxiv.org/pdf/1902.01568.pdf  )

30. Joint haze image synthesis and dehazing with mmd-vae losses Zongliang Li, Chi Zhang, Gaofeng Meng, Yuehu Liu  [paper](https://arxiv.org/pdf/1905.05947  )

31. Semi-supervised Open Domain Information Extraction with Conditional VAE Zhengbao Jiang (zhengbaj), Songwei Ge (songweig), Ruohong Zhang (ruohongz), Donghan Yu (dyu2)[paper]( https://sailinglab.github.io/pgm-spring-2019/assets/project/final-reports/project22.pdf )  

32. Inf-VAE: A Variational Autoencoder Framework to Integrate Homophily and Influence in Diffusion Prediction.  Aravind Sankar, Xinyang Zhang, Adit Krishnan, Jiawei Han  [paper](https://arxiv.org/pdf/2001.00132)   

33. Sequential VAE-LSTM for Anomaly Detection on Time Series. Run-Qing Chen, Guang-Hui Shi, Wan-Lei Zhao, Chang-Hui Liang [paper](https://arxiv.org/pdf/1910.03818  )  

34. Bayesian EDDI: Sequential Variable Selection with Bayesian Partial VAE. Chao Ma, Wenbo Gong, SebastianTschiatschek2 Sebastian Tschiatschek, Sebastian Nowozin, José Miguel Hernández-Lobato, Cheng Zhang [paper]( http://www.tschiatschek.net/files/ma2019BayesianEDDI.pdf )

35. Increasing Expressivity of a Hyperspherical VAE Tim R. Davidson, Jakub M. Tomczak, Efstratios Gavves  [paper](https://arxiv.org/pdf/1910.02912 )

36. VAE-based regularization for deep speaker embedding.  Yang Zhang, Lantian Li, Dong Wang [paper](https://arxiv.org/pdf/1904.03617 )

37. G-VAE: A Continuously Variable Rate Deep Image Compression Framework. Ze Cui, Jing Wang, Bo Bai, Tiansheng Guo, Yihui Feng  [paper](https://arxiv.org/pdf/2003.02012)  

38. Multi-Angle Point Cloud-VAE: Unsupervised Feature Learning for 3D Point Clouds from Multiple Angles by Joint Self-Reconstruction and Half-to-Half Prediction  Zhizhong Han, Xiyang Wang, Yu-Shen Liu, Matthias Zwicker  [paper](https://arxiv.org/pdf/1907.12704 )   

39. Coupled VAE: Improved Accuracy and Robustness of a Variational Autoencoder. Shichen Cao, Jingjing Li, Kenric P. Nelson, Mark A. Kon [paper](https://arxiv.org/pdf/1906.00536)    

40. The Usual Suspects? Reassessing Blame for VAE Posterior Collapse. Bin Dai, Ziyu Wang, David Wipf  [paper](https://arxiv.org/pdf/1912.10702 )

41. Disentangling the Spatial Structure and Style in Conditional VAE. Ziye Zhang, Li Sun, Zhilin Zheng, Qingli Li [paper](https://arxiv.org/pdf/1910.13062)

42. Inspecting and Interacting with Meaningful Music Representations using VAE. Ruihan Yang, Tianyao Chen, Yiyi Zhang, Gus Xia [paper]( https://arxiv.org/pdf/1904.08842 )

43. An Interactive Insight Identification and Annotation Framework for Power Grid Pixel Maps using DenseU-Hierarchical VAE. Tianye Zhang, Haozhe Feng, Zexian Chen, Can Wang, Yanhao Huang, Yong Tang, Wei Chen [paper]( https://arxiv.org/pdf/1905.12164 )   

44. Class-Conditional VAE-GAN for Local-Ancestry Simulation.  Daniel Mas Montserrat, Carlos Bustamante, Alexander Ioannidis [paper](https://arxiv.org/pdf/1911.13220)

45. VAE-based Domain Adaptation for Speaker Verification.   Xueyi Wang, Lantian Li, Dong Wang [paper](https://arxiv.org/pdf/1908.10092)   

46. Constructing the Matrix Multilayer Perceptron and its Application to the VAE. Jalil Taghia, Maria Bånkestad, Fredrik Lindsten, Thomas B. Schön  [paper](https://arxiv.org/pdf/1902.01182 )   

47. Dynamic Narrowing of VAE Bottlenecks Using GECO and L0 Regularization.  Cedric De Boom, Samuel Wauthier, Tim Verbelen, Bart Dhoedt [paper]( https://arxiv.org/pdf/2003.10901 )   

48. MIDI-Sandwich2: RNN-based Hierarchical Multi-modal Fusion Generation VAE networks for multi-track symbolic music generation.  Xia Liang, Junmin Wu, Jing Cao [paper]( https://arxiv.org/pdf/1909.03522 )  

49. Program Synthesis and Vulnerability Injection Using a Grammar VAE Leonard Kosta, Laura Seaman, Hongwei Xi [paper](https://pdfs.semanticscholar.org/e21b/233996437b0bafdb253fe18c29b5b535ce7b.pdf )  

50. SAG-VAE: End-to-end Joint Inference of Data Representations and Feature Relations Chen Wang, Chengyuan Deng, Vladimir Ivanov  [paper](https://arxiv.org/pdf/1911.11984 )  

51. A Closer Look at Disentangling in β-VAE.  Harshvardhan Sikka, Weishun Zhong, Jun Yin, Cengiz Pehlevan [paper](https://arxiv.org/pdf/1912.05127 )   
52. Mixture of Inference Networks for VAE-based Audio-visual Speech Enhancement.  Mostafa Sadeghi, Xavier Alameda-Pineda  [paper](https://arxiv.org/pdf/1912.10647 ) 

53. CBN-VAE: A Data Compression Model with Efficient Convolutional Structure for Wireless Sensor Networks.  Jianlin Liu, Fenxiong Chen,Jun Yan and Dianhong Wang [paper]( https://www.mdpi.com/1424-8220/19/16/3445/pdf )  

54. Generated Loss and Augmented Training of MNIST VAE. Jason Chou  [paper](https://arxiv.org/pdf/1904.10937)  

55. Learning Facial Recognition Biases through VAE Latent Representations.  Diego  Celis, Meghana  Rao  [paper](https://dl.acm.org/doi/pdf/10.1145/3347447.3356752 )

56. The Gaussian Process Prior VAE for Interpretable Latent Dynamics from Pixels  Michael Pearce [paper]( http://proceedings.mlr.press/v118/pearce20a/pearce20a.pdf )  

57. Class-Conditional VAE-GAN for Local-Ancestry Simulation.  Daniel Mas Montserrat, Carlos Bustamante, Alexander Ioannidis [paper]( https://arxiv.org/pdf/1911.13220.pdf  )

58. Investigating GAN and VAE to Train DCNN   Soundararajan Ezekiel, Larry Pearlstein, Abdullah Ali Alshehri, Adam Lutz, Jackson Zaunegger, and Waleed Farag [paper]( http://www.ijmlc.org/vol9/872-AM1002.pdf)    

59. MIDI-Sandwich: Multi-model Multi-task Hierarchical Conditional VAE-GAN networks for Symbolic Single-track Music Generation. Xia Liang, Junmin Wu, Yan Yin [paper](https://arxiv.org/pdf/1907.01607  )  

60. Generated Loss, Augmented Training, and Multiscale VAE. Jason Chou, Gautam Hathi [paper]( https://arxiv.org/pdf/1904.10446  )

61. Based on Graph-VAE Model to Predict Student's Score.  Yang Zhang, Mingming Lu [paper](https://arxiv.org/pdf/1903.03609 )

61. Graph Embedding VAE: A Permutation Invariant Model of Graph Structure.  Tony Duan, Juho Lee [paper](https://arxiv.org/pdf/1910.08057 ) 

62. Wyner VAE: Joint and Conditional Generation with Succinct Common Representation Learning. J. Jon Ryu, Yoojin Choi, Young-Han Kim, Mostafa El-Khamy, Jungwon Lee [paper](https://arxiv.org/pdf/1905.10945 )   

63. VAE-PGN based Abstractive Model in Multi-stage Architecture for Text Summarization. Hyungtak Choi, Lohith Ravuru, Tomasz Dryjanski, Seonghan Ryu, Donghyun Lee, Hojung Lee and Inchu Hwang  [paper](https://www.aclweb.org/anthology/W19-8664.pdf )

64. Effect of VAE Latex Powder Addition on Tensile and Shear Properties of Styrene-Acrylate Based Cement Composite Joint Compound Meng Boxu, Xu Jinyu, Gu Chao and Peng guang[paper](https://iopscience.iop.org/article/10.1088/1755-1315/242/3/032063/pdf )  

65. BooVAE: A scalable framework for continual VAE learning under boosting approach Anna Kuzina, Evgenii Egorov, Evgeny Burnaev [paper](https://arxiv.org/pdf/1908.11853  )  

66. ρ-VAE: Autoregressive parametrization of the VAE encoder. Sohrab Ferdowsi, Maurits Diephuis, Shideh Rezaeifar, Slava Voloshynovskiy [paper](https://arxiv.org/pdf/1909.06236 ) 

67. M2VAE - Derivation of a Multi-Modal Variational Autoencoder Objective from the Marginal Joint Log-Likelihood. Timo Korthals [paper](https://arxiv.org/pdf/1903.07303  )  

68. Progressive VAE Training on Highly Sparse and Imbalanced Data.  Dmitry Utyamishev, Inna Partin-Vaisband [paper](https://arxiv.org/pdf/1912.08283 )  

69. retina-VAE: Variationally Decoding the Spectrum of Macular Disease. Stephen G. Odaibo [paper](https://arxiv.org/pdf/1907.05195  )

70. GP-VAE: Deep Probabilistic Time Series Imputation.  Vincent Fortuin, Dmitry Baranchuk, Gunnar Rätsch, Stephan Mandt [paper](https://arxiv.org/pdf/1907.04155  )

71. Latent Space Expanded Variational Autoencoder for Sentence Generation.  TIANBAO SONG , JINGBO SUN, BO CHEN, WEIMING PENG, AND JIHUA SONG  [paper](https://ieeexplore.ieee.org/stamp/stamp.jsp?tp=&arnumber=8853312 )   


72. RecVAE: a New Variational Autoencoder for Top-N Recommendations with Implicit Feedback. Ilya Shenbin, Anton Alekseev, Elena Tutubalina [paper]( https://arxiv.org/pdf/1912.11160.pdf  )  

73. Concept Saliency Maps to Visualize Relevant Features in Deep Generative Models. Lennart Brocki, Neo Christopher Chung [paper](https://arxiv.org/pdf/1910.13140.pdf   ) 

74. MIDI-Sandwich2: RNN-based Hierarchical Multi-modal Fusion Generation VAE networks for multi-track symbolic music generation Xia Liang, Junmin Wu and Jing Cao [paper]( https://arxiv.org/pdf/1909.03522.pdf )

75. SCALABLE MODELING OF SPATIOTEMPORAL DATA USING THE VARIATIONAL AUTOENCODER: AN APPLICATION IN GLAUCOMA  By Samuel I. Berchuck, Felipe A. Medeiros and Sayan Mukherjee [paper](https://arxiv.org/pdf/1908.09195.pdf  )  

76. Learning Discrete and Continuous Factors of Data via Alternating Disentanglement  Yeonwoo Jeong, Hyun Oh Song [paper](https://arxiv.org/pdf/1905.09432.pdf)

77. Variational Adversarial Active Learning Samarth Sinha, Sayna Ebrahimi, Trevor Darrell [paper](https://arxiv.org/pdf/1904.00370.pdf ) 

78. Using RGB Image as Visual Input for Mapless Robot Navigation  Liulong Ma, Yanjie Liu and Jiao Chen  [paper](https://arxiv.org/ftp/arxiv/papers/1903/1903.09927.pdf  )  

79. Diagnosing and Enhancing VAE Models.  Bin Dai, David Wipf [paper](https://arxiv.org/pdf/1903.05789.pdf )   

80. PRACTICAL LOSSLESS COMPRESSION WITH LATENT VARIABLES USING BITS BACK CODING James Townsend, Thomas Bird & David Barber [paper]( https://arxiv.org/pdf/1901.04866.pdf  )

81. Defense-VAE: A Fast and Accurate Defense against Adversarial Attacks. Xiang Li, and Shihao Ji [paper](https://arxiv.org/pdf/1812.06570.pdf)    




#### 2020

1. GOOD SEMI-SUPERVISED VAE REQUIRES TIGHTER EVIDENCE LOWER BOUND  Haozhe Feng, Kezhi Kong, Tianye Zhang, Siyue Xue, Wei Chen [paper]( https://openreview.net/pdf?id=S1ejj64YvS) [code](https://github.com/PaperCodeSubmission/ICML2020-697 )

2. Learning Discrete and Continuous Factors of Data via Alternating Disentanglement  YeonwooJeong, HyunOhSong [paper]( http://proceedings.mlr.press/v97/jeong19d/jeong19d.pdf ) [code](https://github.com/snu-mllab/DisentanglementICML19  ) [supportingDocs](http://proceedings.mlr.press/v97/jeong19d/jeong19d-supp.pdf)

3. D-VAE: A Variational Autoencoder for Directed Acyclic Graphs  Muhan Zhang, Shali Jiang, Zhicheng Cui, Roman Garnett, Yixin Chen[paper]( https://openreview.net/pdf?id=r1lIr4BgIS  ) [code](https://github.com/muhanzhang/D-VAE )


4. q-VAE for Disentangled Representation Learning and Latent Dynamical Systems.  Taisuke Kobayashi [paper](https://arxiv.org/pdf/2003.01852 )

5. Out-of-Distribution Detection in Multi-Label Datasets using Latent Space of β-VAE.  Vijaya Kumar, Sundar, Shreyas Ramakrishna, Zahra Rahiminasab, Arvind Easwaran, Abhishek Dubey [paper](https://arxiv.org/pdf/2003.08740)    

6. Robust Ordinal VAE: Employing Noisy Pairwise Comparisons for Disentanglement. Junxiang Chen, Kayhan Batmanghelich [paper](https://arxiv.org/pdf/1910.05898 )   

7. Deterministic Decoding for Discrete Data in Variational Autoencoders. Daniil Polykovskiy, Dmitry Vetrov [paper](https://arxiv.org/pdf/2003.02174.pdf )

8. Dimensionality Reduction of SDSS Spectra with Variational Autoencoders. Stephen K. N. Portillo, John K. Parejko, Jorge R. Vergara,  and Andrew J. Connolly [paper]( https://arxiv.org/pdf/2002.10464.pdf )   

9. NeurIPS 2019 Disentanglement Challenge: Improved Disentanglement through Aggregated Convolutional Feature Maps. Maximilian Seitzer [paper]( https://arxiv.org/pdf/2002.10003.pdf  )  

10. An Explicit Local and Global Representation Disentanglement Framework with Applications in Deep Clustering and Unsupervised Object Detection. Rujikorn Charakorn, Yuttapong Thawornwattana, Sirawaj Itthipuripat, Nick Pawlowski, Poramate Manoonpong, and Nat Dilokthanakul  [paper](https://arxiv.org/pdf/2001.08957.pdf )   

11. Re-balancing Variational Autoencoder Loss for Molecule Sequence Generation  Chaochao Yan, Sheng Wang, Jinyu Yang, Tingyang Xu, Junzhou Huang  [paper](https://arxiv.org/pdf/1910.00698.pdf )   

12. RACT: TOWARDS AMORTIZED RANKING-CRITICAL TRAINING FOR COLLABORATIVE FILTERING Sam Lobel, Chunyuan Li, Jianfeng Gao, Lawrence Carin [paper]( https://arxiv.org/pdf/1906.04281.pdf)  


13. Draft and Edit: Automatic Storytelling Through Multi-Pass Hierarchical Conditional Variational Autoencoder. Yu, Li, Liu, Tang, Zhang, Zhao, Yan[paper]( https://www.aaai.org/Papers/AAAI/2020GB/AAAI-YuM.8133.pdf)

14. Reverse variational autoencoder for visual attribute manipulation and anomaly detection.  Gauerhof, Gu [paper]( http://openaccess.thecvf.com/content_WACV_2020/papers/Lydia_Reverse_Variational_Autoencoder_for_Visual_Attribute_Manipulation_and_Anomaly_Detection_WACV_2020_paper.pdf)


15. Bridged variational autoencoders for joint modeling of images and attributes. Yadav, Sarana, Namboodiri, Hegde [paper]( http://openaccess.thecvf.com/content_WACV_2020/papers/Yadav_Bridged_Variational_Autoencoders_for_Joint_Modeling_of_Images_and_Attributes_WACV_2020_paper.pdf)


16. Treatment effect estimation with disentangled latent factors. anon  [paper](https://arxiv.org/abs/2001.10652)

17. Unbalanced GANS: pre-training the generator of generative adversarial network using variational autoencoder.  Ham, Jun, Kim [paper](https://arxiv.org/pdf/2002.02112.pdf)

18. Regularized autoencoders via relaxed injetive probability flow. Kumar, Poole, Murphy [paper](https://arxiv.org/abs/2002.08927)

19. Out-of-distribution detection with distance guarantee in deep generative models.  Zhang, Liu, Chen, Wang, Liu, Li, Wei, Chen  [paper](https://arxiv.org/abs/2002.03328)

20. Balancing reconstruction error and Kullback-Leibler divergence in variational autoencoders. Asperti, Trentin  [paper](https://arxiv.org/pdf/2002.07514.pdf)

21. Data augmentation for historical documents via cascade variational auto-encoder.  Cao, Kamata [paper](https://ieeexplore.ieee.org/abstract/document/8977737)

22. Controlling generative models with continuous factors of variations.  Plumerault, Borgne, Hudelot [paper](https://arxiv.org/pdf/2001.10238.pdf)

23. Towards a controllable disentanglement network. Song, Koyejo, Zhang [paper](https://arxiv.org/abs/2001.08572)

24. Knowledge-induced learning with adaptive sampling variational autoencoders for open set fault diagnostics.  Chao, Adey, Fink  [paper](https://arxiv.org/abs/1912.12502)

25. NestedVAE: isolating common factors via weak supervision. Vowels, Camgoz, Bowden   [paper](https://arxiv.org/abs/2002.11576)

26. Leveraging cross feedback of user and item embeddings for variational autoencoder based collaborative filtering.  Jin, Zhao, Du, Liu, Gao, Li, Xu [paper]( https://arxiv.org/pdf/2002.09145.pdf)

27. K-autoencoders deep clustering. Opochinsky, Chazan, Gannot, Goldberger [paper]( http://www.eng.biu.ac.il/goldbej/files/2020/02/ICASSP_2020_Yaniv.pdf)

28. D2D-TM: a cycle VAE-GAN for multi-domain collaborative filtering. Nguyen, Ishigaki  [paper](https://ieeexplore.ieee.org/abstract/document/9006461/)

29. Disentangling controllable object through video prediction improves visual reinforcement learning.  Zhong, Schwing, Peng  [paper](https://arxiv.org/pdf/2002.09136.pdf)

30. A deep adversarial variational autoencoder model for dimensionality reduction in single-cell RNA sequencing analysis. Lin, Mukherjee, Kannan  [paper](https://bmcbioinformatics.biomedcentral.com/articles/10.1186/s12859-020-3401-5)

31. Context conditional variational autoencoder for predicting multi-path trajectories in mixed traffic.  Cheng, Liao, Yang, Sester, Rosenhahn  [paper](https://arxiv.org/pdf/2002.05966.pdf)

32. Optimizing variational graph autoencoder for community detection with dual optimization.  Choong, Liu, Murata 

33. Learning flat latent manifolds with VAEs. Chen, Klushyn, Ferroni, Bayer, van der Smagt [paper]( https://arxiv.org/pdf/2002.04881.pdf)

34. Learning discrete distributions by dequantization.  Hoogeboom, Cohen, Tomczak [paper](https://arxiv.org/pdf/2001.11235.pdf)

35. Learning discrete and continuous factors of data via alternating disentanglement. Jeong, Song [paper](http://proceedings.mlr.press/v97/jeong19d/jeong19d.pdf https://github.com/snu-mllab/DisentanglementICML19)


36. Electrocardiogram generation and feature extraction using a variational autoencoder. Kuznetsov, Moskalenko, Zolotykh [paper]( https://arxiv.org/pdf/2002.00254.pdf)

37. CosmoVAE: variational autoencoder for CMB image inpainting. Yi, Guo, Fan, Hamann, Wang  [paper](https://arxiv.org/pdf/2001.11651.pdf)

38. Unsupervised representation disentanglement using cross domain features and adversarial learning in variational autoencoder based voice conversion. Huang, Luo, Hwang, Lo, Peng, Tsao, Wang [paper](https://arxiv.org/pdf/2001.07849.pdf)

39. On implicit regularization in beta VAEs.  Kumar, Poole [paper]( https://arxiv.org/pdf/2002.00041.pdf)

40. Weakly-supervised disentanglement without compromises.  Locatello, Poole, Ratsch, Scholkopf, Bachem, Tschannen  [paper](https://arxiv.org/pdf/2002.02886.pdf)


41. An integrated framework based on latent variational autoencoder for providing early warning of at-risk students.  Du, Yang, Hung  [paper](https://ieeexplore.ieee.org/abstract/document/8952699)

42. Variational autoencoder and friends.  Zheng [paper](https://www.cs.cmu.edu/~xunzheng/files/vae_single.pdf)

43. High-fidelity synthesis with disentangled representation. Lee, Kim, Hong, Lee [paper](https://arxiv.org/pdf/2001.04296.pdf)

44. Neurosymbolic knowledge representation for explainable and trustworthy AI.  Malo [paper]( https://www.preprints.org/manuscript/202001.0163/v1)

45. Adversarial disentanglement with grouped observations.  Nemeth  [paper](https://arxiv.org/pdf/2001.04761.pdf)

46. AE-OT-GAN: Training GANs from data specific latent distribution.  An, Guo, Zhang, Qi, Lei, Yau, Gu  [paper](https://arxiv.org/pdf/2001.03698.pdf)

47. AE-OT: a new generative model based on extended semi-discrete optimal transport.  An, Guo, Lei, Luo, Yau, Gu [paper]( https://openreview.net/pdf?id=HkldyTNYwH)

48. Disentanglement by nonlinear ICA with general incompressible-flow networks (GIN). Sorrenson, Rother, Kothe [paper]( https://arxiv.org/pdf/2001.04872.pdf)

49. Phase transitions for the information bottleneck in representation learning.  Wu, Fischer [paper](https://arxiv.org/pdf/2001.01878.pdf)

50. Bayesian deep learning: a model-based interpretable approach.   Matsubara [paper](https://www.jstage.jst.go.jp/article/nolta/11/1/11_16/_article)

51. SPACE: unsupervised object-oriented scene representation via spatial attention and decomposition.   Lin, Wu, Peri, Sun, Singh, Deng, Jiang, Ahn [paper](https://openreview.net/forum?id=rkl03ySYDH)

52. A variational stacked autoencoder with harmony search optimizer for valve train fault diagnosis of diesel engine. Chen, Mao, Zhao, Jiang, Zhang [paper](https://www.mdpi.com/1424-8220/20/1/223)

53. Evaluating loss compression rates of deep generative models.  anon [paper]( https://openreview.net/forum?id=ryga2CNKDH)

54. Progressive learning and disentanglement of hierarchical representations.  anon [paper](https://openreview.net/forum?id=SJxpsxrYPS)

55. Learning group structure and disentangled representations of dynamical environments.  Quessard, Barrett, Clements [paper](https://arxiv.org/abs/2002.06991)

56. A simple framework for contrastive learning of visual representations.  Chen, Kornblith, Norouzi, Hinton [paper]( https://arxiv.org/abs/2002.05709)


57. WiSE-ALE: Wide Sample Estimator for Approximate Latent Embedding. Shuyu Lin, Ronald Clark, Robert Birke, Niki Trigoni, Stephen Roberts [paper](https://arxiv.org/pdf/1902.06160.pdf)

58. Learning to Dress 3D People in Generative Clothing. Qianli Ma, Jinlong Yang, Anurag Ranjan, Sergi Pujades, Gerard Pons-Moll, Siyu Tang, Michael J. Black [paper](https://arxiv.org/pdf/1907.13615.pdf)

59. VV-Net: Voxel VAE Net With Group Convolutions for Point Cloud Segmentation. Hsien-Yu Meng, Lin Gao, Yu-Kun Lai, Dinesh Manocha [paper](http://openaccess.thecvf.com/content_ICCV_2019/papers/Meng_VV-Net_Voxel_VAE_Net_With_Group_Convolutions_for_Point_Cloud_ICCV_2019_paper.pdf)

#### 2019



#### 2018

1. DVAE++: Discrete variational autoencoders wth overlapping transformations.  Vahdat, Macready, Bian,Khoshaman, Andriyash [paper](http://proceedings.mlr.press/v80/vahdat18a/vahdat18a.pdf)


2. FFJORD: free-form continuous dynamics for scalable reversible generative models.  Grathwohl, Chen, Bettencourt, Sutskever, Duvenaud [paper](https://arxiv.org/pdf/1810.01367.pdf)

3. A general method for amortizing variational filtering.  Marino, Cvitkovic, Yue  [paper](https://arxiv.org/pdf/1811.05090.pdf) [code](https://github.com/joelouismarino/amortized-variational-filtering)

4. Handling incomplete heterogeneous data using VAEs.  Nazabal, Olmos, Ghahramani, Valera [paper]( https://arxiv.org/pdf/1807.03653.pdf ) 

5. Sequential attend, infer, repeat: generative modeling of moving objects.  Kosiorek, Kim, Posner, Teh  [paper](https://arxiv.org/pdf/1806.01794.pdf) [code](https://github.com/akosiorek/sqair)  [youtube](https://www.youtube.com/watch?v=-IUNQgSLE0c&feature=youtu.be)

6. Doubly reparameterized gradient estimators for monte carlo objectives.  Tucker, Lawson, Gu, Maddison [paper](https://arxiv.org/pdf/1810.04152.pdf)

7. Interpretable intuitive physics model.  Ye, Wang, Davidson, Gupta [paper](https://arxiv.org/pdf/1808.10002.pdf) [code](https://github.com/tianye95/interpretable-intuitive-physics-model)

8. Normalizing Flows Tutorial, Part 2: Modern Normalizing Flows. Eric Jang [paper](https://blog.evjang.com/2018/01/nf2.html)

9. Neural autoregressive flows.  Huang, Krueger, Lacoste, Courville  [paper](https://medium.com/element-ai-research-lab/neural-autoregressive-flows-f164d6b8e462) [link](https://arxiv.org/pdf/1804.00779.pdf) [code](https://github.com/CW-Huang/NAF)

10. Gaussian process prior variational autoencoders.  Casale, Dalca, Sagletti, Listgarten, Fusi [paper](https://papers.nips.cc/paper/8238-gaussian-process-prior-variational-autoencoders.pdf)

11. ACVAE-VC: non-parallel many-to-many voice conversion with auxiliary classifier variational autoencoder. Kameoka, Kaneko, Tanaka, Hojo [paper](https://arxiv.org/pdf/1808.05092.pdf)

12. Discovering interpretable representations for both deep generative and discriminative models. Adel, Ghahramani, Weller  [paper](http://mlg.eng.cam.ac.uk/adrian/ICML18-Discovering.pdf)

13. Autoregressive quantile networks for generative modelling . Ostrovski, Dabey, Munos  [paper](https://arxiv.org/pdf/1806.05575.pdf)


14. Probabilistic video generation using holistic attribute control.  He, Lehrmann, Marino, Mori, Sigal [paper](https://arxiv.org/pdf/1803.08085.pdf)

15. Bias and generalization in deep generative models: an empirical study.  Zhao, Ren, Yuan, Song, Goodman, Ermon [paper](https://arxiv.org/pdf/1811.03259.pdf)  [link](https://ermongroup.github.io/blog/bias-and-generalization-dgm/) [code](https://github.com/ermongroup/BiasAndGeneralization/tree/master/Evaluate)

16. On variational lower bounds of mutual information.  Poole, Ozair, van den Oord, Alemi, Tucker [paper](http://bayesiandeeplearning.org/2018/papers/136.pdf)

17. GAN - why it is so hard to train generative adversarial networks  . Hui [paper](https://medium.com/@jonathan_hui/gan-why-it-is-so-hard-to-train-generative-advisory-networks-819a86b3750b)

18. Counterfactuals uncover the modular structure of deep generative models.  Besserve, Sun, Scholkopf. [paper](https://arxiv.org/pdf/1812.03253.pdf)

19. Learning independent causal mechanisms. Parascandolo, Kilbertus, Rojas-Carulla, Scholkopf [paper](https://arxiv.org/pdf/1712.00961.pdf)

20. Emergence of invariance and disentanglement in deep representations.  Achille, Soatto [paper](https://arxiv.org/pdf/1706.01350.pdf)

21. Variational memory encoder-decoder. Le, Tran, Nguyen, Venkatesh [paper](https://arxiv.org/pdf/1807.09950.pdf) [code](https://github.com/thaihungle/VMED)

22. Variational autoencoders for collaborative filtering. Liang, Krishnan, Hoffman, Jebara  [paper](https://arxiv.org/pdf/1802.05814.pdf)

23. Invariant representations without adversarial training. Moyer, Gao, Brekelmans, Steeg, Galstyan [paper](http://papers.nips.cc/paper/8122-invariant-representations-without-adversarial-training.pdf) [code](https://github.com/dcmoyer/inv-rep)

24. Density estimation: Variational autoencoders. Rui Shu [paper](http://ruishu.io/2018/03/14/vae/)

25. TherML: The thermodynamics of machine learning. Alemi, Fishcer [paper]( https://arxiv.org/pdf/1807.04162.pdf)

26. Leveraging the exact likelihood of deep latent variable models. Mattei, Frellsen  [paper](https://arxiv.org/pdf/1802.04826.pdf)

27. What is wrong with VAEs?  Kosiorek  [paper](http://akosiorek.github.io/ml/2018/03/14/what_is_wrong_with_vaes.html )

28. Stochastic variational video prediction.  Babaeizadeh, Finn, Erhan, Campbell, Levine  [paper](https://arxiv.org/pdf/1710.11252.pdf)  [code](https://github.com/alexlee-gk/video_prediction)

29. Variational attention for sequence-to-sequence models.  Bahuleyan, Mou, Vechtomova, Poupart [paper](https://arxiv.org/pdf/1712.08207.pdf) [code](https://github.com/variational-attention/tf-var-attention)

30. FactorVAE Disentangling by factorizing. Kim, Minh [paper](https://arxiv.org/pdf/1802.05983.pdf ) 

31. Disentangling factors of variation with cycle-consistent variational autoencoders.  Jha, Anand, Singh, Veeravasarapu  [paper](https://arxiv.org/pdf/1804.10469.pdf ) [code](https://github.com/ananyahjha93/cycle-consistent-vae)

32. Isolating sources of disentanglement in VAEs. Chen, Li, Grosse, Duvenaud  [paper](https://arxiv.org/pdf/1802.04942.pdf)

33. VAE with a VampPrior. Tomczak, Welling  [paper](https://arxiv.org/pdf/1705.07120.pdf  )

34. A Framework for the quantitative evaluation of disentangled representations.  Eastwood, Williams  [paper](https://openreview.net/pdf?id=By-7dz-AZ) [code](https://github.com/cianeastwood/qedr)

35. Recent advances in autoencoder based representation learning. Tschannen, Bachem, Lucic  [paper](https://arxiv.org/pdf/1812.05069.pdf)  

36. InfoVAE: Balancing learning and inference in variational autoencoders.  Zhao, Song, Ermon [paper](https://arxiv.org/pdf/1706.02262.pdf)  

37. Understanding disentangling in Beta-VAE.  Burgess, Higgins, Pal, Matthey, Watters, Desjardins, Lerchner [paper](https://arxiv.org/pdf/1804.03599.pdf)  

38. Hidden Talents of the Variational autoencoder.  Dai, Wang, Aston, Hua, Wipf [paper](https://arxiv.org/pdf/1706.05148.pdf)  

39. Variational Inference of disentangled latent concepts from unlabeled observations.  Kumar, Sattigeri, Balakrishnan  [paper](https://arxiv.org/abs/1711.00848 ) 

40. Self-supervised learning of a facial attribute embedding from video.  Wiles, Koepke, Zisserman  [paper](http://www.robots.ox.ac.uk/~vgg/publications/2018/Wiles18a/wiles18a.pdf )

41. Wasserstein auto-encoders.  Tolstikhin, Bousquet, Gelly, Scholkopf  [paper](https://arxiv.org/pdf/1711.01558.pdf)

42. A two-step disentanglement. method  Hadad, Wolf, Shahar
[paper](http://openaccess.thecvf.com/content_cvpr_2018/papers/Hadad_A_Two-Step_Disentanglement_CVPR_2018_paper.pdf)  [code](https://github.com/naamahadad/A-Two-Step-Disentanglement-Method)

43. Taming VAEs.  Rezende, Viola  [paper](https://arxiv.org/pdf/1810.00597.pdf) [code](https://github.com/denproc/Taming-VAEs)  [code](https://github.com/syncrostone/Taming-VAEs)

44. IntroVAE Introspective variational autoencoders for photographic image synthesis. Huang, Li, He, Sun, Tan [paper](https://arxiv.org/pdf/1807.06358.pdf) [code](https://github.com/dragen1860/IntroVAE-Pytorch)

45. Information constraints on auto-encoding variational bayes. Lopez, Regier, Jordan, Yosef  [paper](https://papers.nips.cc/paper/7850-information-constraints-on-auto-encoding-variational-bayes.pdf) [code](https://github.com/romain-lopez/HCV)

46. Learning disentangled joint continuous and discrete representations.  Dupont  [paper](https://papers.nips.cc/paper/7351-learning-disentangled-joint-continuous-and-discrete-representations.pdf) [code](https://github.com/Schlumberger/joint-vae)

47. Neural discrete representation learning.  van den Oord, Vinyals, Kavukcuoglu  [paper](https://arxiv.org/pdf/1711.00937.pdf) [code](https://github.com/1Konny/VQ-VAE)  [code](https://github.com/ritheshkumar95/pytorch-vqvae)

48. Disentangled sequential autoencoder.  Li, Mandt [paper](https://arxiv.org/abs/1803.02991)  [code](https://github.com/yatindandi/Disentangled-Sequential-Autoencoder)

49. Variational Inference: A review for statisticians.  Blei, Kucukelbir, McAuliffe [paper](https://arxiv.org/pdf/1601.00670.pdf ) 
Advances in Variational Inferece. Zhang, Kjellstrom [paper](https://arxiv.org/pdf/1711.05597.pdf ) 

50. Auto-encoding total correlation explanation.  Goa, Brekelmans, Steeg, Galstyan  [paper](https://arxiv.org/abs/1802.05822)  Closest: [code](https://github.com/gregversteeg/CorEx)

51. Fixing a broken ELBO. Alemi, Poole, Fischer, Dillon, Saurous, Murphy  [paper](https://arxiv.org/pdf/1711.00464.pdf)

52. The information autoencoding family: a lagrangian perspective on latent variable generative models. Zhao, Song, Ermon [paper](https://arxiv.org/pdf/1806.06514.pdf)  [code](https://github.com/ermongroup/lagvae)

53. Debiasing evidence approximations: on importance-weighted autoencoders and jackknife variational inference. Nowozin [paper](https://openreview.net/pdf?id=HyZoi-WRb) [code](https://github.com/microsoft/jackknife-variational-inference)

54. Unsupervised discrete sentence representation learning for interpretable neural dialog generation.  Zhao, Lee, Eskenazi [paper](https://vimeo.com/285802293)  [paper](https://arxiv.org/pdf/1804.08069.pdf)  [code](https://github.com/snakeztc/NeuralDialog-LAED)

55. Dual swap disentangling.  Feng, Wang, Ke, Zeng, Tao, Song [paper](https://papers.nips.cc/paper/7830-dual-swap-disentangling.pdf )

56. Multimodal generative models for scalable weakly-supervised learning. Wu, Goodman [paper](https://papers.nips.cc/paper/7801-multimodal-generative-models-for-scalable-weakly-supervised-learning.pdf)  [code](https://github.com/mhw32/multimodal-vae-public) [code](https://github.com/panpan2/Multimodal-Variational-Autoencoder)

57. Do deep generative models know what they don't know?  Nalisnick, Matsukawa, The, Gorur, Lakshminarayanan  [paper](https://arxiv.org/pdf/1810.09136.pdf  )

58. Glow: generative flow with invertible 1x1 convolutions. Kingma, Dhariwal  [paper](https://arxiv.org/pdf/1807.03039.pdf) [code](https://github.com/openai/glow)  [code](https://github.com/pytorch/glow)

59. Inference suboptimality in variational autoencoders.  Cremer, Li, Duvenaud  [paper](https://arxiv.org/pdf/1801.03558.pdf)  [code](https://github.com/chriscremer/Inference-Suboptimality)

60. Adversarial Variational Bayes: unifying variational autoencoders and generative adversarial networks. Mescheder, Mowozin, Geiger [paper]( https://arxiv.org/pdf/1701.04722.pdf)  [code](https://github.com/LMescheder/AdversarialVariationalBayes)

61. Semi-amortized variational autoencoders.  Kim, Wiseman, Miller, Sontag, Rush  [paper](https://arxiv.org/pdf/1802.02550.pdf)  [code](https://github.com/harvardnlp/sa-vae)

62. Spherical Latent Spaces for stable variational autoencoders.  Xu, Durrett [paper](https://arxiv.org/pdf/1808.10805.pdf)  [code](https://github.com/jiacheng-xu/vmf_vae_nlp)

63. Hyperspherical variational auto-encoders. Davidson, Falorsi, De Cao, Kipf, Tomczak  [paper](https://arxiv.org/pdf/1804.00891.pdf) [code](https://github.com/nicola-decao/s-vae-tf) [code](https://github.com/nicola-decao/s-vae-pytorch)

64. Fader networks: manipulating images by sliding attributes.  Lample, Zeghidour, Usunier, Bordes, Denoyer, Ranzato  [paper](https://arxiv.org/pdf/1706.00409.pdf)  [code](https://github.com/facebookresearch/FaderNetworks)

65. Training VAEs under structured residuals. Dorta, Vicente, Agapito, Campbell, Prince, Simpson  [paper](https://arxiv.org/pdf/1804.01050.pdf ) [code](https://github.com/Garoe/tf_mvg)

66. oi-VAE: output interpretable VAEs for nonlinear group factor analysis.  Ainsworth, Foti, Lee, Fox [paper](https://arxiv.org/pdf/1802.06765.pdf)  [code](https://github.com/samuela/oi-vae)

67. infoCatVAE: representation learning with categorical variational autoencoders.  Lelarge, Pineau [paper](https://arxiv.org/pdf/1806.08240.pdf ) [code](https://github.com/edouardpineau/infoCatVAE)

68. Iterative Amortized inference.  Marino, Yue, Mandt  [paper](https://arxiv.org/pdf/1807.09356.pdf) [paper](https://vimeo.com/287766880)  [code](https://github.com/joelouismarino/iterative_inference)

69. On unifying Deep Generative Models. Hu, Yang, Salakhutdinov, Xing [paper](https://arxiv.org/pdf/1706.00550.pdf ) 

70. Diverse Image-to-image translation via disentangled representations.  Lee, Tseng, Huang, Singh, Yang  [paper](https://arxiv.org/pdf/1808.00948.pdf)  [code](https://github.com/HsinYingLee/DRIT)

71. PIONEER networks: progressively growing generative autoencoder. Heljakka, Solin, Kannala  [paper](https://arxiv.org/pdf/1807.03026.pdf) [code](https://github.com/AaltoVision/pioneer)

72. Towards a definition of disentangled representations. Higgins, Amos, Pfau, Racaniere, Matthey, Rezende, Lerchner  [paper](https://arxiv.org/pdf/1812.02230.pdf ) 

73. Life-long disentangled representation learning with cross-domain latent homologies. Achille, Eccles, Matthey, Burgess, Watters, Lerchner,  Higgins  [paper](file:///Users/matthewvowels/Downloads/Life-Long_Disentangled_Representation_Learning_wit.pdf ) 

74. Learning deep disentangled embeddings with F-statistic loss.  Ridgeway, Mozer [paper](https://arxiv.org/pdf/1802.05312.pdf ) [code](https://github.com/kridgeway/f-statistic-loss-nips-2018)

75. Learning latent subspaces in variational  autoencoders. Klys, Snell, Zemel  [paper](https://arxiv.org/pdf/1812.06190.pdf)

76. On the latent space of Wasserstein auto-encoders. Rubenstein, Scholkopf, Tolstikhin.  [paper](https://arxiv.org/pdf/1802.03761.pdf)  [code](https://github.com/tolstikhin/wae)

77. Learning disentangled representations with Wasserstein auto-encoders. Rubenstein, Scholkopf, Tolstikhin [paper](https://openreview.net/pdf?id=Hy79-UJPM )

78. The mutual autoencoder: controlling information in latent code representations. Phuong, Kushman, Nowozin, Tomioka, Welling  [paper](https://openreview.net/pdf?id=HkbmWqxCZ)   [paper](https://openreview.net/pdf?id=HkbmWqxCZ) [paper](http://2017.ds3-datascience-polytechnique.fr/wp-content/uploads/2017/08/DS3_posterID_048.pdf ) 

79. Auxiliary guided autoregressive variational autoencoders. Lucas, Verkbeek [paper](https://openreview.net/pdf?id=HkGcX--0- ) [code](https://github.com/pclucas14/aux-vae)

80. Interventional robustness of deep latent variable models. Suter, Miladinovic, Bauer, Scholkopf  [paper](https://pdfs.semanticscholar.org/8028/a56d6f9d2179416d86837b447c6310bd371d.pdf?_ga=2.190184363.1450484303.1564569882-397935340.1548854421 )

81. Understanding degeneracies and ambiguities in attribute transfer. Szabo, Hu, Portenier, Zwicker, Facaro [paper](http://openaccess.thecvf.com/content_ECCV_2018/papers/Attila_Szabo_Understanding_Degeneracies_and_ECCV_2018_paper.pdf)
DNA-GAN: learning disentangled representations from multi-attribute images.
Xiao, Hong, Ma  [paper](https://arxiv.org/pdf/1711.05415.pdf  https://github.com/Prinsphield/DNA-GAN)

82. Normalizing flows.  Kosiorek  [paper](http://akosiorek.github.io/ml/2018/04/03/norm_flows.html)  

83. Hamiltonian variational auto-encoder  Caterini, Doucet, Sejdinovic  [paper](https://arxiv.org/pdf/1805.11328.pdf ) 

84. Causal generative neural networks.  Goudet, Kalainathan, Caillou, Guyon, Lopez-Paz, Sebag.  [paper](https://arxiv.org/pdf/1711.08936.pdf ) [code](https://github.com/GoudetOlivier/CGNN)

85. Flow-GAN: Combining maximum likelihood and adversarial learning in generative models. Grover, Dhar, Ermon [paper](https://arxiv.org/pdf/1705.08868.pdf) [code](https://github.com/ermongroup/flow-gan)

86. Linked causal variational autoencoder for inferring paired spillover effects. Rakesh, Guo, Moraffah, Agarwal, Liu [paper](https://arxiv.org/pdf/1808.03333.pdf) [code](https://github.com/rguo12/CIKM18-LCVA)

87. Unsupervised anomaly detection via variational auto-encoder for seasonal KPIs in web applications.  Xu, Chen, Zhao, Li, Bu, Li, Liu, Zhao, Pei, Feng, Chen, Wang, Qiao  [paper](https://arxiv.org/pdf/1802.03903.pdf)

88. Mutual information neural estimation. Belghazi, Baratin, Rajeswar, Ozair, Bengio, Hjelm.  [paper](https://arxiv.org/pdf/1801.04062.pdf) [code](https://github.com/sungyubkim/MINE-Mutual-Information-Neural-Estimation-)  [code](https://github.com/mzgubic/MINE)

89. Explorations in homeomorphic variational auto-encoding. Falorsi, de Haan, Davidson, Cao, Weiler, Forre, Cohen.  [paper](https://arxiv.org/pdf/1807.04689.pdf) [code](https://github.com/pimdh/lie-vae)

90. Hierarchical variational memory network for dialogue generation.  Chen, Ren, Tang, Zhao, Yin  [paper](http://delivery.acm.org/10.1145/3190000/3186077/p1653-chen.pdf?ip=86.162.136.199&id=3186077&acc=OPEN&key=4D4702B0C3E38B35%2E4D4702B0C3E38B35%2E4D4702B0C3E38B35%2E6D218144511F3437&__acm__=1569938843_c07ad21d173fc64a44a22fd6521140cb)

91. World models. Ha, Schmidhuber [paper](https://arxiv.org/pdf/1803.10122.pdf)

#### 2017

1. The concrete distribution: a continuous relaxation of discrete random variables.  Maddison, Mnih, The [paper](https://arxiv.org/pdf/1611.00712.pdf)

2. Categorical reparameterization with Gumbel-Softmax. Jang, Gu, Poole [paper](https://arxiv.org/abs/1611.01144)

3. Opening the black box of deep neural networks via information.  Schwartz-Ziv, Tishby  [paper](https://arxiv.org/pdf/1703.00810.pdf) [youtube]( https://www.youtube.com/watch?v=gOn8Po_NPe4)


4. Discovering causal signals in images  . Lopez-Paz, Nishihara, Chintala, Scholkopf, Bottou   [paper](https://arxiv.org/pdf/1605.08179.pdf)

5. Autoencoding variational inference for topic models.  Srivastava, Sutton  [paper](https://arxiv.org/pdf/1703.01488.pdf)

6. Hidden Markov model variational autoencoder for acoustic unit discovery.  Ebbers, Heymann, Drude, Glarner, Haeb-Umbach, Raj [paper](https://www.isca-speech.org/archive/Interspeech_2017/pdfs/1160.PDF)

7. Application of variational autoencoders for aircraft turbomachinery design.   Zalger  [paper](http://cs229.stanford.edu/proj2017/final-reports/5231979.pdf)

8. Semi-supervised learning with variational autoencoders. Keng  [paper]( http://bjlkeng.github.io/posts/semi-supervised-learning-with-variational-autoencoders/)

9. Causal effect inference with deep latent variable models. Louizos, Shalit, Mooij, Sontag, Zemel, Welling  [paper](https://arxiv.org/pdf/1705.08821.pdf) [code](https://github.com/AMLab-Amsterdam/CEVAE)

10. beta-VAE: learning basic visual concepts with a constrained variational framework.  Higgins, Matthey, Pal, Burgess, Glorot, Botvinick, Mohamed, Lerchner  [paper](https://openreview.net/pdf?id=Sy2fzU9gl )

11. Challenges in disentangling independent factors of variation. Szabo, Hu, Portenier, Facaro, Zwicker [paper](https://arxiv.org/pdf/1711.02245.pdf)  [code](https://github.com/ananyahjha93/challenges-in-disentangling)

12. Composing graphical models with neural networks for structured representations and fast inference.  Johnson, Duvenaud, Wiltschko, Datta, Adams  [paper](https://arxiv.org/pdf/1603.06277.pdf ) 

13. Split-brain autoencoders: unsupervised learning by cross-channel prediction.  Zhang, Isola, Efros [paper](https://arxiv.org/pdf/1611.09842.pdf  )

14. Learning disentangled representations with semi-supervised deep generative models.Siddharth, Paige, van de Meent, Desmaison, Goodman, Kohli, Wood, Torr [paper](https://papers.nips.cc/paper/7174-learning-disentangled-representations-with-semi-supervised-deep-generative-models.pdf) [code](https://github.com/probtorch/probtorch)

15. Learning hierarchical features from generative models.  Zhao, Song, Ermon [paper](https://arxiv.org/pdf/1702.08396.pdf) [code](https://github.com/ermongroup/Variational-Ladder-Autoencoder)

16. Multi-level variational autoencoder: learning disentangled representations from grouped observations. Bouchacourt, Tomioka, Nowozin [paper](https://arxiv.org/pdf/1705.08841.pdf ) 

17. Neural Face editing with intrinsic image disentangling. Shu, Yumer, Hadap, Sankavalli, Shechtman, Samaras [paper](http://openaccess.thecvf.com/content_cvpr_2017/papers/Shu_Neural_Face_Editing_CVPR_2017_paper.pdf)  [code](https://github.com/zhixinshu/NeuralFaceEditing)

18. Variational Lossy Autoencoder.  Chen, Kingma, Salimans, Duan, Dhariwal, Schulman, Sutskever, Abbeel [paper](https://arxiv.org/abs/1611.02731) [code](https://github.com/jiamings/tsong.me/blob/master/_posts/reading/2016-11-08-lossy-vae.md)

19. Unsupervised learning of disentangled and interpretable representations from sequential data. Hsu, Zhang, Glass [paper](https://papers.nips.cc/paper/6784-unsupervised-learning-of-disentangled-and-interpretable-representations-from-sequential-data.pdf) [code](https://github.com/wnhsu/FactorizedHierarchicalVAE) [code](https://github.com/wnhsu/ScalableFHVAE)

20. Factorized variational autoencoder for modeling audience reactions to movies. Deng, Navarathna, Carr, Mandt, Yue, Matthews, Mori  [paper](http://www.yisongyue.com/publications/cvpr2017_fvae.pdf )

21. Learning latent representations for speech generation and transformation. Hsu, Zhang, Glass [paper](https://arxiv.org/pdf/1704.04222.pdf ) [code](https://github.com/wnhsu/SpeechVAE)

22. Unsupervised learning of disentangled representations from video. Denton, Birodkar  [paper](https://papers.nips.cc/paper/7028-unsupervised-learning-of-disentangled-representations-from-video.pdf) [code](https://github.com/ap229997/DRNET)

23. Laplacian pyramid of conditional variational autoencoders.  Dorta, Vicente, Agapito, Campbell, Prince, Simpson  [paper](http://cs.bath.ac.uk/~nc537/papers/cvmp17_LapCVAE.pdf )

24. Neural Photo Editing with Inrospective Adverarial Networks. Brock, Lim, Ritchie, Weston [paper](https://arxiv.org/pdf/1609.07093.pdf)  [code](https://github.com/ajbrock/Neural-Photo-Editor)

25. Discrete Variational Autoencoder. Rolfe [paper](https://arxiv.org/pdf/1609.02200.pdf)  [code](https://github.com/QuadrantAI/dvae)

26. Reinterpreting importance-weighted autoencoders.  Cremer, Morris, Duvenaud  [paper](https://arxiv.org/pdf/1704.02916.pdf) [code](https://github.com/FighterLYL/iwae)

27. Density Estimation using realNVP. Dinh, Sohl-Dickstein, Bengio  [paper](https://arxiv.org/pdf/1605.08803.pdf) [code](https://github.com/taesungp/real-nvp) [code](https://github.com/chrischute/real-nvp)

28. JADE: Joint autoencoders for disentanglement. Banijamali, Karimi, Wong, Ghosi [paper](https://arxiv.org/pdf/1711.09163.pdf ) 
Joint Multimodal learning with deep generative models.  Suzuki, Nakayama, Matsuo [paper]( https://openreview.net/pdf?id=BkL7bONFe) [code](https://github.com/masa-su/jmvae)

29. Towards a deeper understanding of variational autoencoding models.  Zhao, Song, Ermon [paper](https://arxiv.org/pdf/1702.08658.pdf)  [code](https://github.com/ermongroup/Sequential-Variational-Autoencoder)

30. Lagging inference networks and posterior collapse in variational autoencoders.  Dilokthanakul, Mediano, Garnelo, Lee, Salimbeni, Arulkumaran, Shanahan  [paper](https://arxiv.org/pdf/1611.02648.pdf)  [code](https://github.com/Nat-D/GMVAE) [code](https://github.com/psanch21/VAE-GMVAE)

31. On the challenges of learning with inference networks on sparse, high-dimensional data. Krishnan, Liang, Hoffman  [paper](https://arxiv.org/pdf/1710.06085.pdf) [code](https://github.com/rahulk90/vae_sparse)

32. Stick-breaking Variational Autoencoder.   [paper](https://arxiv.org/pdf/1605.06197.pdf )  [code](https://github.com/sporsho/hdp-vae)

33. Deep variational canonical correlation analysis.  Wang, Yan, Lee, Livescu [paper](https://arxiv.org/pdf/1610.03454.pdf) [code](https://github.com/edchengg/VCCA_pytorch)

34. Nonparametric variational auto-encoders for hierarchical representation learning. Goyal, Hu, Liang, Wang, Xing  [paper](https://arxiv.org/pdf/1703.07027.pdf) [code](https://github.com/bobchennan/VAE_NBP/blob/master/report.markdown)

35. PixelSNAIL: An improved autoregressive generative model.  Chen, Mishra, Rohaninejad, Abbeel [paper](https://arxiv.org/pdf/1712.09763.pdf) [code](https://github.com/neocxi/pixelsnail-public)

36. Improved Variational Inference with inverse autoregressive flows. Kingma, Salimans, Jozefowicz, Chen, Sutskever, Welling  [paper](https://arxiv.org/pdf/1606.04934.pdf) [code](https://github.com/kefirski/bdir_vae)

36. It takes (only) two: adversarial generator-encoder networks.  Ulyanov, Vedaldi, Lempitsky [paper](https://arxiv.org/pdf/1704.02304.pdf) [code](https://github.com/DmitryUlyanov/AGE)

38. Symmetric Variational Autoencoder and connections to adversarial learning.  Chen, Dai, Pu, Li, Su, Carin  [paper](https://arxiv.org/pdf/1709.01846.pdf)  

39. Reconstruction-based disentanglement for pose-invariant face recognition. Peng, Yu, Sohn, Metaxas, Chandraker [paper](https://arxiv.org/pdf/1702.03041.pdf) [code](https://github.com/zhangjunh/DR-GAN-by-pytorch)

40. Is maximum likelihood useful for representation learning? Huszár  [paper](https://www.inference.vc/maximum-likelihood-for-representation-learning-2/ ) 

41. Disentangled representation learning GAN for pose-invariant face recognition. Tran, Yin, Liu  [paper](http://zpascal.net/cvpr2017/Tran_Disentangled_Representation_Learning_CVPR_2017_paper.pdf) [code](https://github.com/kayamin/DR-GAN)

42. Improved Variational Autoencoders for text modeling using dilated convolutions. Yang, Hu, Salakhutdinov, Berg-kirkpatrick [paper](https://arxiv.org/pdf/1702.08139.pdf  )

43. Improving variational auto-encoders using householder flow. Tomczak, Welling [paper]( https://arxiv.org/pdf/1611.09630.pdf) [code](https://github.com/jmtomczak/vae_householder_flow)

44. Sticking the landing: simple, lower-variance gradient estimators for variational inference. Roeder, Wu, Duvenaud. [paper](http://proceedings.mlr.press/v97/kingma19a/kingma19a.pdf)  [code](https://github.com/geoffroeder/iwae)

45. VEEGAN: Reducing mode collapse in GANs using implicit variational learning. Srivastava, Valkov, Russell, Gutmann. [paper](https://arxiv.org/pdf/1705.07761.pdf)  [code](https://github.com/akashgit/VEEGAN)

46. Discovering discrete latent topics with neural variational inference. Miao, Grefenstette, Blunsom [paper](https://arxiv.org/pdf/1706.00359.pdf)

47. Variational approaches for auto-encoding generative adversarial networks.   Rosca, Lakshminarayana, Warde-Farley, Mohamed [paper](https://arxiv.org/pdf/1706.04987.pdf)

48. Variational Autoencoder and extensions. Courville [paper](https://ift6266h17.files.wordpress.com/2017/03/vae1.pdf)

49. A neural representation of sketch drawings. Ha, Eck [paper](https://arxiv.org/pdf/1704.03477.pdf)

## 2016

1. Attend, infer, repeat: fast scene understanding with generative models. Eslami, Heess, Weber, Tassa, Szepesvari, Kavukcuoglu, Hinton  [paper](https://arxiv.org/pdf/1603.08575.pdf)  [paper](http://akosiorek.github.io/ml/2017/09/03/implementing-air.html)  [code](https://github.com/aleju/papers/blob/master/neural-nets/Attend_Infer_Repeat.md)

2. Deep feature consistent variational autoencoder.  Hou, Shen, Sun, Qiu [paper](https://arxiv.org/pdf/1610.00291.pdf) [code](https://github.com/sbavon/Deep-Feature-Consistent-Variational-AutoEncoder-in-Tensorflow)

3. Neural variational inference for text processing.   Miao, Yu, Grefenstette,  Blunsom. [paper](https://arxiv.org/pdf/1511.06038.pdf)

4. Domain-adversarial training of neural networks. Ganin, Ustinova, Ajakan, Germain, Larochelle, Laviolette, Marchand, Lempitsky [paper](https://arxiv.org/pdf/1505.07818.pdf)

5. Tutorial on Variational Autoencoders. Doersch [paper](https://arxiv.org/pdf/1606.05908.pdf)

6. How to train deep variational autoencoders and probabilistic ladder networks. Sonderby, Raiko, Maaloe, Sonderby, Winther  [paper](https://orbit.dtu.dk/files/121765928/1602.02282.pdf )

7. ELBO surgery: yet another way to carve up the variational evidence lower bound. Hoffman, Johnson  [paper](http://approximateinference.org/accepted/HoffmanJohnson2016.pdf )

8. Variational inference with normalizing flows. Rezende, Mohamed  [paper](https://arxiv.org/pdf/1505.05770.pdf)

9. The Variational Fair Autoencoder. Louizos, Swersky, Li, Welling, Zemel  [paper](https://arxiv.org/pdf/1511.00830.pdf)   [code](https://github.com/dendisuhubdy/vfae)

10. Information dropout: learning optimal representations through noisy computations. Achille, Soatto [paper](https://arxiv.org/pdf/1611.01353.pdf)  

11. Domain separation networks. Bousmalis, Trigeorgis, Silberman, Krishnan, Erhan [paper](https://arxiv.org/pdf/1608.06019.pdf) [code](https://github.com/fungtion/DSN)  [code](https://github.com/farnazj/Domain-Separation-Networks)

12. Disentangling factors of variation in deep representations using adversarial training.  Mathieu, Zhao, Sprechmann, Ramesh, LeCunn [paper](https://arxiv.org/pdf/1611.03383.pdf)  [code](https://github.com/ananyahjha93/disentangling-factors-of-variation-using-adversarial-training)

13. Variational autoencoder for semi-supervised text classification.  Xu, Sun, Deng, Tan  [paper](https://arxiv.org/pdf/1603.02514.pdf) [code](https://github.com/wead-hsu/ssvae) related: [code](https://github.com/isohrab/semi-supervised-text-classification)

14. Learning what and where to draw.  Reed, Sohn, Zhang, Lee  [paper](https://arxiv.org/pdf/1610.02454.pdf  )

15. Attribute2Image: Conditional image generation from visual attributes. Yan, Yang, Sohn, Lee  [paper](https://arxiv.org/pdf/1512.00570.pdf ) 

16. Variational inference with normalizing flows. Rezende, Mohamed  [paper](https://arxiv.org/pdf/1505.05770.pdf)  [code](https://github.com/ex4sperans/variational-inference-with-normalizing-flows)

17. Wild Variational Approximations.  Li, Liu [paper](http://approximateinference.org/2016/accepted/LiLiu2016.pdf )

18. Importance Weighted Autoencoders. Burda,  Grosse, Salakhutdinov [paper](https://arxiv.org/pdf/1509.00519.pdf) [code](https://github.com/yburda/iwae) [code](https://github.com/xqding/Importance_Weighted_Autoencoders) [code](https://github.com/abdulfatir/IWAE-tensorflow)

19. Stacked What-Where Auto-encoders. Zhao, Mathieu, Goroshin, LeCunn [paper](https://arxiv.org/pdf/1506.02351.pdf)  [code](https://github.com/yselivonchyk/Tensorflow_WhatWhereAutoencoder)

20. Disentangling nonlinear perceptual embeddings with multi-query triplet networks.  Veit, Belongie, Karaletsos  [paper](https://www.researchgate.net/profile/Andreas_Veit/publication/301837223_Disentangling_Nonlinear_Perceptual_Embeddings_With_Multi-Query_Triplet_Networks/links/57e2997308ae040ae3c2f3a3/Disentangling-Nonlinear-Perceptual-Embeddings-With-Multi-Query-Triplet-Networks.pdf ) 

21. Ladder Variational Autoencoders.  Sonderby, Raiko, Maaloe, Sonderby, Winther  [paper](https://arxiv.org/pdf/1602.02282.pdf)  
Variational autoencoder for deep learning of images, labels and captions. Pu, Gan Henao, Yuan, Li, Stevens, Carin [paper](https://papers.nips.cc/paper/6528-variational-autoencoder-for-deep-learning-of-images-labels-and-captions.pdf )

22. Approximate inference for deep latent Gaussian mixtures.  Nalisnick, Hertel, Smyth  [paper](https://pdfs.semanticscholar.org/f6fe/5e8e25994c188ba6a124462e2cc55f2c5a67.pdf)  [code](https://github.com/enalisnick/mixture_density_VAEs)

23. Auxiliary Deep Generative Models. Maaloe, Sonderby, Sonderby, Winther [paper](https://arxiv.org/pdf/1602.05473.pdf)  [code](https://github.com/larsmaaloee/auxiliary-deep-generative-models)

24. Variational methods for conditional multimodal deep learning. Pandey, Dukkipati [paper](https://arxiv.org/pdf/1603.01801.pdf ) 

25. PixelVAE: a latent variable model for natural images. Gulrajani, Kumar, Ahmed, Taiga, Visin, Vazquez, Courville [paper](https://arxiv.org/pdf/1611.05013.pdf)  [code](https://github.com/igul222/PixelVAE)  [code](https://github.com/kundan2510/pixelVAE)

26. Adversarial autoencoders. Makhzani, Shlens, Jaitly, Goodfellow, Frey  [paper](https://arxiv.org/pdf/1511.05644.pdf)  [code](https://github.com/conan7882/adversarial-autoencoders)

27. A hierarchical latent variable encoder-decoder model for generating dialogues.  Serban, Sordoni, Lowe, Charlin, Pineau, Courville, Bengio [paper](http://www.cs.toronto.edu/~lcharlin/papers/vhred_aaai17.pdf )

28. Infinite variational autoencoder for semi-supervised learning.  Abbasnejad, Dick  [paper](https://arxiv.org/pdf/1611.07800.pdf)  

29. f-GAN: Training generative neural samplers using variational divergence minimization. Nowozin, Cseke  [paper](https://arxiv.org/pdf/1606.00709.pdf) [code](https://github.com/LynnHo/f-GAN-Tensorflow)

30. DISCO Nets: DISsimilarity Coefficient networks  Bouchacourt, Kumar, Nowozin [paper](https://arxiv.org/pdf/1606.02556.pdf)  [code](https://github.com/oval-group/DISCONets)

31. Information dropout: learning optimal representations through noisy computations. Achille, Soatto [paper](https://arxiv.org/pdf/1611.01353.pdf)

32. Weakly-supervised disentangling with recurrent transformations for 3D view synthesis. Yang, Reed, Yang, Lee [paper](https://arxiv.org/pdf/1601.00706.pdf)  [code](https://github.com/jimeiyang/deepRotator)

33. Autoencoding beyond pixels using a learned similarity metric. Boesen, Larsen, Sonderby, Larochelle, Winther [paper](https://arxiv.org/pdf/1512.09300.pdf)  [code](https://github.com/andersbll/autoencoding_beyond_pixels)

34. Generating images with perceptual similarity metrics based on deep networks Dosovitskiy, Brox.  [paper](https://arxiv.org/pdf/1602.02644.pdf) [code](https://github.com/shijx12/DeepSim)

35. A note on the evaluation of generative models.  Theis, van den Oord, Bethge.  [paper](https://arxiv.org/pdf/1511.01844.pdf)

36. InfoGAN: interpretable representation learning by information maximizing generative adversarial nets. Chen, Duan, Houthooft, Schulman, Sutskever, Abbeel  [paper](https://arxiv.org/pdf/1606.03657.pdf) [code](https://github.com/openai/InfoGAN)

37. Disentangled representations in neural models.  Whitney [paper](https://arxiv.org/abs/1602.02383)

38. A recurrent latent variable model for sequential data.  Chung, Kastner, Dinh, Goel, Courville, Bengio [paper](https://arxiv.org/pdf/1506.02216.pdf)

39. Unsupervised learning of 3D structure from images.  Rezende, Eslami, Mohamed, Battaglia, Jaderberg, Heess [paper](https://arxiv.org/pdf/1607.00662.pdf)

40. A survey of inductive biases for factorial representation-learning. Ridgeway  [paper](https://arxiv.org/pdf/1612.05299.pdf)


## 2015
1. Deep learning and the information bottleneck principle  Tishby, Zaslavsky [paper](https://arxiv.org/pdf/1503.02406.pdf)

2. Training generative neural networks via Maximum Mean Discrepancy optimization.  Dziugaite, Roy, Ghahramani  [paper](https://arxiv.org/pdf/1505.03906.pdf)


3. NICE: non-linear independent components estimation. Dinh, Krueger, Bengio [paper](https://arxiv.org/pdf/1410.8516.pdf )

4. Deep convolutional inverse graphics network.  Kulkarni, Whitney, Kohli, Tenenbaum [paper](https://arxiv.org/pdf/1503.03167.pdf)  [code](https://github.com/yselivonchyk/TensorFlow_DCIGN)

5. Learning structured output representation using deep conditional generative models. Sohn, Yan, Lee  [paper](https://papers.nips.cc/paper/5775-learning-structured-output-representation-using-deep-conditional-generative-models.pdf)  [code](https://github.com/wsjeon/ConditionalVariationalAutoencoder)

6. Latent variable model with diversity-inducing mutual angular regularization.  Xie, Deng, Xing [paper](https://arxiv.org/pdf/1512.07336.pdf)

7. DRAW: a recurrent neural network for image generation.  Gregor, Danihelka, Graves, Rezende, Wierstra. [paper](https://arxiv.org/pdf/1502.04623.pdf)  [code](https://github.com/ericjang/draw)

8. Variational Inference II. Xing, Zheng, Hu, Deng [paper](https://www.cs.cmu.edu/~epxing/Class/10708-15/notes/10708_scribe_lecture13.pdf ) 

## 2014

1. Auto-encoding variational Bayes.  Kingma, Welling [paper](https://arxiv.org/pdf/1312.6114.pdf)

2. Learning to disentangle factors of variation with manifold interaction. Reed, Sohn, Zhang, Lee  [paper](http://proceedings.mlr.press/v32/reed14.pdf )

3. Semi-supervised learning with deep generative models. Kingma, Rezende, Mohamed, Welling [paper](https://papers.nips.cc/paper/5352-semi-supervised-learning-with-deep-generative-models.pdf)  [code](https://github.com/saemundsson/semisupervised_vae) [code](https://github.com/Response777/Semi-supervised-VAE)

4. Stochastic backpropagation and approximate inference in deep generative models. Rezende, Mohamed, Wierstra  [paper](https://arxiv.org/pdf/1401.4082.pdf) [code](https://github.com/ashwindcruz/dgm/tree/master/adgm_mnist)

5. Representation learning: a review and new perspectives. Bengio, Courville, Vincent  [paper](https://arxiv.org/pdf/1206.5538.pdf)

## 2011
1. Transforming Auto-encoders. Hinton, Krizhevsky, Wang  [paper](https://www.cs.toronto.edu/~hinton/absps/transauto6.pdf) 


## 2008

1. Graphical models, exponential families, and variational inference.  Wainwright, Jordan et al

## 2004

1. Variational learning and bits-back coding: an information-theoretic view to Bayesian learning.  Honkela, Valpola  [paper](https://www.cs.helsinki.fi/u/ahonkela/papers/infview.pdf)  

## 2000

1. The information bottleneck method.  Tishby, Pereira, Bialek [paper](https://arxiv.org/pdf/physics/0004057.pdf)
